package com.csc.library.databean;

import com.csc.library.session.DbInquiry;
import com.csc.library.session.InitialInquiry;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.MyTreeMap;

/*
 * class Ѻ͡§ҹ ʶԵԨӹǹ¢ͧѡҹ
 */
public class Latesummary extends Memployee {
	
	MyTreeMap hm_value = new MyTreeMap(); 
	CscCalendar csStart = new CscCalendar();
	CscCalendar csEnd = new CscCalendar();
	
	DbInquiry inqTime = null;
	DbInquiry inqHistory = null;
	
	public void postInqNext() {		
		if (this.foundData) {
			super.postInqNext();	
			this.initialColumn();
			this.setCalendar();
			this.initialEmpWorkingTime();
			System.out.println(this.hm_value);		
		}		
	}
	
	/*
	 * ˹§ҹ ӹǹ 12 ͹
	 */
	private void initialColumn() {
		for (int i=1; i<=12; i++) {
			this.hm_value.put("col"+i, new Integer(0));;		
			this.hm_value.put("month"+i, "");;		
		}
	}
	
	/*
	 * ӡá˹ӹǹ͹ͧ͡§ҹ
	 * ·ӡúǡӹǹ͹ѺҨҡ˹Ҩա 11 ͹
	 *  12 ͹
	 */
	private void setCalendar() {
		MyLog.debug(this, "START MONTH==="+this.param.get("MONTH_START"));
		MyLog.debug(this, "START YEAR==="+this.param.get("YEAR_START"));		
		MyLog.debug(this, "END MONTH==="+this.param.get("MONTH_END"));
		MyLog.debug(this, "END YEAR==="+this.param.get("YEAR_END"));			
		 
		this.csStart = new CscCalendar((String)this.param.get("YEAR_START")+"-"
			+(String)this.param.get("MONTH_START")+"-01");
		CscCalendar cs = new CscCalendar((String)this.param.get("YEAR_END")+"-"
				+(String)this.param.get("MONTH_END")+"-01");
		this.csEnd = new CscCalendar((String)this.param.get("YEAR_END")+"-"
				+(String)this.param.get("MONTH_END")+"-"+cs.getEndDateOfMonth());
		
		CscCalendar c1 = new CscCalendar(csStart.getDDMMYYYY());
		CscCalendar c2 = new CscCalendar(csEnd.getDDMMYYYY());
		int loop = 1;
		int i = 1 ;
		CscCalendar tmp = null;
		while (c1.beforeDate(c2)) {
			if (loop==1) {
				tmp = new CscCalendar(c1.getDDMMYYYY());
				this.hm_value.put((c1.getMM()+":"+c1.getYear()), "header"+i);
				if (this.userPro.get("lang").equalsIgnoreCase("tha")) {
					this.hm_value.put("month"+i, c1.getThaiLongMonth()+" "+c1.getYear());
				} else this.hm_value.put("month"+i, c1.getEngLongMonth()+" "+c1.getYear());
				i++;
			}
			
			//System.out.println("tmp : "+tmp.getMonth()+" : "+tmp.getYear());
			//System.out.println("c1 : "+c1.getMonth()+" : "+c1.getYear());
			
			if (tmp.getMonth()!=c1.getMonth() || tmp.getYear()!=c1.getYear()) {
				this.hm_value.put((c1.getMM()+":"+c1.getYear()), "header"+i);
				i++;
				if (this.userPro.get("lang").equalsIgnoreCase("tha")) {
					this.hm_value.put("month"+i, c1.getThaiLongMonth()+" "+c1.getYear());
				} else this.hm_value.put("month"+i, c1.getEngLongMonth()+" "+c1.getYear());
			}
			c1.incMonth(1);
			loop++;
		}
	}
	
	/*
	 * ӡúǡӹǹ边ѡҹ
	 * ӹǹ 12 ͹˹ҧ 
	 * Ҩҡ 	ttime_current1 = 㹧ǴѨغѹ
	 * 					ttime_history1 = 㹻ѵԡ÷ӧҹ 
	 */
	private void initialEmpWorkingTime() {
		try {				
			String filter="employeeid='"+this.getString("employeeid")+"' and " +
					"(dateid between '"+this.csStart.getYYYYMMDD()+"' and '"+this.csEnd.getYYYYMMDD()+"') " +
					"and lt>0";
			//ǴѨغѹ
			if (this.inqTime == null) {
				this.inqTime = new InitialInquiry(this.userPro).getDbInquiry();
				this.inqTime.setParam(this.param);
				this.inqTime.setSchemaName(this.userPro.getSchemaName());
				this.inqTime.initMyTable("Ttime_current1", "", "employeeid, dateid");
				this.inqTime.setColumn("*");
			}
			this.inqTime.setFilter(filter);
			this.inqTime.refresh();
			while (this.inqTime.next()) {
				System.out.println("DATE : "+this.inqTime.getCurrentDbRecord().getString("dateid"));
				CscCalendar cs = new CscCalendar(this.inqTime.getString("dateid"));
				if (this.hm_value.containsKey(cs.getMM()+":"+cs.getYear())) {
					String header = (String) this.hm_value.get(cs.getMM()+":"+cs.getYear());
					String id = header.substring(6, header.length());
					int value = ((Integer) this.hm_value.get("col"+id)).intValue() + 1;
					this.hm_value.put("col"+id, Integer.valueOf(value));
				}
			}
			
			//㹻ѵԡá÷ӧҹ
			if (this.inqHistory == null) {
				this.inqHistory = new InitialInquiry(this.userPro).getDbInquiry();
				this.inqHistory.setParam(this.param);
				this.inqHistory.setSchemaName(this.userPro.getSchemaName());
				this.inqHistory.initMyTable("Ttime_history1", "", "employeeid, dateid");
				this.inqHistory.setColumn("*");
			}
			this.inqHistory.setFilter(filter);
			this.inqHistory.refresh();
			while (this.inqHistory.next()) {
				System.out.println("DATE HISTORY : "+this.inqHistory.getCurrentDbRecord().getString("dateid"));
				CscCalendar cs = new CscCalendar(this.inqHistory.getString("dateid"));
				if (this.hm_value.containsKey(cs.getMM()+":"+cs.getYear())) {
					String header = (String) this.hm_value.get(cs.getMM()+":"+cs.getYear());
					String id = header.substring(6, header.length());
					int value = ((Integer) this.hm_value.get("col"+id)).intValue() + 1;
					this.hm_value.put("col"+id, Integer.valueOf(value));
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}		
	}
}
