package com.csc.library.databean;

import com.csc.library.utilities.MyLog;
import java.text.DecimalFormat;
import java.util.HashMap;
import java.util.Iterator;

import com.csc.library.database.FieldManager;
import com.csc.library.database.MyHashMap;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.timeattendance.DayShift;
import com.csc.library.timeattendance.Shift;
import com.csc.library.timeattendance.WorkingShift;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyTreeMap;

/*
 * class 㹡èѴ šèѺШ͹
 * NOT USE 2008/09/17
 */
public class Memployee_reserve extends Memployee {
	
	MyTreeMap hmField;
	String column="";
	
	public int search() {
		int find = super.search();
		this.hmField = new MyTreeMap();
		if (find == 1) {
			this.setSwipeRecord();			
		}
		//this.param.put("hmField", this.hmField);
		//this.userPro.put("hmField", this.hmField);
		MyLog.debug(this, " ==== RESULT ==== ");
		MyLog.debug(this, this.hmField.toString());
		return find;
	}
	
	/*
	 * ӡҧ field ͹
	 */
	private FieldManager initalField(String fmName) {
		FieldManager fm = this.initField("String", fmName, 20, 0, "String");
		fm.setWorking(true);
		fm.setDefault("");
		fm.setName(fmName);
		fm.setComType("text");
		fm.setWidth(10);
		fm.set("");
		return fm;
	}
	
	public void setSwipeRecord() {		
		int month = Integer.parseInt((String)this.param.get("__month"));
		int year = Integer.parseInt((String)this.param.get("__year"));
		CscCalendar cs1 = new CscCalendar("01-"+month+"-"+year);
		CscCalendar cs2 = new CscCalendar(cs1.getEndDateOfMonth()+"-"+month+"-"+year);
		
		//CscCalendar cs1 = new CscCalendar("20-11-2006");		
		//CscCalendar cs2 = new CscCalendar("25-11-2006");
		
		MyLog.debug(this, "employeeid======="+this.getString("employeeid"));
		MyLog.debug(this, "startdate======="+this.getString("startdate"));
		MyLog.debug(this, "resigndate======="+this.getString("resigndate"));
		try {
			DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
			inq.setSchemaName(this.userPro.getSchemaName());
			inq.initMyTable("Mtime0", "", "");
			inq.setColumn("*");
			this.putChild(inq);
			this.refreshChild("Mtime0");
			if (this.getChild("mtime0")!=null) {
				Mtime0 timeRec = (Mtime0) (((DbInquiry) this.getChild("mtime0")).getCurrentDbRecord());
				timeRec.setEmpRec((DbRecord) this);
				
				WorkingShift ws = timeRec.genWorkingShift(new CscCalendar(cs1	.getTimestamp()), new CscCalendar(cs2.getTimestamp()));
				MyLog.debug(this, "Working Shift of :> "+this.getString("employeeid"));				
				ws.setUProfile(this.userPro);
				ws.setEmployeeid(this.getString("employeeid"));
				ws.adjust();
				
				ws.createLink();	
				ws.genTimeZone();
				MyLog.debug(this, "<<< ADJUST >>>");
				MyLog.debug(this, ws.getUprofile(), ws.toString());
				
				DecimalFormat df = new DecimalFormat("00.00");
				Iterator it_ws = ws.keySet().iterator();
				while (it_ws.hasNext()) {
					DayShift ds = (DayShift) ws.get(it_ws.next());
					Iterator it_ds = ds.keySet().iterator();
					while (it_ds.hasNext()) {
						Shift sh = (Shift) ds.get(it_ds.next());
						MyLog.debug(this, this.getUProfile(), sh.toString()); 
						
						//2006-08-0108.0001T00
						//2006-08-0117.0001T01			
						
						String inCode = sh.getShiftDate().getYYYYMMDD()+"-"+sh.get_c_dt_in().getYYYYMMDD()+
							df.format(Double.parseDouble(String.valueOf(sh.get_c_dt_in().getCSCTime())))+
							sh.getTimeCode()+
							sh.getTR_Type().substring(0,1)+
							"00";
						
						String inCodeInq = sh.getShiftDate().getYYYYMMDD()+
							df.format(Double.parseDouble(String.valueOf(sh.get_c_dt_in().getCSCTime())))+
							sh.getTimeCode()+
							sh.getTR_Type().substring(0,1)+
							"00";
						
						String outCode = sh.getShiftDate().getYYYYMMDD()+"-"+sh.get_c_dt_out().getYYYYMMDD()+
							df.format(Double.parseDouble(String.valueOf(sh.get_c_dt_out().getCSCTime())))+
							sh.getTimeCode()+
							sh.getTR_Type().substring(0,1)+
							"01";
						
						String outCodeInq = sh.getShiftDate().getYYYYMMDD()+
							df.format(Double.parseDouble(String.valueOf(sh.get_c_dt_out().getCSCTime())))+
							sh.getTimeCode()+
							sh.getTR_Type().substring(0,1)+
							"01";
												
						DbInquiry inqSwipe = new InitialInquiry(this.userPro).getDbInquiry();
						inqSwipe.setSchemaName(this.userPro.getSchemaName());
						inqSwipe.initMyTable("Ttimetemp", "", "");
						inqSwipe.setColumn("*");
						
						String filter = "employeeid='"+this.getString("employeeid")+"' and (reservecode='"+inCodeInq+"')";
						DbInquiry inqReserve = new InitialInquiry(this.userPro).getDbInquiry();
						inqReserve.setSchemaName(this.userPro.getSchemaName());
						inqReserve.initMyTable("Ttimereserve", filter, "");
						inqReserve.setColumn("*");
						inqReserve.putChild(inqSwipe);
						inqReserve.refresh();
						if (inqReserve.next()) {
							DbRecord rec = inqReserve.getCurrentDbRecord();
							MyLog.debug(this, rec.getString("reservecode")+" : "+rec.getString("ttimetemp"));
							FieldManager fm = this.initalField(rec.getString("reservecode"));
							fm.set(rec.getString("ttimetemp"));
							fm.setProperty("initvalue", rec.getString("ttimetemp"));
							this.hmField.put(inCode, fm);
                            FieldManager fm2 = this.initalField(rec.getString("ttimetemp"));
                            fm2.set(rec.getChild("Ttimetemp").getString("swipedate")+"|"+rec.getChild("Ttimetemp").getString("swipetime"));
                            fm2.setProperty("initvalue", rec.getChild("Ttimetemp").getString("swipedate")+"|"+rec.getChild("Ttimetemp").getString("swipetime"));
                            this.hmField.put(rec.getString("ttimetemp"), fm2);
						} else {
							FieldManager fm = this.initalField(inCode);							
							this.hmField.put(inCode, fm);
						}
						
						filter = "employeeid='"+this.getString("employeeid")+"' and (reservecode='"+outCodeInq+"')";						
						inqReserve.setFilter(filter);
						inqReserve.refresh();
						if (inqReserve.next()) {
							DbRecord rec = inqReserve.getCurrentDbRecord();
							MyLog.debug(this, rec.getString("reservecode")+" : "+rec.getString("ttimetemp"));
							FieldManager fm = this.initalField(rec.getString("reservecode"));
							fm.set(rec.getString("ttimetemp"));
							fm.setProperty("initvalue", rec.getString("ttimetemp"));
							this.hmField.put(outCode, fm);
                            FieldManager fm2 = this.initalField(rec.getString("ttimetemp"));
                            fm2.set(rec.getChild("Ttimetemp").getString("swipedate")+"|"+rec.getChild("Ttimetemp").getString("swipetime"));
                            fm2.setProperty("initvalue", rec.getChild("Ttimetemp").getString("swipedate")+"|"+rec.getChild("Ttimetemp").getString("swipetime"));
                            this.hmField.put(rec.getString("ttimetemp"), fm2);
						} else {
							FieldManager fm = this.initalField(outCode);							
							this.hmField.put(outCode, fm);
						}
					}
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}
		MyLog.debug(this, "######## HM : "+this.hmField.keySet());
		MyLog.debug(this, "######## HM : "+this.hmField);
	}
	
	protected boolean preUpdateTrigger() {
		boolean b = super.preUpdateTrigger();
		try {
			//this.hmField = (MyTreeMap) this.userPro.get((Object) "hmField");
			MyLog.debug("+++++++++ MEMPLOYYEE_RESERVE PREUPDATE PARAM +++++++++++");
			MyLog.debug(this.param.toString());
			this.column = this.getFieldList();
			//this.setColumn("employeeid,companyid");
			DbRecord rec = new InitialRecord(this.userPro).getDbRecord("Ttimereserve");
						
			Iterator it = this.hmField.keySet().iterator();
			while (it.hasNext()) {
				String key = (String) it.next();
				try {
					if (key.length()>15) {
						FieldManager fm = (FieldManager) this.hmField.get(key);
						if (!fm.getProperty("initvalue").equals(this.getParam("__"+key.toLowerCase()))) { 
							rec.set("employeeid", this.getString("employeeid"));
							rec.set("companyid", this.getString("companyid"));
							rec.set("reservecode", key.substring(11, key.length()));
		                    MyLog.debug(this, key);
							if (this.getParam("__"+key.substring(11, key.length()).toLowerCase())!=null && !this.getParam("__"+key.substring(11, key.length()).toLowerCase()).trim().equals("")) { 
								rec.set("ttimetemp", this.getParam("__"+key.substring(11, key.length()).toLowerCase()));
								rec.save();
							} else if (this.getParam("__"+key.toLowerCase())!=null && !this.getParam("__"+key.toLowerCase()).trim().equals("")) {
								rec.set("ttimetemp", this.getParam("__"+key.toLowerCase()).trim());
								rec.save();
							}else  { 
								rec.set("ttimetemp", fm.getProperty("initvalue"));
								rec.delete();
							}
						}
					}
				} catch (Exception e) {
					e.printStackTrace();
				}
			}			
		} catch (Exception ex) {
			MyLog.error(this, ex);
  }
		return b;
	}
	
	public FieldManager getField(String fieldName) {
		FieldManager fm;
		if (this.hmField!=null && this.hmField.containsKey(fieldName)) {
			fm = (FieldManager) this.hmField.get(fieldName);
		} else fm = super.getField(fieldName);
		return fm;
	}
	
	public MyTreeMap getHashData() {
		return this.hmField;
	}
	
	protected void postUpdateTrigger() throws Exception {
		super.postUpdateTrigger();
		//this.setColumn(this.column);
	}
}
