package com.csc.library.databean;

import java.text.DecimalFormat;

import com.csc.library.database.MyHashMap;

public class Memployee_working_summarize_liteon extends Memployee_working_summarize {
	
	private DecimalFormat dfH = new DecimalFormat("0");
	
	public String getString(String fieldName) {
		if (fieldName.indexOf("$") > -1) {
			return this.getStringChild(fieldName);
		} else {
			return super.getString(fieldName);
		}
	}
	
	private String getStringChild(String fieldName) {
		String result = "";
		if (fieldName.indexOf("$") >= 0) {
			String tName = fieldName.substring(0, fieldName.indexOf("$"));
			String fName = fieldName.substring(fieldName.indexOf("$") + 1, fieldName.length());
			if (this.hmHeader.containsKey(fName)) {			
				return this.getResult(this.hmHeader.getString(fName));
			} else if (fName.indexOf("col")>-1 && this.hmHeader.containsKey(fName.substring(0, fName.indexOf("_")))) {
				MyHashMap hm = (MyHashMap) this.hmHeader.get(fName.substring(0, fName.indexOf("_")));
				return this.getResult(hm.getString(fName));
			} else super.getString(fieldName);
		}
		return super.getString(fieldName);
	}
	
	private String getResult(String value) {
		if (value.indexOf(":")>-1) {
			double result = 0;
			String[] x = value.split(":");
			double tmp0 = Double.parseDouble(x[0]);
			double tmp1 = Double.parseDouble(x[1]);
			if (this.hourwork>0 && tmp1>0 && tmp1/this.hourwork<=0.5) {
				result = tmp0+0.5;
			} else if (this.hourwork>0 && tmp1>0 && tmp1/this.hourwork>0.5) {
				result = tmp0+1;
			} else result = tmp0;
			return dfH.format(result*this.hourwork);
		} else {
			if (value==null || value.equals("null") || value.equals("")) {
				return "0";
			} else return value;
		}
	}
}
