package com.csc.library.databean;

import com.csc.library.utilities.MyLog;
import java.rmi.RemoteException;

import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.RecordCmp;
/**
 * @author paecsc
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class Tcardtemp_borrow extends RecordCmp implements DbRecord {
	public Tcardtemp_borrow() {
		super("Tcardtemp_borrow","Tcardtemp_borrow Table");					
	}
    
    /**
     * ѺõǨͺաҹ ^^? 
     * աҹ borrow_status դ 1 ҹդ 0
     * 
     */
    protected boolean preInsertTrigger() throws Exception{
        boolean result = super.preInsertTrigger();
        if (chkCardtemp(this.getString("cardtempid")) && chkDupEmp(this.getString("employeeid"))){
            DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
            inq.setSchemaName(this.userPro.getSchemaName());
            inq.initMyTable("Tcardtemp_borrow","borrow_status='1'","borrowid");
            inq.setColumn("cardtempid,employeeid,borrow_date,return_date,borrow_status,borrowid");
            inq.refresh();
            while(inq.next()){
                DbRecord rec = inq.getCurrentDbRecord();
                if(this.getString("cardtempid").equalsIgnoreCase(rec.getString("cardtempid"))) return false;
            }
        }else return false;
        return result;
    }
    
    /**
     * ҺѵêǶ١¡ԡҹ ҹ card_status=1 ¡ԡҹ 2
     * @param cardtempid
     * @return boolean
     */
    private boolean chkCardtemp(String cardtempid){
        DbInquiry inqCard = new InitialInquiry(this.userPro).getDbInquiry();
        try {
            inqCard.initMyTable("Mcardtemp","cardtempid='"+cardtempid+"' and card_status='1'","");
            inqCard.setColumn("*");
            inqCard.refresh();
            if (inqCard.recCount()>0){
                return true;
            }else return false;
        } catch (RemoteException e) {
        	MyLog.error(this, e);
        	return false;
        }
    }
    
    /**
     *  Employee աѵêǤա
     * ·ѧ׹ѵêǤѹѨغѹ
     * @param employeeid
     * @return boolean
     */
    private boolean chkDupEmp(String employeeid){
        DbInquiry inqEmp = new InitialInquiry(this.userPro).getDbInquiry();
        try {
            inqEmp.setSchemaName(this.userPro.getSchemaName());
            inqEmp.initMyTable("Tcardtemp_borrow","borrow_status='1' and employeeid='"+employeeid+"'","borrowid");
            inqEmp.setColumn("cardtempid,employeeid,borrow_date,return_date,borrow_status,borrowid");
            inqEmp.refresh();
            if (inqEmp.recCount()>0){
                return false;
            }else return true;
        } catch (RemoteException e) {
        	MyLog.error(this, e);
            return false;
        }
    }

}