package com.csc.library.databean;

import com.csc.library.utilities.MyLog;
import com.csc.library.session.RecordCmp;
import com.csc.library.timeattendance.TimeZone;
import com.csc.library.timeinterface.DocAdjust;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyTreeMap;

public class Tchshift1 extends RecordCmp  {

	public Tchshift1() {
		super("Tchshift1", "Tchshift1 Table");
	}
	
	public MyTreeMap getDocAllTimeZone(){
		MyTreeMap hm = new MyTreeMap();
		CscCalendar begDate = new CscCalendar(this.getString("start_date"));
		CscCalendar endDate = new CscCalendar(this.getString("end_date"));
		while (begDate.beforeEquals(endDate)) {	
			CscCalendar cs1 = new CscCalendar(begDate.getYYYYMMDD());
			CscCalendar cs2 = new CscCalendar(begDate.getYYYYMMDD());
			try {
				cs1.setCSCTime(0.00f);
				cs2.setCSCTime(23.59f);
			} catch (Exception e) {
				MyLog.error(this, e);

				
			}
			TimeZone tz = new TimeZone();
			tz.setBeginZone(new CscCalendar(cs1.getTimestamp()));
			tz.setEndZone(new CscCalendar(cs2.getTimestamp()));
			hm.put(begDate.getYYYYMMDD(), tz);
			begDate.incDate();			
		}
		return hm;
	}

}