package com.csc.library.databean;

import com.csc.library.utilities.MyLog;
import java.rmi.RemoteException;
import java.text.DecimalFormat;

import com.csc.library.database.FieldManager;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;

/*
 * ʴš÷ͷ ͡ѧ˹Ҩ, §ҹ * 
 */
public class Ttime_current1_ot extends Ttime_current1 {
	
	String ot_in = "";
	String ot_out = "";
	DecimalFormat df = new DecimalFormat("00.00");
	
	public void postInqNext(){
		this.ot_in="";
		this.ot_out = "";
		if (this.getDouble("ap_ot")>0) {
			try {
				DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
				inq.initMyTable("Tadjtime0", "doctype='"+this.getString("doctype")+"' and docid='"+this.getString("docno")+"'"+
						" and dt_bg='"+this.getString("dateid")+"' and employeeid='"+this.getString("employeeid")+"' and updtype='O'", "");
				inq.setColumn("*");
				inq.refresh();
				while (inq.next()) {
					DbRecord rec = inq.getCurrentDbRecord();
					this.ot_in = df.format(rec.getDouble("tm_bg"));
					this.ot_out = df.format(rec.getDouble("tm_en"));
				}
			} catch (RemoteException e) {
				MyLog.error(this, e);
			}
		}
    }
	
	public FieldManager getField(String fieldName) {        
        FieldManager fm = super.getField(fieldName);
        if (fieldName.equalsIgnoreCase("ot_in")) { //ͷա͹ҧҹ
        	fm = this.initField("String", "OT_IN", 10, 2, "OT Time In");            
            fm.setWorking(true);
            fm.set(this.ot_in);
        } else if (fieldName.equalsIgnoreCase("ot_out")) { //ͷѧҧҹ
        	fm = this.initField("String", "OT_OUT", 10, 2, "OT Time out");            
            fm.setWorking(true);
            fm.set(this.ot_out);
        }
        return fm;
    }	

}
