package com.csc.library.databean;

import com.csc.library.utilities.MyLog;
import java.util.StringTokenizer;

import com.csc.library.database.FieldManager;
import com.csc.library.database.MyHashMap;
import com.csc.library.formula.FormulaString;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.RecordCmp;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscTime;

public class Ttime_current_decimal extends Ttime_current {
	
	FieldManager fmTmp = null;
	FormulaString fs = new FormulaString();
	
	public Ttime_current_decimal() {
		super();
	}
	
	/*
	 * Overide For getField LT, LV, ABSENT, OT, OT1, OT5, OT2, OT3, HOUR_D
	 * 繰ҹ 100 к繰ҹ 60
	 * ¨ Class FormulaString 㹡ŧ繰ҹ 100
	 */
	public FieldManager getField(String fieldName) {		
		FieldManager fm = super.getField(fieldName);		
		if (fieldName.equalsIgnoreCase("LT_DECIMAL")) {
			this.fmTmp = super.getField("LT");			
			fm = this.initField("Double", "LT_DECIMAL", 10, 2, "Late");
			fm.setWorking(true);
			fm.setUProfile(this.userPro);
			fm.setProperty(fmTmp.getProperty());
			fm.set(fs.Tm_To_Dec(fmTmp.getDouble()));
		} else if  (fieldName.equalsIgnoreCase("LV_DECIMAL")) {
			this.fmTmp = super.getField("LV");			
			fm = this.initField("Double", "LV_DECIMAL", 10, 2, "Leave");
			fm.setWorking(true);
			fm.setUProfile(this.userPro);
			fm.setProperty(fmTmp.getProperty());
			fm.set(fs.Tm_To_Dec(fmTmp.getDouble()));
		} else if  (fieldName.equalsIgnoreCase("ABSENT_DECIMAL")) {
			this.fmTmp = super.getField("ABSENT");			
			fm = this.initField("Double", "ABSENT_DECIMAL", 10, 2, "Absent");
			fm.setWorking(true);
			fm.setUProfile(this.userPro);
			fm.setProperty(fmTmp.getProperty());
			fm.set(fs.Tm_To_Dec(fmTmp.getDouble()));
		} else if  (fieldName.equalsIgnoreCase("OT_DECIMAL")) {
			this.fmTmp = super.getField("OT");			
			fm = this.initField("Double", "OT_DECIMAL", 10, 2, "OT");
			fm.setWorking(true);
			fm.setUProfile(this.userPro);
			fm.setProperty(fmTmp.getProperty());
			fm.set(fs.Tm_To_Dec(fmTmp.getDouble()));	
		} else if  (fieldName.equalsIgnoreCase("OT1_DECIMAL")) {
			this.fmTmp = super.getField("OT1");			
			fm = this.initField("Double", "OT1_DECIMAL", 10, 2, "OT1");
			fm.setWorking(true);
			fm.setUProfile(this.userPro);
			fm.setProperty(fmTmp.getProperty());
			fm.set(fs.Tm_To_Dec(fmTmp.getDouble()));	
		} else if  (fieldName.equalsIgnoreCase("OT5_DECIMAL")) {
			this.fmTmp = super.getField("OT5");			
			fm = this.initField("Double", "OT5_DECIMAL", 10, 2, "OT5");
			fm.setWorking(true);
			fm.setUProfile(this.userPro);
			fm.setProperty(fmTmp.getProperty());
			fm.set(fs.Tm_To_Dec(fmTmp.getDouble()));	
		} else if  (fieldName.equalsIgnoreCase("OT2_DECIMAL")) {
			this.fmTmp = super.getField("OT2");			
			fm = this.initField("Double", "OT2_DECIMAL", 10, 2, "OT2");
			fm.setWorking(true);
			fm.setUProfile(this.userPro);
			fm.setProperty(fmTmp.getProperty());
			fm.set(fs.Tm_To_Dec(fmTmp.getDouble()));	
		} else if  (fieldName.equalsIgnoreCase("OT3_DECIMAL")) {
			this.fmTmp = super.getField("OT3");			
			fm = this.initField("Double", "OT3_DECIMAL", 10, 2, "OT3");
			fm.setWorking(true);
			fm.setUProfile(this.userPro);
			fm.setProperty(fmTmp.getProperty());
			fm.set(fs.Tm_To_Dec(fmTmp.getDouble()));	
		} else if  (fieldName.equalsIgnoreCase("HOUR_D_DECIMAL")) {
			this.fmTmp = super.getField("HOUR_D");			
			fm = this.initField("Double", "HOUR_D_DECIMAL", 10, 2, "Hour_D");
			fm.setWorking(true);
			fm.setUProfile(this.userPro);
			fm.setProperty(fmTmp.getProperty());
			fm.set(fs.Tm_To_Dec(fmTmp.getDouble()));	
		} else fm = super.getField(fieldName);
		return fm;
	}
	
}