package com.csc.library.databean;

import com.csc.library.utilities.MyLog;
import java.text.DecimalFormat;
import java.util.StringTokenizer;
import java.util.Vector;

import com.csc.library.database.FieldAutoNumber;
import com.csc.library.database.FieldManager;
import com.csc.library.database.StaticConfig;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.RecordCmp;
import com.csc.library.timeattendance.AutoGenChangeShift;
import com.csc.library.timeattendance.CreateChangeShift;
import com.csc.library.timeinterface.SwipeRecord;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.StrReplace;

/*
 * 红šŧҢͧѡҹ
 * öҡ 3 ҧ
 * 1. ҡô֧Ũҡͧٴѵ txt file
 * 2. ҡá͡ҹ˹Ҩ HR
 * 3. ҡâ͹ѵԼҹ Workflow µǾѡҹ
 */
public class Ttimetemp extends RecordCmp implements SwipeRecord  {

	private long record=0;
	
	public Ttimetemp() {
        super("Ttimetemp","Ttimetemp Table");
    }
	
	public Ttimetemp(String table, String desc) {
        super(table, desc);
    }
	
    /*
     * ֧ѹ-Ңͧٴѵ
     */ 
    public CscCalendar getDate(){
    	CscCalendar cs = new CscCalendar(this.getCscCalendar("swipedate").getTimeInMillis());
    	try {
			cs.setCSCTime(this.getFloat("swipetime"));
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
        return cs;
    }

    public float getTime(){
        return this.getFloat("swipetime");
    }

    public Vector getReserveCode() {   	
    	Vector result = new Vector();    	
    	/*DbInquiry inqChild = new InitialInquiry(this.userPro).getDbInquiry("Ttimereserve");
		this.putChild(inqChild);
		this.refreshChild("Ttimereserve");  	
    	DbInquiry inq = (DbInquiry) this.getChild("Ttimereserve"); 
    	try {
			do {
				result.add(inq.getString("runno"));
			} while (inq.next());
		} catch (Exception e) {
			MyLog.error(this, e);			
		} ----> NOT USED THIS TABLE */ 
    	return result;
    }
    
    /*
     *  record ͧٴѵù١ͧѧ
     */
    public boolean isReserved() {
    	boolean result = true;
    	if (this.getReserveCode().size()==0) result = false;
    	return result;
    }
    
    public String getSwipeType() {  // IN OR OUT 
    	return this.getString("swipetype");
    }
       
    /*
     * Ңͧšŧ
     * ٷ SYSTEMCODE ===> SWIPE_SOURCE
     */
    public String getSource() { // T-TimeRecorder, A-Auto, M-Manual, S-SignOn, O-SignOff
    	//0=myHR System, 1=Machine
    	return this.getString("source");
	}
    
    /*
     * Ţͧٴѵ
     */
    public String getMachineName() {
    	return this.getString("machinno");
    }
    
    public String getJobCode() {
    	return this.getString("jobcode");
    }
    
    public String getTimeCode() { 
    	return this.getString("time0id");
    }
    
    public long getRecordNo() {  
    	return this.getLong("runno");
    }
    
    public String getStringRecordNo() {  
    	return this.getString("runno");
    }

    public String toString() {    	
    	return  this.getStringRecordNo()+"\t : "+this.getDate().getDDMMYYYYHHMMSS()+"\n";
    }
   
    private void setEmployeeDetail(){
		try {
			DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();
			inq.setParam(this.param);
			inq.setSchemaName(this.userPro.getSchemaName());
			inq.initMyTable("Memployee", " employeeid='"+this.getString("employeeid")+"'", "");
			inq.setColumn("employeeid, runno, branch, job, bossid, bu1, bu2, bu3, bu4, bu5, " +
					"costcenter, salatype, workarea,  time0, emp_position, emp_group, companyid");	 
			inq.refresh();
			while (inq.next()) {
				this.set("time0id",inq.getString("time0"));
				this.set("costcenter",inq.getString("costcenter"));				
				this.set("bu1",inq.getString("bu1"));
				this.set("bu2",inq.getString("bu2"));
				this.set("bu3",inq.getString("bu3"));
				this.set("bu4",inq.getString("bu4"));
				this.set("bu5",inq.getString("bu5"));
				this.set("jobcode",inq.getString("job"));
				this.set("emp_group",inq.getString("emp_group"));
				this.set("emp_position",inq.getString("emp_position"));
				this.set("branch",inq.getString("branch"));
				this.set("bossid",inq.getString("bossid"));
				this.set("salatype",inq.getString("salatype"));
				if (!this.getString("workarea").equals("")) {
					this.set("workarea",inq.getString("workarea"));		
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}		
	}
      
	
    /*
     * ¢šŧѵԡŧҨҡ
     * TTIMETEMP ===> TTIMETEMP_HISTORY
     */
    public void moveTimeHistory() {
		try {			
			DbRecord rec = this.cloneRecord(true);
			
			DbRecord recHis = new InitialRecord(this.userPro).getDbRecord("Ttimetemp_history");
			recHis.setColumn("*");
			recHis.setData(this);
			recHis.save();			
			
			rec.delete();
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
	}
    
    public FieldManager getField(String fieldName) {
		FieldManager fm = super.getField(fieldName);
		if (fieldName.equalsIgnoreCase("swipetime_format")) {
			//㹡 return ͡ FORMAT HHMMSS
			fm = this.initField("String", "swipetime_format", 8, 0, "swipetime_format");
			fm.setWorking(true);
			fm.setUProfile(this.userPro);
			double value = this.getDouble("swipetime"); 			
			DecimalFormat df = new DecimalFormat("00.00");
			String t = df.format(value);
			StrReplace str = new StrReplace();
			fm.set(str.replace(t,".","")+"00");
		} else if (fieldName.equalsIgnoreCase("runno")) {
			if (((String)this.userPro.get("lang")).equalsIgnoreCase("tha")) {
				fm.setDescription("ŧ");
			} else fm.setDescription("Swipe Record");
		}
		return fm;
	}
    
    @Override
    protected void postInsertTrigger() throws Exception {
    	super.postInsertTrigger();
    	
    	//this.AutoGenShift(this.getString("runno"));
    }
    
    protected void postUpdateTrigger() throws Exception{
    	super.postUpdateTrigger();
    	
    	//this.AutoGenShift(this.pRemote.getString("runno"));
    }
    
    public void AutoGenShift(String runno){
    	/* 㹡óշ˹кҧẺѵѵ ʶҹТͧ AUTO_GEN_SHIFT == 1 (֧Ҩҡ MConfig) ͧἹ÷ӧҹҧ ԧѺٴѵ ͧҧ¹ */
    	if(this.getString("swipetype").equals("0") && !isFromPermitPage()){ /* ੾Тٴѵٴҹ (swipetype = 0) еͧҨҡ˹Ҩ TAU177, TAU177_HR */
    		System.out.print("!!! swipetype is 0 !!!!");
    		if(isValidRunno(runno)){
	    		CreateChangeShift genShift = new CreateChangeShift(this);
		        genShift.setFixDoc(runno);
		        genShift.createChangeShift();
    		}
    	}else{
    		System.out.print("!!! swipetype is not 0 ,process changeshift will not be activate !!!!");
    	}
    }
    
    /* Ҩҡ˹Ҩͺѹ֡ҷӧҹ (ѧҹ) Ẻкػٴѵ  ͡ */
    private boolean isFromPermitPage(){
    	try{
    		if(this.getParam().containsKey("__screen") && (this.getParam().get("__screen").equals("TAU177") || this.getParam().get("__screen").equals("TAU177_HR"))){
    			MyLog.error("!! Data input from TAU177 or TAU177_HR can not be created change shift auto !!");
    			return true ;
    		}
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}
    	return false ;
    }
    
    protected boolean preInsertTrigger() throws Exception {
    	return super.preInsertTrigger();
    }
    
    protected boolean preUpdateTrigger() throws Exception {
    	return super.preUpdateTrigger();
    }
    
    private boolean isValidRunno(String runno){
    	try {
        	if(runno.equals("0")){
        		MyLog.error(" !! Error insert ttimetemp with runno is 0 !! [" + this.getString("employeeid") 
        				+ ":" + this.getString("swipedate") + ":" + this.getString("swipetime") + "]");
        		return false ;
        	}
    	}catch(Exception e){
    		MyLog.error(this,e);
    		return false ;
    	}
    	return true ;
    }
}   