package com.csc.library.databean;
/**
 * Class TTimeTemp_nstda_outdoor 
 * Ѻ Ƿ. ҹ 繡 import šâһԺѵԧҹ͡ʶҹ繡˭  (ҡ 10 )
 * ´֧Ũҡ Txtfile ٻẺô֧Ũ礨ҡ TIMETEMP_NSTDA_OUTDOOR.xml
 * еͧѹ֡šٴѵû  -->ٴ  ش-->ٴ͡
 * ҡաѹ кѹ֡Ţͧءѹŧ Table TTimeTemp
 * աҧ Table Tabsent_nstda  ءѹ
 * Auth. Kom
 * Modi. 26-05-2010
 */

import java.text.DecimalFormat;
import java.util.Vector;

import com.csc.library.database.FieldManager;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.StrReplace;

public class Ttimetemp_nstda_outdoor extends Ttimetemp {

	private String swipeStartDate 	= null;
	private String swipeEndDate 	= null;
	private String swipeStartTime	= null;
	private String swipeEndTime		= null;
	private String remark			= null;
	
	private Vector vtTimeTemp 		= null;
	
	public boolean set (String field, String data){
		/**
		 * 红ŷ֧ҡ text file  
		 * ¶ field ǢͧѺ Table TTimeTemp ͵ͧ价ҧ˹ҧ㴡͹ҹ
		 * 㹵âͧ Class ᷹ (Virtual field)
		 *  ѹ鹡, ѹش, 鹡, ش  ˵
		 */
		boolean result = false ;
		try {
			result = super.set(field, data);
			if (field.equalsIgnoreCase("SWIPESTDATE")) { 
				this.swipeStartDate = this.convTextToDate(data); 
				return true;
				
			} else if (field.equalsIgnoreCase("SWIPEENDATE")){
				this.swipeEndDate = this.convTextToDate(data); 
				return true;
			} else if (field.equalsIgnoreCase("SWIPESTTIME")){
				this.swipeStartTime = data;
				return true;
			} else if (field.equalsIgnoreCase("SWIPEENTIME")){
				this.swipeEndTime = data;
				return true;
			} else if (field.equalsIgnoreCase("REMARK")){
				this.remark = data;
				return true;
			}
		} catch (Exception e){
			MyLog.error(">>>>> Error : TTimetemp_nstda_out.set >>>>");
		}
		return result;
	}
	
	/** ¹ٻẺŨҡ 10012010  10-01-2010 **/
	protected String convTextToDate(String text){
		StringBuffer bf = new StringBuffer();
		bf.append(text.substring(0,2)).append("-");
		bf.append(text.substring(2,4)).append("-");
		bf.append(text.substring(4,8));
		
		return bf.toString(); 
	}
	
	protected void setSwipeTimeToTimeTemp(){
		/** 
		 *  ҧŷ     RH047,01-01-2010,03-01-2010,17.00,1.00,L14,memo
		 *  зӡ૿ŷѧ
		 *  rec No.   employeeid::swipedate::swipetime::source::swipetype   
		 *  rec1#       RH047    01-01-2010     8.00      L14      I
		 *  rec2#       RH047    01-01-2010    17.00      L14      O
		 *  rec3#       RH047    02-01-2010     8.00      L14      I
		 *  rec4#       RH047    02-01-2010    17.00      L14      O
		 *  rec5#       RH047    03-01-2010     8.00      L14      I
		 *  rec6#       RH047    03-01-2010    17.00      L14      O
		 */
		
		CscCalendar calStartDate ; /** ˹âͧѹ鹡 **/
		CscCalendar calEndDate ; /** ˹âͧѹش **/
		try {
			calStartDate = new CscCalendar(this.swipeStartDate);
			calEndDate = new CscCalendar(this.swipeEndDate);
			while ( calStartDate.beforeEquals(calEndDate) ) { /** ǹٻѹ ҡѹش  **/
				saveTimeTemp(calStartDate, calEndDate, "I", this.swipeStartTime); /** ૿ٴѵâ ¹ 繢ٴ **/
				saveTimeTemp(calStartDate, calEndDate, "O", this.swipeEndTime); /** ૿ٴѵâ͡ ¹ش 繢ٴ͡ **/
				saveTabsent(calStartDate, this.swipeStartTime, this.swipeEndTime); /** ӡúѹ֡ѹ   Table Tabsent_nstda **/
				
				calStartDate.incDate();  /** Ңͧ calStartDate ж١  ҨҡѺѹش 繡ǹٻͺѹ֡Ũúͺѹ **/
			}
			
		} catch (Exception e){
			MyLog.error(">>>>>> Error : TTimetemp_nstda.setSwipeTimeToTimeTemp() >>>>>> "); 
		}
	}
	
	/**
	 * ѹ֡ŧ Table TTimeTemp ٴ  ٴ͡ (ͧշͧäʹ ٴٴ͡)
	 */
	protected void saveTimeTemp(CscCalendar strDate,CscCalendar endDate,String swipeType,String swTime){
		try {
			DbRecord db = new InitialRecord(this.userPro).getDbRecord("Ttimetemp");
			db.setColumn("*");
			db.set("companyid", "100"); 	/** fix code : 100 **/
			db.set("employeeid", this.getString("employeeid")); 
			db.set("swipedate", strDate); /** ˹ѹ **/
			db.set("swipetime", swTime);  /** ˹ҡٴѵ **/
			db.set("swipeType", swipeType);  /** ˹ٴѵ (IN or OUT) **/
			db.set("source", "L"); /** fix  L Ҩҡ import **/
			db.set("machinno", "IMPFL"); /** fix code : IMPFL -> Import File **/
			db.save(); 
			
		} catch(Exception e){
			MyLog.error(">>>>>>> Error : TTimetemp_nstda_outdoor.saveTimeTemp >>>>> ");
		}
	}
	
	/**
	 *  ѹ֡һԺѵԧҹ͡ʶҹ Table Tabsent_nstda ѹ
	 */
	protected void saveTabsent(CscCalendar strDate,String swipeIn,String swipeOut){
		try {
			DbRecord dbTabsent = new InitialRecord(this.userPro).getDbRecord("Tabsent_nstda");
			dbTabsent.setColumn("*");
			dbTabsent.set("absentid", "0"); /** ҧŢ͡һԺѵԧҹ͡ʶҹ **/
			dbTabsent.set("companyid", "100");
			dbTabsent.set("emp_request", this.getString("employeeid"));
			dbTabsent.set("employeeid", this.getString("employeeid"));
			dbTabsent.set("type_absent", this.getString("source")); /**  "L14"  Ҩҡ import **/
			dbTabsent.set("start_date", strDate); 
			dbTabsent.set("end_date", strDate); /** ѹ شѹǡѹ Ҩҡ import **/
			dbTabsent.set("start_time", swipeIn); 
			dbTabsent.set("end_time", swipeOut); 
			dbTabsent.set("remark", this.remark); 
			dbTabsent.set("leave_day", 1); /**  1  繡ҧ ѹѹ **/
			dbTabsent.set("request_date", this.swipeStartDate); /** ѹ鹡 **/
			
			dbTabsent.save();				
		} catch(Exception e){
			MyLog.error(">>>>>>> Error : TTimetemp_nstda_outdoor.saveTabsent >>>>> ");
		}
	}
	
	/**
	 * ҧŢͧ͡ҹ͡ʶҹ ٻẺ鹵鹴 IMPFL еѹ  "IMPFL-01012010"
	 * Ҩͧ  absentid  Auto number.
	 */
	protected String getAbsentId(CscCalendar strDate){
		StringBuffer sb = new StringBuffer("IMPFL-").append(strDate.getDDMMYYYY());
		return sb.toString();
	}
	
	public int save(){ /** override method save **/
    	this.setSwipeTimeToTimeTemp(); /** ֧¡Ŵ зӡ ǹٻ૿ **/
		return 1;
	}
	
}
