package com.csc.library.dwr;


import java.rmi.RemoteException;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.HashMap;

import com.csc.entity.SQLExceptionManager;
import com.csc.library.database.CscConnection;
import com.csc.library.database.DataSet;
import com.csc.library.database.StaticProperties;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.InitialInquiry;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.ReadFile;
import com.csc.library.upload.FileUploadUtils;  

public class Createshiftlist_dwr extends DWR_base{
	private int error = 0;
//	private String tableName = "EMP_CREATE_SHIFT_TEMP";
	private String tableName = "MTIME2_TEMP_IMPORT";
	private HashMap<String,String> hm_shift = new HashMap();
	private HashMap<String,String> hm_time0id = new HashMap();
	public String createlist(String path, String filename) {
		this.setUProfile();
		CscCalendar csctime = new CscCalendar();	
		String Listid = String.valueOf(csctime.getTimeInMillis());		
		String fullpath = path+""+filename;
		ReadFile rf = new ReadFile(fullpath);
		String empline="";
		String headerline="";
		String list ;
		CscCalendar listd = new CscCalendar();
		CscCalendar now = new CscCalendar();
		CscCalendar limit_before = new CscCalendar();
		String[] mm;
		String[] corum;
		//String Import="";
		ArrayList<String> Import = new ArrayList<String>();
		ArrayList<String> beford = new ArrayList<String>();
		try{
			if(rf.hasMoreData()){
				list = rf.readLine();
				mm = list.split(",");
				listd.setCalendar("01-"+mm[0]+"-"+mm[1]); // ͹- ҡ÷Ѵá ҵ駵
			}
			if(rf.hasMoreData()){
				headerline = rf.readLine(); // ҹ header  áѺѹ
			}
			while(rf.hasMoreData()){
				empline =rf.readLine();
				corum = empline.split(",");	
				if(!corum[0].equals("")||!corum[0].equals(null)){
					for(int i=1;i<corum.length;i++){ // ҹšТͧѡҹ÷Ѵ 3 
						try{
							if(i<=listd.getDayInMonth()){
								if(!corum[i].equals("") && this.chkStickTm(corum[i])){
									listd.setDate(i);
									if(listd.afterEqualsDate(limit_before)){
										StringBuffer sql = new StringBuffer();
										sql.append("insert into EMP_CREATE_SHIFT_TEMP(COMPANYID,LISTID,EMPLOYEEID,DATE,TIME0ID,CREATE_DATE,CREATE_TIME,EDIT_TIME,CREATE_BY) ");
										sql.append("select companyid,'"+Listid+"',EMPLOYEEID,'"+listd.getDDMMYYYY()+"','"+corum[i]+"','"+now.getDDMMYYYY()+"','"+now.getHHMMSS()+"','"+now.getHHMMSS()+"','"+this.up.get("employeeid")+"' from memployee ");
										sql.append("where employeeid='"+corum[0]+"' ");
										System.out.println(">>>> createlist Sql >>>> "+sql.toString());
										boolean chkInsert = excuteSql(sql.toString());
										Import.add(String.valueOf(chkInsert));
									}else{
										beford.add("false");
									}
								}
							}
						}catch(Exception e){
							MyLog.error(">>>>>>>>>employee null<<<<<<<<<<<");
						}
					}
				}
			}	
		}catch(Exception e){
			e.printStackTrace();
			MyLog.error(">>>>>>>>> ImportUnsuccess<<<<<<<<<<<");
			return "ImportUnsuccess";
		}
		if(Import.indexOf("true")>-1)
			return Listid;
		else if(beford.indexOf("false")>-1)
			return "Can't Change";
		else
			return "ImportUnsuccess";
	}
	
	public String createlistNoCondition(String path, String filename) {
		this.setUProfile();
		CscCalendar csctime = new CscCalendar();	
		String Listid = String.valueOf(csctime.getTimeInMillis());		
		String fullpath = path+""+filename;
		ReadFile rf = new ReadFile(fullpath);
		String empline="";
		String headerline="";
		String list ;
		CscCalendar listd = new CscCalendar();
		CscCalendar now = new CscCalendar();
		String[] mm;
		String[] corum;
		//String Import="";
		ArrayList<String> Import = new ArrayList<String>();
		ArrayList<String> beford = new ArrayList<String>();
		try{
			if(rf.hasMoreData()){
				list = rf.readLine();
				mm = list.split(",");
				listd.setCalendar("01-"+mm[0]+"-"+mm[1]); // ͹- ҡ÷Ѵá ҵ駵
			}
			if(rf.hasMoreData()){
				headerline = rf.readLine(); // ҹ header  áѺѹ
			}
			while(rf.hasMoreData()){
				empline =rf.readLine();
				corum = empline.split(",");	
				if(!corum[0].equals("")||!corum[0].equals(null)){
					for(int i=1;i<corum.length;i++){ // ҹšТͧѡҹ÷Ѵ 3 
						try{
							if(i<=listd.getDayInMonth()){
							//	if(!corum[i].equals("") && this.chkStickTm(corum[i])){
								if(!corum[i].equals("")){
									listd.setDate(i);
									if(true){
										StringBuffer sql = new StringBuffer();
										sql.append("insert into EMP_CREATE_SHIFT_TEMP(COMPANYID,LISTID,EMPLOYEEID,DATE,TIME0ID,CREATE_DATE,CREATE_TIME,EDIT_TIME,CREATE_BY) ");
										sql.append("select companyid,'"+Listid+"',EMPLOYEEID,'"+listd.getDDMMYYYY()+"','"+corum[i]+"','"+now.getDDMMYYYY()+"','"+now.getHHMMSS()+"','"+now.getHHMMSS()+"','"+this.up.get("employeeid")+"' from memployee ");
										sql.append("where employeeid='"+corum[0]+"' ");
										System.out.println(">>>> createlist Sql >>>> "+sql.toString());
										boolean chkInsert = excuteSql(sql.toString());
										Import.add(String.valueOf(chkInsert));
									}else{
										beford.add("false");
									}
								}
							}
						}catch(Exception e){
							MyLog.error(">>>>>>>>>employee null<<<<<<<<<<<");
						}
					}
				}
			}	
		}catch(Exception e){
			e.printStackTrace();
			MyLog.error(">>>>>>>>> ImportUnsuccess<<<<<<<<<<<");
			return "ImportUnsuccess";
		}
		if(Import.indexOf("true")>-1)
			return Listid;
		else if(beford.indexOf("false")>-1)
			return "Can't Change";
		else
			return "ImportUnsuccess";
	}
	
	private boolean chkStickTm(String time0id){
		String data = "";
		try{
			String sql= "select sticktm from mtime0 where time0id = '"+time0id+"'" ;
			DataSet ds = new DataSet(sql,this.up.get("dbname"),"mtime0");
			ds.setFetchAll(false);
			ds.initConnection(this.up);
			while(ds.next()){
				data = ds.getString("sticktm");
			}	
		}catch(Exception e){
			MyLog.error(this, this.up, this.tableName + e.toString());
		}
		if(data.equals("N")){
			return false;
		}else{
			return true;
		}
	} 

	private boolean excuteSql(String sql){
		boolean result = false;
		CscConnection connection = null;
		Statement statement = null;
		try {
			if(sql.trim().toLowerCase().startsWith("delete ")){
				if(sql.toLowerCase().indexOf(" where ")==-1){
					MyLog.error(this, this.up, this.tableName +" if used delete command ,please set where condition");
					return false;
				}
			}
			connection = (CscConnection) StaticProperties.myConnection.getConnection(this.up.get("dbname"),this.up); 
			connection.setClassName(">DataSet.excuteUpdate");
			statement = connection.createStatement(java.sql.ResultSet.TYPE_FORWARD_ONLY, java.sql.ResultSet.CONCUR_UPDATABLE);			
			int i = statement.executeUpdate(sql);
			if( i > 0 ){
				result = true;
			}else{
				result = false;
			}
		} catch(SQLException s){
			SQLExceptionManager sqlEx = new SQLExceptionManager();
			try {
				sqlEx.checkProplem(this.up, connection, this.tableName, s, sql);
			} catch (RemoteException e1) {
				MyLog.error(this , this.up , e1);
			} catch (SQLException e2) {
				MyLog.error(this , this.up , e2);
			}
			this.error++;
			MyLog.error("");
			if(this.error < 2){
				return this.excuteSql(sql);
			}else{
				return false;
			}
		} catch (Exception e) {
			result=false;
			MyLog.error(this, this.up, this.tableName + e.toString());
		} finally {
			this.closeConnection(connection, statement);
		}
		return result;
	}
	
	private void closeConnection(CscConnection connection, Statement statement) {
		try {
			if(statement!=null)
				statement.close();
			if(connection!=null)
				connection.close();
		} catch (SQLException e) {
			MyLog.error(this, e);
		}
	}
	
	public void removeList(String listid,String uploadfield,String subfolder,String filename){
		removeDb(listid);
		FileUploadUtils.deleteFileUpload(uploadfield,subfolder,filename);
	}
	
	public void removeDb(String listid){
		try {
			this.setUProfile();
			String sql = "delete EMP_CREATE_SHIFT_TEMP where listid = '"+listid+"'";
			System.out.println(">>>> removeList Sql >>>> "+sql);
			DataSet ds = new DataSet(sql,this.up.get("dbname"),"EMP_CREATE_SHIFT_TEMP");
			ds.excuteUpdate(this.up);
			ds.closeConnection();

		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	public String createlistAdmin(String path, String filename,String emp_boss) {
		this.setUProfile();
		CscCalendar csctime = new CscCalendar();	
		String Listid = String.valueOf(csctime.getTimeInMillis());		
		String fullpath = path+""+filename;
		ReadFile rf = new ReadFile(fullpath);
		String empline="";
		String headerline="";
		String list ;
		CscCalendar listd = new CscCalendar();
		CscCalendar now = new CscCalendar();
		CscCalendar limit_before = this.getLimitDate();
		String[] mm;
		String[] corum;
		//String Import="";
		ArrayList<String> Import = new ArrayList<String>();
		ArrayList<String> beford = new ArrayList<String>();
		try{
			if(rf.hasMoreData()){
				list = rf.readLine();
				mm = list.split(",");
				listd.setCalendar("01-"+mm[0]+"-"+mm[1]);
			}
			if(rf.hasMoreData()){
				headerline = rf.readLine(); // ҹ header  áѺѹ
			}
			while(rf.hasMoreData()){
				empline =rf.readLine();
				corum = empline.split(",");	
				if(!corum[0].equals("")||!corum[0].equals(null)){
					for(int i=1;i<corum.length;i++){
						try{
							if(i<=listd.getDayInMonth()){
								if(!corum[i].equals("")){
									listd.setDate(i);
									if(listd.afterEqualsDate(limit_before)){
										StringBuffer sql = new StringBuffer();
										sql.append("insert into EMP_CREATE_SHIFT_TEMP(COMPANYID,LISTID,EMPLOYEEID,DATE,TIME0ID,CREATE_DATE,CREATE_TIME,EDIT_TIME,CREATE_BY) ");
										sql.append("select companyid,'"+Listid+"',EMPLOYEEID,'"+listd.getDDMMYYYY()+"','"+corum[i]+"','"+now.getDDMMYYYY()+"','"+now.getHHMMSS()+"','"+now.getHHMMSS()+"','"+this.up.get("employeeid")+"' from memployee ");
										sql.append("where employeeid='"+corum[0]+"' and ");
										sql.append("employeeid in (select EMPLOYEEID from MSUPERVISOR where SUPERVISOR like'%"+emp_boss+"%')");
										System.out.println(">>>> createlist Sql >>>> "+sql.toString());
										boolean chkInsert = excuteSql(sql.toString());
										Import.add(String.valueOf(chkInsert));
									}else{
										beford.add("false");
									}
								}
							}
						}catch(Exception e){
							MyLog.error(">>>>>>>>> employee null<<<<<<<<<<<");
						}
					}
				}
			}	
		}catch(Exception e){
			e.printStackTrace();
			MyLog.error(">>>>>>>>> ImportUnsuccess<<<<<<<<<<<");
			return "ImportUnsuccess";
		}
		if(Import.indexOf("true")>-1 && beford.indexOf("false") == -1)
			return Listid;
		else if(beford.indexOf("false")>-1)
			return "Can't Change";
		else
			return "ImportUnsuccess";
	}
	
	
	public CscCalendar getLimitDate(){
		int limit_d = 3;
		CscCalendar now = new CscCalendar();
		CscCalendar c = new CscCalendar();
		c.decDate(limit_d);
		int DAY_SUN = 1;
		boolean isHoliday = false;
		//System.out.println(c.getYYYYMMDD());
		while(c.beforeEqualsDate(now)){
			//System.out.println(c.getYYYYMMDD() + " Day : " + c.getDayOfWeek());
			if(c.getDayOfWeek() == DAY_SUN){
				isHoliday = true;
			}
			c.incDate(1);
		}
		
		if(isHoliday){
			limit_d += 1;
		}
		now.decDate(limit_d);
		return now;
	}
	
	public String createlistAdminV2(String path, String filename,String emp_boss) {
		this.setUProfile();
		this.setShift();
		CscCalendar csctime = new CscCalendar();	
		String fullpath = path+""+filename;
		ReadFile rf = new ReadFile(fullpath);
		String empline="";
		CscCalendar listd = new CscCalendar();
		CscCalendar now = new CscCalendar();
		String[] corum;
		//String Import="";
		ArrayList<String> Import = new ArrayList<String>();
		ArrayList<String> beford = new ArrayList<String>();
		
		String Listid = String.valueOf(csctime.getTimeInMillis());
		String monthid = "";
		String yearid = "";
		String time0id = "";
		String groupid = "";
		CscCalendar limit_before = this.getLimitDate();
		
		/*
		 * 1 = ҹ
		 * 2 = ʾѡҹеҧçѹ
		 * 3 = Shift Դ
		 * 4 = ʡмԴ
		 * 5 = ͹ѧԹ 3 ѹ
		 * 6 = յҧк
		 * 7 = ʡз鹵鹴 P
		 */
		String status = "";
		
		int line = 0 ;
		try{
			if(rf.hasMoreData()){
				String headerline = rf.readLine(); // ҹ header  áѺѹ
			}
			while(rf.hasMoreData()){
				try{
					status = "1";   
					HashMap<String,String> hm = new HashMap();
					line++;
					empline =rf.readLine();
					corum = empline.split(",");
					if(!corum[0].equals(null) && !corum[0].equals("")){
						if(corum.length>=7){ 
							hm.put("monthid",corum[0]);
							hm.put("yearid",corum[1]);
							hm.put("employeeid",corum[2]);
							hm.put("time0id",corum[5]);
							hm.put("groupid",corum[6]);
							for(int i=1 ; i<corum.length-6 ; i++){
								//hm.put("time"+getDay(i)+hm.get("groupid"),corum[i+6]);
								hm.put("time"+getDay(i)+hm.get("groupid"),corum[i+6].trim());
							}
						}
						if(!hm.get("employeeid").equals(hm.get("time0id"))){ // ҧüԴ 
							status = "2";
						}
						
						if(!hm.get("groupid").equals("1") && !hm.get("groupid").equals("2") && !hm.get("groupid").equals("3")){
							return "ö Import  سҵǨͺ  Shift ͧ繤 1,2  3";
						}
						
						CscCalendar input_date = new CscCalendar();	
						HashMap<String,String> hm_dayShift = new HashMap();
						for(int i=1 ; i<corum.length-6 ; i++){
							String dayShift = corum[i+6];
							input_date.setDate(i);
							input_date.setMonth(Integer.parseInt(hm.get("monthid"))-1);
							input_date.setYear(Integer.parseInt(hm.get("yearid")));
							
							if(!input_date.afterEqualsDate(limit_before) && !dayShift.equals("")){
								status = "5";
							}
						}
						// Check Day.now > Day(6) Can't Import File Old Month.now - 1
						/*CscCalendar input_date1 = new CscCalendar();		
						HashMap<String,String> hm_dayShift1 = new HashMap();
						for(int i=1 ; i<corum.length-6 ; i++){
							String dayShift = corum[i+6];
							input_date.setDate(i);
							input_date.setMonth(Integer.parseInt(hm.get("monthid"))-1);
							input_date.setYear(Integer.parseInt(hm.get("yearid")));
							
							if(!input_date.afterEqualsDate(limit_before) && !dayShift.equals("")){
								status = "8";
							}
						}*/
						
						StringBuffer sql = new StringBuffer();
						sql.append("INSERT INTO MTIME2_TEMP_IMPORT (COMPANYID,LISTID,MONTHID,YEARID,EMPLOYEEID,TIME0ID,LINE_NO,");
						sql.append("TIME01"+hm.get("groupid")+",TIME02"+hm.get("groupid")+",TIME03"+hm.get("groupid")+",TIME04"+hm.get("groupid")+",TIME05"+hm.get("groupid")+",TIME06"+hm.get("groupid")+",TIME07"+hm.get("groupid")+",TIME08"+hm.get("groupid")+",TIME09"+hm.get("groupid")+",TIME10"+hm.get("groupid")+",");
						sql.append("TIME11"+hm.get("groupid")+",TIME12"+hm.get("groupid")+",TIME13"+hm.get("groupid")+",TIME14"+hm.get("groupid")+",TIME15"+hm.get("groupid")+",TIME16"+hm.get("groupid")+",TIME17"+hm.get("groupid")+",TIME18"+hm.get("groupid")+",TIME19"+hm.get("groupid")+",TIME20"+hm.get("groupid")+",");
						sql.append("TIME21"+hm.get("groupid")+",TIME22"+hm.get("groupid")+",TIME23"+hm.get("groupid")+",TIME24"+hm.get("groupid")+",TIME25"+hm.get("groupid")+",TIME26"+hm.get("groupid")+",TIME27"+hm.get("groupid")+",TIME28"+hm.get("groupid")+",TIME29"+hm.get("groupid")+",TIME30"+hm.get("groupid")+",");
						sql.append("TIME31"+hm.get("groupid")+",GROUPID,STATUS) ");
						sql.append("VALUES ("+this.up.get("companyid")+",'"+Listid+"','"+hm.get("monthid")+"','"+hm.get("yearid")+"','"+hm.get("employeeid")+"','"+hm.get("time0id")+"',"+line+",");
						for(int i=1 ; i<=31 ; i++){
							String time0 = "";
							if(hm.containsKey("time"+getDay(i)+hm.get("groupid"))){
								time0 = hm.get("time"+getDay(i)+hm.get("groupid"));
							}
							sql.append("'"+time0+"',");
							if(hm.get("groupid").equals("1") && time0.startsWith("P")){
								status = "7";
							}
							if(!hm_shift.containsKey(time0) && !time0.equals("")){ //  з繡Ẻʹٴѵ 繵ҧ
								status = "4";
							}
						}
						
						if(!hm_time0id.containsKey(hm.get("time0id"))){ // յҧк 
							status = "6"; 
						}
						
						CscCalendar DateNOW = new CscCalendar();	
						int DAY =  Integer.parseInt(DateNOW.getDD());
						int NowMM = Integer.parseInt(DateNOW.getMM());
						if(DAY > 5){
							int MMReq = Integer.parseInt(corum[0]);
							if(NowMM>MMReq){
								status = "8";
							}
						}
						
						sql.append("'"+hm.get("groupid")+"','"+status+"') ");
						System.out.println(">>>> INSERT SQL : "+sql.toString());
						
						boolean chkInsert = excuteSql(sql.toString());
						Import.add(String.valueOf(chkInsert));
						
					}
				}catch(Exception e){
					MyLog.error(">>>>>>>>> employee null <<<<<<<<<<<");
				}
			}	
		}catch(Exception e){
			e.printStackTrace();
			MyLog.error(">>>>>>>>> ImportUnsuccess <<<<<<<<<<<");
			return "ImportUnsuccess";
		}
		if(Import.indexOf("true")>-1)
			return Listid;
		else if(beford.indexOf("false")>-1)
			return "Can't Change";
		else
			return "ImportUnsuccess";
	}
	
	public String getDay(int day){
		if(day<10){
			return "0"+day;
		}else{
			return ""+day;
		}
	}
	
	public void setShift(){
		DbInquiry inq = new InitialInquiry(this.up).getDbInquiry("MTIME0");
		try {
			inq.setColumn("*");
			inq.setFilter("sticktm='Y'");
			inq.refresh();
			while(inq.next()){
				if(inq.getString("status").equals("0")){
					hm_shift.put(inq.getString("time0id"), "");
				}else{
					hm_time0id.put(inq.getString("time0id"), "");
				}
			}
		}catch(RemoteException e){}
	}
}
