package com.csc.library.dwr;

import com.csc.library.utilities.MyLog;
import java.text.DecimalFormat;

import com.csc.library.session.DbInquiry;
import com.csc.library.utilities.CscCalendar;

public class Totapprove_nstda_dwr extends DWR_base {
	
	DecimalFormat df = new DecimalFormat("0.00");

	public Totapprove_nstda_dwr() { }
	
	public String getDWRData(String[] str) {
		this.setUProfile();
		String data="";
		data += this.getHeaderFrame();
		
		String empCode = this.chkEmptyData(str, 0);
		String startDate = this.chkEmptyData(str, 1);
		String endDate = this.chkEmptyData(str, 2);
		
		try {
			CscCalendar cs1 = new CscCalendar(startDate);
			CscCalendar cs2 = new CscCalendar(endDate);		
			
			data += "<table cellspacing='1' cellpadding='0' width='98%' align='center' border='0'>";		
			data += "<tr bgcolor='#0099cc'>";
            if(this.up.get("lang").equalsIgnoreCase("ENG")){
    			data += "<td colspan='8' align='center' class='txt_normal'><strong>&nbsp;:&nbsp;Working Information&nbsp;:&nbsp;"+empCode
    				+"&nbsp;:&nbsp;"+this.getEmployeeName(empCode)+"&nbsp;:&nbsp;</strong></td>";
    			//Working Information = š÷ӧҹ
    			data += "</tr>";
    			data += "<tr align='center' bgcolor='#0099cc'>";
    			data += "<td class='txt_normal' width='15%'><strong>Date&nbsp;</strong></td>";
    			data += "<td class='txt_normal' width='40%'><strong>Time Code&nbsp;</strong></td>";
    			data += "<td class='txt_normal' width='10%'><strong>Day Type&nbsp;</strong></td>";
    			data += "<td class='txt_normal' width='10%'><strong>Time In&nbsp;</strong></td>";
    			data += "<td class='txt_normal' width='10%'><strong>Time Out&nbsp;</strong></td>";			
    			data += "<td class='txt_normal' width='5%'><strong>Late&nbsp;</strong></td>";			
    			data += "<td class='txt_normal' width='5%'><strong>Leave&nbsp;</strong></td>";
    			data += "<td class='txt_normal' width='5%'><strong>OT&nbsp;</strong></td>";
            }else{
                data += "<td colspan='8' align='center' class='txt_normal'><strong>&nbsp;:&nbsp;š÷ӧҹ&nbsp;:&nbsp;"+empCode
                +"&nbsp;:&nbsp;"+this.getEmployeeName(empCode)+"&nbsp;:&nbsp;</strong></td>";
            //Working Information = š÷ӧҹ
                data += "</tr>";
                data += "<tr align='center' bgcolor='#0099cc'>";
                data += "<td class='txt_normal' width='15%'><strong>ѹ&nbsp;</strong></td>";
                data += "<td class='txt_normal' width='40%'><strong>ʡ&nbsp;</strong></td>";
                data += "<td class='txt_normal' width='10%'><strong>ѹ&nbsp;</strong></td>";
                data += "<td class='txt_normal' width='10%'><strong>ٴ&nbsp;</strong></td>";
                data += "<td class='txt_normal' width='10%'><strong>ٴ͡&nbsp;</strong></td>";          
                data += "<td class='txt_normal' width='5%'><strong>. &nbsp;</strong></td>";           
                data += "<td class='txt_normal' width='5%'><strong>. &nbsp;</strong></td>";
                data += "<td class='txt_normal' width='5%'><strong>. OT&nbsp;</strong></td>";
            }
			data += "</tr>";				
			
			String filter = "employeeid='"+empCode+"' and (dateid between '"+cs1.getYYYYMMDD()+"' " +
					"and '"+cs2.getYYYYMMDD()+"')";		
			DbInquiry inq = this.getInquiry("Ttime_current1", "*", filter, "dateid", this.up);
			while (inq.next()) {
				CscCalendar cs = new CscCalendar(inq.getString("dateid"));
				data += "<tr align='center'>";
				data += "<td class='txt_normal' width='12%'>"+cs.getDDMMYYYY()+"</td>";
				data += "<td class='txt_normal' width='40%'>"+inq.getString("time0id")+" : "+this.getTimeDesc(inq.getString("time0id"))+"</td>";
				data += "<td class='txt_normal' width='9%'>"+inq.getString("eventgrp")+"</td>";	
				data += "<td class='txt_normal' width='9%'>"+df.format(Double.parseDouble(inq.getString("m_tm_bg")))+"</td>";
				data += "<td class='txt_normal' width='9%'>"+df.format(Double.parseDouble(inq.getString("m_tm_en")))+"</td>";						
				data += "<td class='txt_normal' width='7%'>"+df.format(inq.getCurrentDbRecord().getDouble("lt"))+"</td>";			
				data += "<td class='txt_normal' width='7%'>"+df.format(inq.getCurrentDbRecord().getDouble("m_lv"))+"</td>";
				data += "<td class='txt_normal' width='7%'>"+df.format(inq.getCurrentDbRecord().getDouble("ac_ot"))+"</td>";
				data += "</tr>";	
			}
			
			data += "</table>";
		} catch (Exception e) {
			MyLog.error(this, e);

			
		}
		
		data += this.getBelowFrame();
		return data;
	}
}
