package com.csc.library.process;

import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import java.util.HashMap;
import java.util.Iterator;
import java.util.StringTokenizer;
import java.util.Vector;

import com.csc.library.databean.Mtime0;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;

/*
 * class ˹͹㹡ûżŢͧ TA 
 *  class 繡 process зӡ extends class 
 *  class 繡͹䢷ҡҡ˹Ҩ ͹ process list
 * 㹡 process  
 */
public class ProcessTimeBase extends MyProcess {
	
	HashMap hmParam = new HashMap();
	Vector vtFilter = new Vector();
	DbInquiry inqTme = null;
	DbInquiry inqSwipeTime = null;
	
	public Vector getProcessList() {
		Vector v = new Vector();
		v.addElement("All");
		return v;
	}
	
	private String getTimeList(Vector vtList) {
		String list = "";
		String filter = "";
		int i = 0;
		if (vtList.size() > 0) {
			filter = "(";
			for (Iterator it = vtList.iterator(); it.hasNext();) {
				String key = (String) it.next();
				if (i == 0)
					filter = filter + "(runno=" + key + ")";
				else
					filter = filter + " or (runno=" + key + ")";
				i++;
			}
			filter = filter + ")";
		}

		if (filter.length() > 0) {
			try {
				int j = 0;
				String data = "";
				if (this.inqSwipeTime == null) {
					this.inqSwipeTime = new InitialInquiry(this.upf).getDbInquiry();
					this.inqSwipeTime.setSchemaName(this.upf.getSchemaName());
					this.inqSwipeTime.initMyTable("Ttimetemp", "", "runno");
					this.inqSwipeTime.setColumn("swipedate, swipetime, runno, companyid");
				}
				this.inqSwipeTime.setFilter(filter);
				this.inqSwipeTime.refresh();
				while (this.inqSwipeTime.next()) {
					data = this.inqSwipeTime.getString("swipedate") + ":"
							+ this.inqSwipeTime.getString("swipetime");
					if (j == 0) {
						list = data;
					} else
						list = list + "," + data;
					j++;
				}
			} catch (Exception e) {
				MyLog.error(this, e);

				
			}
		}
		return list;
	}
	
	/*
	 *   ѧ param Ҩҡ˹Ҩ
	 */
	protected String getParamData(String filedName) {
		if (this.data.containsKey(filedName))
			return this.data.get(filedName).toString();
		return "";
	}
	
	public void setParamData() {		
		this.hmParam.put("employeeProcess", this.getParamData("employeeProcess"));
		this.hmParam.put("startDate", this.getParamData("startDate"));
		this.hmParam.put("endDate", this.getParamData("endDate"));
		this.hmParam.put("timein", this.getParamData("timein"));
		this.hmParam.put("timeout", this.getParamData("timeout"));
		this.hmParam.put("cmdValue", this.getParamData("cmdValue"));
		
		//=======================Nuiss Code ==========================
		/**
		 * Author : Nuiss
		 * Date : 08/04/2552
		 * Logic : process  ͹ѹ ͡ 
		 * ͡ 1/10/2552 ͧ process š͹˹ ѹѧ
		 * 㹷ҧѺѹ ͧ process ѧѹ 1/10/2552  
		 */
		String startDate = this.getParamValue("startDate");
		if(startDate.equals("")){
			//ͧ 
			this.hmParam.put("filterProcess", this.getProcessCondition());
		}else{
			String whereClause = this.getProcessCondition();
			String processDate = new CscCalendar(startDate).getYYYYMMDD();
	 		whereClause += " AND employeeid in (select emp.employeeid from memployee emp where (emp.status in('A','B','S','V','W') or emp.endworkdate >= '"+processDate+"'))";
			this.hmParam.put("filterProcess", whereClause);
		}//end if 
		//=======================Nuiss Code ==========================
		
		this.hmParam.put("startTime", this.getParamData("startTime"));
		this.hmParam.put("endTime", this.getParamData("endTime"));
	}
	
	/*
	 * ӡҧ͹㹡 select ͡
	 * ˹Ҩ process 觢 list 
	 *  bu1  1100#2005#1000 繵
	 * conValue = ŷҨҡ˹Ҩ list
	 * conField = ͿŴѺ˹͹
	 */
	private String getFilterCondition(String conValue, String conField) {
		String filterData = "";
		if (conValue.length() > 0) {
			int i = 0;
			//StringTokenizer str = new StringTokenizer(conValue, ",");
			StringTokenizer str = null;
			if (conValue.indexOf(",")>-1) {
				str = new StringTokenizer(conValue, ",");
			} else if (conValue.indexOf("#")>-1) {
				str = new StringTokenizer(conValue, "#");
			}   
			while (str.hasMoreTokens()) {
				String con = str.nextToken();
				if (i == 0) {
					filterData = "(" + conField + "='" + con + "'";
				} else
					filterData = filterData + " or " + conField + "='" + con
							+ "'";
				i++;
			}
			filterData = filterData + ")";
			vtFilter.add(filterData); //add data is not empty to Vector
		}
		return filterData;
	}	

	/*
	 * ӡҧ͹㹡 select 
	 */
	protected String getProcessCondition() {
		String filter = "";
		String employeeSelect = this.getParamData("employeeSelect");
		String positionSelect = this.getParamData("positionSelect");
		String branchSelect = this.getParamData("branchSelect");
		String salatypeSelect = this.getParamData("salatypeSelect");
		String bu1Select = this.getParamData("bu1Select");
		String bu2Select = this.getParamData("bu2Select");
		String bu3Select = this.getParamData("bu3Select");
		String bu4Select = this.getParamData("bu4Select");
		String bu5Select = this.getParamData("bu5Select");
		String workareaSelect = this.getParamData("workareaSelect");		
		String emp_levelSelect = this.getParamData("emp_levelSelect");			
		String time0Select = this.getParamData("time0Select");	
		String employeeBetween = this.getParamData("employeeBetween");
		
		String employeeFilter = this.getFilterCondition(employeeSelect, "employeeid");	
		String positionFilter = this.getFilterCondition(positionSelect, "emp_position");
		String branchFilter = this.getFilterCondition(branchSelect, "branch");
		String salatypeFilter = this.getFilterCondition(salatypeSelect, "salatype");
		String bu1Filter = this.getFilterCondition(bu1Select, "bu1");
		String bu2Filter = this.getFilterCondition(bu2Select, "bu2");
		String bu3Filter = this.getFilterCondition(bu3Select, "bu3");
		String bu4Filter = this.getFilterCondition(bu4Select, "bu4");
		String bu5Filter = this.getFilterCondition(bu5Select, "bu5");
		String workareaFilter = this.getFilterCondition(workareaSelect, "workarea");
		String emp_levelFilter = this.getFilterCondition(emp_levelSelect, "emp_level");
		String time0Filter = this.getFilterCondition(time0Select, "time0");
		
		int count = 0;
/*		Iterator it = vtFilter.iterator();
		while (it.hasNext()) {
			String conValue = (String) it.next();
			if (count == 0) {
				filter = conValue;
			} else
				filter = filter + " and " + conValue;
			count++;
		}*/
		
//		Iterator it = vtFilter.iterator();
		for (int ii = 0; ii< vtFilter.size();ii++) {
			String conValue = (String) this.vtFilter.get(ii);
			if (count == 0) {
				filter = conValue;
			} else
				filter = filter + " and " + conValue;
			count++;
		}
		
		if (!employeeBetween.equals("")) {
			if (!filter.equals("")) {
				filter += " and " + employeeBetween;
			} else {
				filter = employeeBetween;
			}
		}
		 
		//EMPLOYEE_STATUS
		//A=Normal,B=Study Leave,C=Contract,T=Apprentice,U=Dead,V=Try out job,W=Suspended from job,X=Dismiss,Y=Resign,Z=Retire
		//String empStatus = " (status='A'||status='C'||status='T||status='V'') ";
		return filter;
	}
	
	public HashMap getParamValue() {
		return this.hmParam;
	}
	
	/*
	 * ֧ҷ param ͡
	 */
	public String getParamValue(String filedName) {
		if (this.hmParam.containsKey(filedName))
			return this.hmParam.get(filedName).toString();
		return "";
	}
	
	public String getStringID(int data, int i) {
		String text="";
        java.text.DecimalFormat dc=new java.text.DecimalFormat();
        for (int j=1;j<=i;j++){
        	text=text+"0";
        }       
        dc.applyPattern(text);
        return String.valueOf(dc.format(data));
	}
	
	/*
	 * ӡäҵҧ÷ӧҹ͡
	 * 㹡ûżŵ
	 */
	public Mtime0 getTimeRecord(String id) {
		Mtime0 rec = null;
		try {
			rec = (Mtime0) new InitialRecord(this.upf).getDbRecord("Mtime0");
			rec.setColumn("*");
			rec.set("time0id", id);
			if(rec.search() == 1){
				/* */
			}else{
				MyLog.error("!! time0id not found " + id);
			}
			/*
			if (this.inqTme == null) {
				this.inqTme = new InitialInquiry(this.upf).getDbInquiry();
				this.inqTme.setParam(this.data);
				this.inqTme.setSchemaName(this.upf.getSchemaName());
				this.inqTme.initMyTable("Mtime0", "", "");
				this.inqTme.setColumn("*");
			}
			this.inqTme.setFilter("time0id='" + id + "'");
			this.inqTme.setFatchAll(true);
			this.inqTme.refresh();
			while (this.inqTme.next()) {
				rec = (Mtime0) this.inqTme.getCurrentDbRecord();
			}*/
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return rec;
	}
	
	public void process() throws Exception {
		if (this.upf!=null && this.data!=null && !this.data.isEmpty()) {
			if (this.data.containsKey("companyid")) {
				this.upf.set("companyid", (String) this.data.get("companyid"));
			}
			if (this.data.containsKey("schemaname")) {
				this.upf.setSchemaName((String) this.data.get("schemaname"));
			}
			if (this.data.containsKey("dbname")) {
				this.upf.setDbName((String) this.data.get("dbname"));
			}
			if (this.data.containsKey("appname")) {
				this.upf.set("appname", (String) this.data.get("appname"));
			}
			if (this.data.containsKey("lang")) {
				this.upf.set("lang", (String) this.data.get("lang"));
			}			
		}
	}
}
