package com.csc.library.process;

import java.sql.ResultSet;
import java.sql.Statement;

import com.csc.library.database.CscConnection;
import com.csc.library.database.StaticProperties;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;

public class SearchEmpByCardid {
	private UProfile upf ;
	
	public SearchEmpByCardid(UProfile upf){
		this.upf = upf;
	}
	
	/* ʾѡҹ ʺѵٴ */
	public String search(String cardid){
		String empid = "";
		CscConnection conn = null ;
		Statement stmt = null;
		ResultSet rs = null;
		try {
			String query = "select employeeid from memployee where swipecardid = '" + cardid + "'";
			conn = (CscConnection) StaticProperties.myConnection.getConnection(this.upf.get("dbname"));
			stmt = (Statement) conn.createStatement();
			rs = stmt.executeQuery(query);
			
			while(rs.next()){
				empid = rs.getString("employeeid");
			}
		}catch(Exception e){
			MyLog.error("!! Error while searching employee id on this card : " + cardid);
			MyLog.error(this,e);
		}finally{
			try {
				if(rs != null ) rs.close();
				if(stmt != null) stmt.close();
				if(conn != null) conn.close();
			}catch(Exception e){
				MyLog.error(this,e);
			}
		}
		return empid;
	}
	
	/* ʾѡҹ Ңͧѡҹ (੾ FTI 㹪ǧáѧк myHR ١ٴѵ) */
	public String searchByExEmpID(String id){
		String empid = "";
		CscConnection conn = null ;
		Statement stmt = null;
		ResultSet rs = null;
		try {
			String query = "select employeeid from mempl_idmaping where ex_employeeid = '" + id + "'";
			conn = (CscConnection) StaticProperties.myConnection.getConnection(this.upf.get("dbname"));
			stmt = (Statement) conn.createStatement();
			rs = stmt.executeQuery(query);
			
			while(rs.next()){
				empid = rs.getString("employeeid");
			}
		}catch(Exception e){
			MyLog.error("!! Error while searching employee id on this card : " + id);
			MyLog.error(this,e);
		}finally{
			try {
				if(rs != null ) rs.close();
				if(stmt != null) stmt.close();
				if(conn != null) conn.close();
			}catch(Exception e){
				MyLog.error(this,e);
			}
		}
		return empid;
	}
}

