package com.csc.library.process;

import java.text.DecimalFormat;
import java.util.HashMap;
import java.util.Vector;

import com.csc.library.database.DataSet;
import com.csc.library.mail.SendMail;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;

public class SendMailpromisework extends ProcessTimeBase{
	String filter="";
	@Override
	public Vector getProcessList() {
		Vector v = new Vector();
		HashMap hData;
		CscCalendar startdate = new CscCalendar();
		startdate.setDate(1);
		CscCalendar enddate= new CscCalendar();
		enddate.incMonth(2);
		enddate.setDate(31);
		try{
			System.out.println("### SendMailpromisework ###");
			String sql = "select * from VW_PROMISEWORK where enddate between '"+startdate.getYYYYMMDD()+"' and '"+enddate.getYYYYMMDD()+"'";
			DataSet ds = new DataSet(sql,this.getUProfile().get("dbname"),"MEMPLOYEE");
			ds.initConnection(this.getUProfile());	
			while(ds.next()){
				hData= new HashMap();
				hData.put("empid", ds.getString("empid"));
				hData.put("fullname", ds.getString("fullname"));
				hData.put("bu2", ds.getString("bu2"));
				hData.put("promisenumber", ds.getString("promisenumber"));
				hData.put("promisedate", ds.getString("promisedate"));
				hData.put("enddate", ds.getString("enddate"));
				hData.put("workage", ds.getString("workage"));
				v.add(hData);
				hData=null;
			}
			ds.closeConnection(); 
		}catch(Exception e){
			e.printStackTrace();
		}
		return v;
	}
	
	@Override
	public void process() throws Exception {
		HashMap hmData = new HashMap();
		try {
			Vector email = new Vector();
			StringBuilder content= new StringBuilder();
			content.append("¹ ˹§ҹ÷Ѿҡ<br><br><br>");
			content.append("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;͹ú˹ѭҨҧѡҹ<br>");
			content.append("<table><tr><td>ʾѡҹ&nbsp;&nbsp;&nbsp;&nbsp;").append("</td>").append("<td> - ʡ&nbsp;&nbsp;&nbsp;&nbsp;").append("</td>");
			content.append("<td>ѧѴ˹§ҹ&nbsp;&nbsp;&nbsp;&nbsp;").append("</td>").append("<td>Ţѭ&nbsp;&nbsp;&nbsp;&nbsp;").append("</td>");
			content.append("<td>ѹѭ&nbsp;&nbsp;&nbsp;&nbsp;").append("</td>").append("<td>ѹú˹ѭ&nbsp;&nbsp;&nbsp;&nbsp;").append("</td>");
			content.append("<td>ѭ&nbsp;&nbsp;&nbsp;&nbsp;").append("<td></tr>");
			Vector data = this.getProcessList();
			if(data.size() > 0) {
				for(int i=0; i < data.size(); i++){	/* ǹٻ֧ҷӧҹ */
					hmData=(HashMap) data.get(i);
					content.append("<tr><td>"+hmData.get("empid")).append("</td>").append("<td>"+hmData.get("fullname")).append("</td>");
					content.append("<td>"+hmData.get("bu2")).append("</td>").append("<td>"+hmData.get("promisenumber")).append("</td>");
					content.append("<td>"+hmData.get("promisedate")).append("</td>").append("<td>"+hmData.get("enddate")).append("</td>");
					content.append("<td>"+this.getage(hmData.get("workage").toString())).append("</tr></td>");
				}
			}
			content.append("</table>");
			String from = "MyHR";
			String subject="͹ú˹ѭҨҧѡҹ";
			
			email=this.getEmailSender();
			
			System.out.println("### SendMailpromisework Send : "+email.size()+"email ###");
			if(email.size()>0){
				for(int i=0; i < email.size(); i++){
					SendMail sm = new SendMail("", from,email.get(i).toString(), "", subject, content.toString());
					sm.send();
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	private Vector getEmailSender(){
		Vector mail = new Vector();
		filter = this.data.get("filter").toString();
		try {
			String sql = "select email from MEMPLOYEE ";
			sql += filter;
			DataSet ds = new DataSet(sql,this.getUProfile().get("dbname"),"MEMPLOYEE");
			ds.initConnection(this.getUProfile());	
			while(ds.next()){
				mail.add(ds.getString("email"));
			}
			ds.closeConnection(); 
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return mail;
	}
	
	private String getage(String data){
		String res="";
		DecimalFormat dc = new DecimalFormat("00");
		if(data.length()>0){
		String[] tmpdata = data.split("/");
		res=dc.format(Double.parseDouble(tmpdata[0]))+":"+dc.format(Double.parseDouble(tmpdata[1]));
		}
		return res;
	}
}
