package com.csc.library.process;

import java.util.HashMap;
import java.util.Iterator;

import com.csc.library.database.DataSet;
import com.csc.library.mail.SendMail;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.session.InitialInquiry;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;

public class Sm_emp_disorder_VIV extends MyProcess{

	public void process(){
		if(isOnSpecificDate()){
			CscCalendar cc = new CscCalendar().decDate(); 		/* end */
			CscCalendar stcc = new CscCalendar().decDate(7); 	/* start */
			
			HashMap<String,String> hm_name = new HashMap<String,String>();
			HashMap<String,String> hm_mail = new HashMap<String,String>();
			HashMap<String,String> hm_data = new HashMap<String,String>();
			MyLog.debug(this,this.getUProfile(),"================== Before Query By BlizZoniC ==================");
			try{
				String sql = "select * from SENDMAILTOEMP where dateid between '" + stcc.getYYYYMMDD() + "' and '"+cc.getYYYYMMDD()+"' order by empid,dateid ";
				DataSet ds = new DataSet(sql,this.getUProfile().get("dbname"),"SENDMAILTOEMP"); 
				ds.initConnection(this.getUProfile());
				while(ds.next()){
					MyLog.debug(this,this.getUProfile(),"================== Query By BlizZoniC ==================");
					String val = 	"<tr>"+
											"<td>"+new CscCalendar(ds.getString("dateid")).getDDMMYYYY()+"</td>"+
											"<td>&nbsp;&nbsp;&nbsp;&nbsp;"+ds.getString("data")+"</td>"+
										"</tr>\n";
					hm_name.put(ds.getString("empid"), ds.getString("fullname"));
					hm_mail.put(ds.getString("empid"), ds.getString("email"));
		            if(hm_data.containsKey(ds.getString("empid"))){
		            	hm_data.put(ds.getString("empid"), hm_data.get(ds.getString("empid"))+val);
		            }else{
		            	hm_data.put(ds.getString("empid"),val);
		            }
					
				}
	
			}catch(Exception e){
				e.printStackTrace();
			}
			
			try{
				Iterator<String> it = hm_mail.keySet().iterator();
				while(it.hasNext()){
					String key = it.next();
					String email = hm_mail.get(key);
		            String content = hm_data.get(key);
		            String name = hm_name.get(key);
		            
		            sendMail(email,content,name);
				}
			}catch(Exception e){
				e.printStackTrace();
			}
		}
	}
	
	private boolean isOnSpecificDate(){
		try {
			if(this.data.containsKey("daysent")){
				String days = (String) this.data.get("daysent");
				if(new CscCalendar().getDayOfWeek() == Integer.parseInt(days)){
					return true ;
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return false;
	}


	private void sendMail(String email,String content,String name){
		MyLog.debug(this,this.getUProfile(),"================== Before Sendmail By Nut Freedom ==================");
		if(email!=null){
			CscCalendar cc2 = new CscCalendar();
			cc2.decDate(2);
				
			InitialEnvironment ine = new InitialEnvironment("GLOBAL");
			String 	from = ine.getValue("mailauth-username");
			String 	head = "<b>¹س "+name+"</b><br>";
					head += "&nbsp;&nbsp;&nbsp;&nbsp;ҡõǨͺҡ÷ӧҹͧҹ к myHR ҷӧҹ 繡͢ͼԴҴѧ<br>";
			String footer = "&nbsp;&nbsp;&nbsp;&nbsp;ѧ鹾ѡҹ ¡سһѺاŢͧҹк myHR ˹ҷ˹§ҹ÷Ѿҡ ͻªͧǷҹͧ<br><br>˹§ҹ÷þҡ";
			//SendMail sm = new SendMail(hostname, from, to, cc, subject, content);
			SendMail sm = new SendMail("", from,(String) email, (String) this.data.get("cc"), "Time attendance notification", head+"<table><tr><td>&nbsp;&nbsp;&nbsp;ѹ</td><td>&nbsp;</td></tr>\n"+content+"</table><br>"+footer);
			sm.send();
		}
	}

}
