package com.csc.library.process;

import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.Vector;

import com.csc.library.database.DataSet;
import com.csc.library.mail.SendMail;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.session.InitialInquiry;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;

public class Sm_emp_disorder_boss_VIV extends MyProcess{
	
	public Vector getProcessList() {
		Vector vc = new Vector();
		vc.add("default");
		return vc;
	}
	
	public void process(){
		if(isOnSendDate()){
			CscCalendar date = null;
			CscCalendar en = new CscCalendar();
			en.setDate(getSentDate());
			en.decDate();
			
			CscCalendar st = new CscCalendar(en.getTime());
			st.decMonth();
			st.incDate();
			
			String data_emp = "";
			HashMap<String,String> hm_name = new HashMap<String,String>();
			HashMap<String,String> hm_mail = new HashMap<String,String>();
			LinkedHashMap<String,String> hm_data = new LinkedHashMap<String,String>();
			HashMap<String,String> hm_boss = new HashMap<String,String>();
			LinkedHashMap<String,String> hm_content = new LinkedHashMap<String,String>();
			MyLog.debug(this,this.getUProfile(),"================== Before Query By BlizZoniC ==================");
			try{
				String sql = "select * from SENDMAILTOEMP where dateid between '"+st.getYYYYMMDD()+"' and '"+en.getYYYYMMDD()+"' order by boss,empid,dateid ";
				DataSet ds = new DataSet(sql,this.getUProfile().get("dbname"),"SENDMAILTOEMP"); 
				ds.initConnection(this.getUProfile());
				while(ds.next()){
					MyLog.debug(this,this.getUProfile(),"================== Query By BlizZoniC ==================");
					data_emp = "<tr><td colspan='2'>ʾѡҹ&nbsp;"+ds.getString("empid")+"&nbsp;&nbsp;"+ds.getString("fullname")+"&nbsp;&nbsp;˹&nbsp;"+ds.getString("position")+"</td></tr>\n";
					date = new CscCalendar(ds.getString("dateid"));
					String val = 	"<tr>"+
											"<td>"+date.getDDMMYYYY()+"</td>"+
											"<td>&nbsp;&nbsp;&nbsp;&nbsp;"+ds.getString("data")+"</td>"+
										"</tr>\n";
					hm_boss.put(ds.getString("empid"), ds.getString("boss"));
					hm_mail.put(ds.getString("boss"), ds.getString("mailboss"));
					hm_name.put(ds.getString("boss"), ds.getString("bossfullname"));
		            if(hm_data.containsKey(ds.getString("empid"))){
		            	hm_data.put(ds.getString("empid"), hm_data.get(ds.getString("empid"))+val);
		            }else{
		            	hm_data.put(ds.getString("empid"),data_emp+"\n"+val);
		            }
					
				}
	
			}catch(Exception e){
				e.printStackTrace();
			}
			
			try{
				Iterator<String> it = hm_data.keySet().iterator();
				while(it.hasNext()){
	
					String key = it.next();
		            String content = hm_data.get(key);
		            String bossid = hm_boss.get(key);
		            
		            if(hm_content.containsKey(bossid)){
		            	hm_content.put(bossid, hm_content.get(bossid)+"<tr><td colspan='2'>&nbsp;</td></tr>\n"+content+"\n");
		            }else{
		            	hm_content.put(bossid,content+"\n");
		            }
				}
				
				Iterator<String> it_content = hm_content.keySet().iterator();
				while(it_content.hasNext()){
					String key = it_content.next();
					String content = hm_content.get(key);
					String name = hm_name.get(key);
					String email = hm_mail.get(key);
					sendMail(email,content,name);
				}
			}catch(Exception e){
				e.printStackTrace();
			}
		}
	}
	
	private int getSentDate(){
		try {
			if(this.data.containsKey("datesent")){
				String days = (String) this.data.get("datesent");
				int sentDate = Integer.parseInt(days);
				return sentDate ;
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return 1 ;
	}

	private boolean isOnSendDate(){
		try {
			if(new CscCalendar().getDayOfMonth() == getSentDate()){
				return true ;
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return false;
	}

	private void sendMail(String email,String content,String name){
		MyLog.debug(this,this.getUProfile(),"================== Before Sendmail By Nut Freedom ==================");
		if(email!=null){
			CscCalendar cc2 = new CscCalendar();
			cc2.decDate(2);
				
			InitialEnvironment ine = new InitialEnvironment("GLOBAL");
			String 	from = ine.getValue("mailauth-username");
			String 	head = "<b>¹س "+name+"</b><br>";
			head += "&nbsp;&nbsp;&nbsp;&nbsp;ҡõǨͺҡ÷ӧҹ ͧѡҹѧѺѭҢͧҹ к myHR ҷӧҹ 繡͢ͼԴҴͧѡҹ մѧ<br><br>";
			String footer = "&nbsp;&nbsp;&nbsp;&nbsp;ҹǨͺеԴ ûѺاš úѹ֡ ͧѡҹ ˹§ҹͧҹ к myHR  ˹ҷ˹§ҹ÷Ѿҡ ";
			footer += " ͻª ͧѡҹѧѺѭҢͧҹ<br><br>˹§ҹ÷þҡ<br><br>";
			//SendMail sm = new SendMail(hostname, from, to, cc, subject, content);
			SendMail sm = new SendMail("", from,(String) email, (String) this.data.get("cc"), "駼šõǨͺҡ÷ӧҹШ͹", head+"<table>"+content+"</table><br>"+footer);
			sm.send();
		}
	}

}
