package com.csc.library.timeattendance;

import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;

/* ´اҹ */
public class DateProperties {

	public int year 	= 0;
	public int month	= 0;
	public int day 		= 0;
	public int hour		= 0;
	public int min		= 0;
	public int dayofwork = 0;
	public CscCalendar cdate ;
	
	/* Ѻ String format YYYY:MM:DD */
	public DateProperties(String date,String deli){
		try {
			if(date.length() < 8 && date.split(deli).length < 3){ /* 礤١ͧͧٻẺ */
				MyLog.error("!! DateProp format is incorrect !!");
				/* ˹ѹѨغѹŧ */
				CscCalendar today = new CscCalendar();
				this.setYEAR(today.getYear());
				this.setMONTH(today.getMonth());
				this.setDAY(today.getDate());
				cdate = new CscCalendar();
			}else{
				String[] data = date.split(deli);
				this.setYEAR(Integer.parseInt(data[0].trim()));
				this.setMONTH(Integer.parseInt(data[1].trim()));
				this.setDAY(Integer.parseInt(data[2].trim()));
				
				if(deli.equals("-")){
					cdate = new CscCalendar(data[0] + "-" + data[1] + "-" + data[2]);
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	public DateProperties(String year,String month,String day){
		try {
			this.setYEAR(Integer.parseInt(year));
			this.setMONTH(Integer.parseInt(month));
			this.setDAY(Integer.parseInt(day));
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	public void setYEAR(int year){
		this.year = year;
	}
	
	public void setMONTH(int month){
		this.month = month;
	}
	
	public void setDAY(int day){
		this.day = day;
	}	
	
	public void setHOUR(int hour){
		this.hour = hour;
	}	
	
	public void setMIN(int min){
		this.min = min;
	}
	
	public void setDayOfWork(int dow){
		this.dayofwork = dow;
	}
	
	public CscCalendar getEndOfYear(){
		CscCalendar cs = new CscCalendar();
		cs.setMonth(11);
		cs.setDate(31);
		return cs ;
	}
	
	public CscCalendar getStartOfYear(){
		CscCalendar cs = new CscCalendar();
		cs.setMonth(0);
		cs.setDate(1);
		return cs ;
	}
	
	/* ӹǳӹǹѹҧѹ */
	public int countDay(String date){
		int day = 0;
		try {
			if(date.equals("ENDOFYEAR")){
				day = this.cdate.countDay(this.getEndOfYear());
			}else if(date.equals("STARTOFYEAR")){
				day = this.cdate.countDay(this.getStartOfYear());
			}else{
				CscCalendar cs = new CscCalendar(date);
				day = this.cdate.countDay(cs);
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return day;
	}
	
	/* ӹǳӹǹѹҧѹ */
	public int countDay(String date, String month, String year){
		CscCalendar cs = new CscCalendar();
		cs.setYear(Integer.parseInt(year));
		cs.setMonth(Integer.parseInt(month));
		cs.setDate(Integer.parseInt(date));
		
		return countDay(cs.getYYYYMMDD());
	}
	
	/* ӹǹѹ㹻չ  */
	public int DaysOfYear(){
		int days = 0;
		CscCalendar tmp = new CscCalendar(this.cdate.getYYYYMMDD());
		tmp.setMonth(1);
		
		return (tmp.getEndDateOfMonth() == 28)?365:366;
	}
}
