package com.csc.library.timeattendance;

import java.util.Vector;

import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;

public class ManageAdjustChangeHoliday {
private UProfile upf ;
	
	public ManageAdjustChangeHoliday(UProfile upf){
		this.upf = upf;
	}
	
	/* ֧š ҧشѾഷ ͹㹵ҧ Tadjtime0 */
	public Vector getAdjustChangeHolidayData(WorkingShift ws,DbRecord empRec){
		Vector vUpdateData = new Vector();
		try {
			/* ֧¹ѹش Vector */
			StringBuffer filter = new StringBuffer();
			filter.append("employeeid = '").append(empRec.getString("employeeid")).append("' and ");
			filter.append(" (");
			filter.append(" (change_date1 >= '").append(ws.getBeginDate().getYYYYMMDD()).append("' and change_date1 <= '").append(ws.getEndDate().getYYYYMMDD()).append("')"); 
			filter.append(" or "); 
			filter.append(" (change_date2 >= '").append(ws.getBeginDate().getYYYYMMDD()).append("' and change_date2 <= '").append(ws.getEndDate().getYYYYMMDD()).append("')");
			filter.append(" )");
	
			DbInquiry inqChHoliday = new InitialInquiry(this.upf).getDbInquiry("TCHHOLIDAY");
			inqChHoliday.setColumn("*");
			inqChHoliday.setOrderBy("runno");
			inqChHoliday.setFilter(filter.toString());
			inqChHoliday.refresh();
			
			while(inqChHoliday.next()){
				vUpdateData.add(inqChHoliday.getCurrentDbRecord().cloneRecord(false));
			}
			
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return vUpdateData;
	}
}
