package com.csc.library.timeattendance;

import com.csc.library.utilities.CscCalendar;

public class PropertiesTimeZone {
	private String StDate,EnDate;
	private float StTime,EnTime,diff;
	private boolean isSet = false;
	public PropertiesTimeZone() {
	}
	
	public void setTimeZone(CscCalendar st , CscCalendar en){
		this.StDate = st.getYYYYMMDD();
		this.EnDate = en.getYYYYMMDD();
		this.StTime = st.getCSCTime();
		this.EnTime = en.getCSCTime();
		this.diff = en.subForHour(st);
		this.isSet = true;
	}
	
	public String getStartDate(){
		return this.StDate;
	}
	
	public String getEndDate(){
		return this.EnDate;
	}
	
	public float getStartTime(){
		return this.StTime;
	}
	
	public float getEndTime(){
		return this.EnTime;
	}
	
	public boolean isSetTimeZone(){
		return this.isSet;
	}
	
	public float getDiffHour(){
		return this.diff;
	}
}
