package com.csc.library.utility;
 
import java.util.HashMap;

import std.library.DataTable;
 
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.UProfile;

public class NTriger{
	private String[] columnName ={"EMPLOYEEID","COMPANYID","DATEID","SEQUENCE","TR_TYPE","LV_TY"};
	private String[] columnType ={"varchar","varchar","varchar","varchar","varchar","varchar"};
	private DataTable  dtbUpdate = new DataTable(columnName,columnType);
	private final int FIRST_SHIFT = 1 ; 
	private final int CURRENT_SHIFT = 2 ; 
	private final int LAST_SHIFT = 3 ; 

    public void triggerPreviousAndNextShift(HashMap hmParam ,UProfile upf){
         try{
    		DbInquiry inq = new InitialInquiry(upf).getDbInquiry();		
 			inq.initMyTable("TTIME_CURRENT1", this.getWhereClause(hmParam,CURRENT_SHIFT,"0") , "EMPLOYEEID, COMPANYID, DATEID, SEQUENCE");
 			inq.setColumn("EMPLOYEEID, COMPANYID, DATEID, SEQUENCE, TR_TYPE,LV_TY,previousshift,nextshift");
 			inq.refresh();
			while (inq.next()) { 
				dtbUpdate.insertRow(1);		
				dtbUpdate.setItem(dtbUpdate.rowCount(), columnName[0], inq.getCurrentDbRecord().getString(columnName[0]));
				dtbUpdate.setItem(dtbUpdate.rowCount(), columnName[1], inq.getCurrentDbRecord().getString(columnName[1]));
				dtbUpdate.setItem(dtbUpdate.rowCount(), columnName[2], inq.getCurrentDbRecord().getString(columnName[2]));
				dtbUpdate.setItem(dtbUpdate.rowCount(), columnName[3], inq.getCurrentDbRecord().getString(columnName[3]));
				dtbUpdate.setItem(dtbUpdate.rowCount(), columnName[4], inq.getCurrentDbRecord().getString(columnName[4]));
				dtbUpdate.setItem(dtbUpdate.rowCount(), columnName[5], inq.getCurrentDbRecord().getString(columnName[5]));
			}//end while  
			
			//to doing...
			int row = 0 ;
			inq.refresh();
			while (inq.next()) { 
				row++;
				String previousShift = "";
				String nextShift ="";
				//check and get data from DataTable
				if (row==1){
					
					DbInquiry inqFirst = new InitialInquiry(upf).getDbInquiry();		
					inqFirst.initMyTable("TTIME_CURRENT1", this.getWhereClause(hmParam,FIRST_SHIFT,"0") , "EMPLOYEEID ASC , COMPANYID ASC , DATEID ASC , SEQUENCE DESC");
					inqFirst.setColumn("EMPLOYEEID, COMPANYID, DATEID, SEQUENCE, TR_TYPE,LV_TY,previousshift,nextshift");
					inqFirst.refresh();
					
					//get previous shift
					if(inqFirst.recCount()==0){
						previousShift = ""; 
					}else{
						inqFirst.next();
						/**
						 *ѹ dateid ѹͧ§ѹӴѺ ⴴ
						 * 1/1/2009
						 *2/1/2009
						 *3/1/2009
						 *4/1/2009 ͧ§ѹẺ ֧ previousShift,nextShift ҧ١ͧش 
						 *ѹⴴ
						 * 1/1/2009
						 *2/1/2009  ѹ nextShift 
						 *4/1/2009 ѹ previousShift 
						 */
						CscCalendar seriesDate1 = new CscCalendar(inqFirst.getCurrentDbRecord().getString("DATEID")).incDate(1);
						CscCalendar seriesDate2 = new CscCalendar(dtbUpdate.getItem(row,"DATEID").toString());
						if(seriesDate1.equalsDate(seriesDate2)){
							if(inqFirst.getCurrentDbRecord().getString("TR_TYPE").substring(0, 1).equals("H")){
								previousShift = inqFirst.getCurrentDbRecord().getString("LV_TY");
							}else{
								previousShift = inqFirst.getCurrentDbRecord().getString("TR_TYPE").substring(0, 1);
							}//end if 
						}//end if 			
					}//end if 
					
					//get next shift
					if(inq.recCount()==1){
						DbInquiry inqLast1 = new InitialInquiry(upf).getDbInquiry();		
						inqLast1.initMyTable("TTIME_CURRENT1", this.getWhereClause(hmParam,LAST_SHIFT,"0") , "EMPLOYEEID ASC , COMPANYID ASC , DATEID ASC , SEQUENCE DESC");
						inqLast1.setColumn("EMPLOYEEID, COMPANYID, DATEID, SEQUENCE, TR_TYPE,LV_TY,previousshift,nextshift");
						inqLast1.refresh();
						if(inqLast1.recCount()==0){
							nextShift = ""; 
						}else{
							inqLast1.next();
							CscCalendar seriesDate13 = new CscCalendar(dtbUpdate.getItem(row,"DATEID").toString()).incDate(1);
							CscCalendar seriesDate14 = new CscCalendar(inqLast1.getCurrentDbRecord().getString("DATEID"));
							if(seriesDate13.equalsDate(seriesDate14)){
								if(inq.getCurrentDbRecord().getString("TR_TYPE").substring(0, 1).equals("H")){
									nextShift = inqLast1.getCurrentDbRecord().getString("LV_TY");
								}else{
									nextShift = inqLast1.getCurrentDbRecord().getString("TR_TYPE").substring(0, 1);
								}//end if 
							}//end if 
						}//end if 
					}else{
						CscCalendar seriesDate3 = new CscCalendar(dtbUpdate.getItem(row,"DATEID").toString()).incDate(1);
						CscCalendar seriesDate4 = new CscCalendar(dtbUpdate.getItem((row+1),"DATEID").toString());
						if(seriesDate3.equalsDate(seriesDate4)){
							if(dtbUpdate.getItem((row+1),"TR_TYPE").toString().substring(0, 1).equals("H")){
								nextShift = dtbUpdate.getItem((row+1),"LV_TY").toString();
							}else{
								nextShift = dtbUpdate.getItem((row+1),"TR_TYPE").toString().substring(0, 1);
							}//end if 
						}//end if 
					}//end if 
					
				}else if(row==inq.recCount()){
					
					DbInquiry inqLast = new InitialInquiry(upf).getDbInquiry();		
					inqLast.initMyTable("TTIME_CURRENT1", this.getWhereClause(hmParam,LAST_SHIFT,"0") , "EMPLOYEEID ASC , COMPANYID ASC , DATEID ASC , SEQUENCE DESC");
					inqLast.setColumn("EMPLOYEEID, COMPANYID, DATEID, SEQUENCE, TR_TYPE,LV_TY,previousshift,nextshift");
					inqLast.refresh();
					
					//get previous shift
					CscCalendar seriesDate5 = new CscCalendar(dtbUpdate.getItem((row-1),"DATEID").toString()).incDate(1);
					CscCalendar seriesDate6 = new CscCalendar(dtbUpdate.getItem(row,"DATEID").toString());
					if(seriesDate5.equalsDate(seriesDate6)){
						if(dtbUpdate.getItem((row-1),"TR_TYPE").toString().substring(0, 1).equals("H")){
							previousShift = dtbUpdate.getItem((row-1),"LV_TY").toString();
						}else{
							previousShift = dtbUpdate.getItem((row-1),"TR_TYPE").toString().substring(0, 1);
						}//end if 
					}//end if 
					
					//get next shift
					if(inqLast.recCount()==0){
						nextShift = ""; 
					}else{
						inqLast.next();
						CscCalendar seriesDate7 = new CscCalendar(dtbUpdate.getItem(row,"DATEID").toString()).incDate(1);
						CscCalendar seriesDate8 = new CscCalendar(inqLast.getCurrentDbRecord().getString("DATEID"));
						if(seriesDate7.equalsDate(seriesDate8)){
							if(inq.getCurrentDbRecord().getString("TR_TYPE").substring(0, 1).equals("H")){
								nextShift = inqLast.getCurrentDbRecord().getString("LV_TY");
							}else{
								nextShift = inqLast.getCurrentDbRecord().getString("TR_TYPE").substring(0, 1);
							}//end if 
						}//end if 
					}//end if 
					
				}else{
					
					//get previous shift
					CscCalendar seriesDate9 = new CscCalendar(dtbUpdate.getItem((row-1),"DATEID").toString()).incDate(1);
					CscCalendar seriesDate10 = new CscCalendar(dtbUpdate.getItem(row,"DATEID").toString());
					if(seriesDate9.equalsDate(seriesDate10)){
						if(dtbUpdate.getItem((row-1),"TR_TYPE").toString().substring(0, 1).equals("H")){
							previousShift = dtbUpdate.getItem((row-1),"LV_TY").toString();
						}else{
							previousShift = dtbUpdate.getItem((row-1),"TR_TYPE").toString().substring(0, 1);
						}//end if 
					}//end if 
	 			
					//get next shift
					CscCalendar seriesDate11 = new CscCalendar(dtbUpdate.getItem(row,"DATEID").toString()).incDate(1);
					CscCalendar seriesDate12 = new CscCalendar(dtbUpdate.getItem((row+1),"DATEID").toString());
					if(seriesDate11.equalsDate(seriesDate12)){
						if(dtbUpdate.getItem((row+1),"TR_TYPE").toString().substring(0, 1).equals("H")){
							nextShift = dtbUpdate.getItem((row+1),"LV_TY").toString();
						}else{
							nextShift = dtbUpdate.getItem((row+1),"TR_TYPE").toString().substring(0, 1);
						}//end if 
					}//end if 
					
				}//end if 
				
				//set data to DbRecord 
				DbRecord dbRecord = inq.getCurrentDbRecord().cloneRecord(true);
				dbRecord.set("previousshift", previousShift);
				dbRecord.set("nextshift", nextShift);
				dbRecord.save();
			}//end if 
			
    	}catch(Exception ex){
    		System.out.print("Error in NTriger.triggerPreviousAndNextShift() "+ ex.getStackTrace());
    	}//end try
    	
    }//end triggerPreviousAndNextShift
 	public String getShift(HashMap hmParam ,UProfile upf,int shiftType,String columnName,String employeeid){
 		String shiftValues = "";
 		String strOrder ="";
 		switch (shiftType){
 			case FIRST_SHIFT:
 				strOrder = "SEQUENCE DESC";
 				break;
 			case CURRENT_SHIFT:
 				strOrder = "SEQUENCE ASC";
 				break;
 			case LAST_SHIFT:
 				strOrder = "SEQUENCE ASC";
 				break;
 		}//end switch 
 		try{
	 		DbInquiry inqShift = new InitialInquiry(upf).getDbInquiry();		
	 		inqShift.initMyTable("TTIME_CURRENT1", this.getWhereClause(hmParam,shiftType,employeeid) , "EMPLOYEEID ASC , COMPANYID ASC , DATEID ASC , "+strOrder);
	 		inqShift.setColumn("EMPLOYEEID, COMPANYID, DATEID, SEQUENCE, TR_TYPE,EVENTGRP,previousshift,nextshift");
	 		inqShift.refresh();
			
			if(inqShift.recCount()==0){
				shiftValues = "X"; 
			}else{
				inqShift.next();
				if(inqShift.getCurrentDbRecord().getString("DOCTYPE").equals("A")){
					shiftValues  = "A";
				}else{
 					if(columnName.equals("TR_TYPE")){
						shiftValues = inqShift.getCurrentDbRecord().getString("TR_TYPE").substring(0, 1);
					}else if(columnName.equals("EVENTGRP")){
						shiftValues = inqShift.getCurrentDbRecord().getString("EVENTGRP");
					}//end if 	
				}//end if	  
			}//end if 
 		}catch(Exception ex){
 			System.out.print("Error in NTriger.getShift() " +ex.getStackTrace());
 		}//end try
 		
 		return shiftValues;
 	}//end getFirstShift
 	
    private String getWhereClause(HashMap hmParam , int forType,String employeeid){
		StringBuffer whereClause  = new StringBuffer(" 1=1 ");
		String stDate=""; //ѹӡûż
		String endDate =""; //ѹӡûż
		
		switch (forType){
			case FIRST_SHIFT://ǧš͹ش ͧŷͧ previousshift Тͧѹá
				stDate =  new CscCalendar(hmParam.get("startDate").toString()).decDate(1).getYYYYMMDD() ;
				endDate =   stDate;
				break;
			case CURRENT_SHIFT://ǧŷͧ
				stDate =  hmParam.get("startDate").toString() ;
				endDate =   hmParam.get("endDate").toString();
				break;	
			case LAST_SHIFT://ǧѧش ͧŷͧ nextshift Тͧѹش
				endDate =  new CscCalendar(hmParam.get("endDate").toString()).incDate(1).getYYYYMMDD() ;
				stDate =endDate;
				break;
			default:break;
		}//end switch

		//===============================================
		if ((stDate==null || stDate.equals("")) && (endDate==null || endDate.equals("")) ){
			//к stDate,endDate 
			stDate = new CscCalendar().getYYYYMMDD();
			endDate = new CscCalendar().getYYYYMMDD();
		}else if ((stDate!=null || !stDate.equals("")) && (endDate==null || endDate.equals("")) ){
			//к stDate
			stDate = new CscCalendar(stDate).getYYYYMMDD();
			endDate = new CscCalendar(stDate).getYYYYMMDD();
		}else if ((stDate==null || stDate.equals("")) && (endDate!=null || !endDate.equals("")) ){
			//к endDate
			stDate = new CscCalendar(endDate).getYYYYMMDD();
			endDate = new CscCalendar(endDate).getYYYYMMDD();
		}else if ((stDate!=null || !stDate.equals("")) && (endDate!=null || !endDate.equals("")) ){
			//к stDate,endDate 駤
			if(new CscCalendar(stDate).equalsDate(new CscCalendar(endDate)) || 
				new CscCalendar(stDate).beforeDate(new CscCalendar(endDate))){
				// ѹ <= ѹش
				stDate = new CscCalendar(stDate).getYYYYMMDD();
				endDate = new CscCalendar(endDate).getYYYYMMDD();
			}else{
				//кѹش > ѹ 
				stDate = new CscCalendar(endDate).getYYYYMMDD();
				endDate = new CscCalendar(stDate).getYYYYMMDD();
			}//end if 
		}//end if 
		//===============================================
		
		whereClause.append(" and ttime_current1.dateid >= '"+stDate+"' ");
		whereClause.append(" and ttime_current1.dateid <= '"+endDate+"' ");
		whereClause.append(" and ttime_current1.employeeid = '"+employeeid+"' ");
		 
		return whereClause.toString();
	}//end getWhereClause
   
}//end class NTriger
