package com.csc.library.databean;

import com.csc.library.utilities.MyLog;
import com.csc.library.database.DataSet;
import com.csc.library.database.MyHashMap;
import com.csc.library.database.StaticConfig;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscTime;

/*
 * 㹡ʴӹǹ边ѡҹͺ 1 
 * Ѻʡ Ҩҡ˹Ҩ
 */
public class Mempl_late_yearsummary extends Memployee {
	
	MyHashMap hmDataMonth = new MyHashMap();
	
	public int assignField(DataSet rs) {
		int temp = super.assignField(rs);
		if (!this.getString("employeeid").equalsIgnoreCase("")) {
			this.initDataColunm(this.hmDataMonth);
			this.setData();
						
			MyLog.debug(this, "MONTH DATA==="+this.hmDataMonth);
		}
		return temp;
    }
	
	/*
	 * ˹͹
	 */
	private void initDataColunm(MyHashMap hm) {
		CscCalendar cscStart = new CscCalendar((String) this.param.get("STARTDATE"));
		CscCalendar cscEnd = new CscCalendar((String) this.param.get("ENDDATE"));
		
		int m = Integer.parseInt(cscStart.getMM());
		int i=1;
		while (i<=12) {
			String id = String.valueOf(i);
			CscCalendar csc = new CscCalendar("01-"+id+"-"+cscStart.getYear());
            this.hmDataMonth.put("col"+id+"_name",csc.getEngShortMonth());
			if (this.getUProfile().get("lang").equals("THA")){
	            this.hmDataMonth.put("col"+id+"_name",csc.getThaiShortMonth());			    
			}
			this.hmDataMonth.put("col"+id+"_used",new Double(0));
			this.hmDataMonth.put("col"+id+"_count",new Integer(0));
			i++;
		}	
		this.hmDataMonth.put("used_total",new Double(0));
		this.hmDataMonth.put("count_total",new Integer(0));
	}
	
	/*
	 * ӡúǡӹǹ边ѡҹ ¡͹ӹǹ 1 
	 * Ѻʡ Ҩҡ˹Ҩ
	 * ҢҨҡ Mempl_leave_total
	 */
	private void setData() {
		try {
			/*
			 * DayType = 7		Vacation
			 * DayType = LT		Late
			 * DayType other 	Leave  
			 */
			CscCalendar cscStart = new CscCalendar((String) this.param.get("STARTDATE"));
			CscCalendar cscEnd = new CscCalendar((String) this.param.get("ENDDATE"));
			String leave = (String) this.param.get("LEAVETYPE");
			
			//CscCalendar cscLeaveStart = new CscCalendar(StaticConfig.getConfigCompany(this.userPro, "ta1001"));
			//CscCalendar cscLeaveEnd = new CscCalendar(StaticConfig.getConfigCompany(this.userPro, "ta1002"));
								
			String filter = "employeeid='"+this.getString("employeeid")+"'" +
				" and ((monthid>="+Integer.parseInt(cscStart.getMM())+" " +
				" and yearid>="+cscStart.getYear()+") " +
				" or (monthid<="+Integer.parseInt(cscEnd.getMM())+" " +
				" and yearid<="+cscEnd.getYear()+"))" +
				" and day_type='"+leave+"'";
			DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry();			
			inq.setSchemaName(this.userPro.getSchemaName());						
			inq.initMyTable("Mempl_leave_total", filter, "");
			inq.setColumn("*");
			inq.refresh();
			while (inq.next()) {
				DbRecord rec = inq.getCurrentDbRecord();
				String id = "col"+rec.getInt("MONTHID");
				if (this.hmDataMonth.containsKey(id+"_name")) {
					int count = this.hmDataMonth.getInt(id+"_count");
					float used = this.hmDataMonth.getFloat(id+"_used");
					count = rec.getInt("DAY_COUNT") + count;
					CscTime ct = new CscTime(used);
					ct.add(rec.getFloat("DAY_USED"));
					used = ct.getFloat();
					
					this.hmDataMonth.put(id+"_used", new Float(used));
					this.hmDataMonth.put(id+"_count", new Integer(count));
				}			
				
				//ӡúǡ駻
				int count_total = this.hmDataMonth.getInt("count_total");
				float used_total = this.hmDataMonth.getFloat("used_total");
				count_total = rec.getInt("DAY_COUNT") + count_total;
				CscTime ct = new CscTime(used_total);
				ct.add(rec.getFloat("DAY_USED"));
				used_total = ct.getFloat();
				
				this.hmDataMonth.put("count_total", new Integer(count_total));
				this.hmDataMonth.put("used_total", new Float(used_total));
			}			
			
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
	}
	
	public String getString(String fieldName) {		
		if (fieldName.indexOf("$") > 0) {
			return this.getStringChild(fieldName);
		} else {
			return super.getString(fieldName);
		}
	}
	
	private String getStringChild(String fieldName) {
		if (fieldName.indexOf("$") > 0) {
			String tName = fieldName.substring(0, fieldName.indexOf("$"));
			String fName = fieldName.substring(fieldName.indexOf("$") + 1, fieldName.length());
			if (this.hmDataMonth.get(fName) != null) {
				return this.hmDataMonth.getString(fName);
			} else super.getString(fieldName);
		}
		return super.getString(fieldName);
	}
}
