package com.csc.library.databean;

import java.text.DecimalFormat;

import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;

public class Memployee_ta extends Memployee {
	
	/*
	 * ŧѹҾѡ͹ٻ 0, 0.5
	 * к DD:HH:SS
 	*/
	public String getString(String fieldName) {   
		try {
			if(fieldName.indexOf(".") > -1){	/* óշٵͷ¡Ҩҡ table 蹷١Ѻ employee  ҧ emp.getString("MJOBCODE.JOBGRADEID") */
	     		String table = fieldName.substring(0,fieldName.indexOf("."));
	     		String field = fieldName.substring(fieldName.indexOf(".")+1);
	     		
	     		DbRecord db = new InitialRecord(this.userPro).getDbRecord(table);
	     		db.setColumn("*");
	     		
	     		this.putChild(db);
	     		this.refreshChild();
	     		
	     		if(this.foundData()){	/*  */
	     			return this.getChild(table).getString(field);
	     		}
	     	} else {	/* ¡Ŵ컡㹵ҧ memployee */
	     		return super.getString(fieldName);
	     	}
		}catch(Exception e){
			MyLog.error(this,e);
		}
     	return "";
     }
	
	/* Ѻʡ ͧѡҹѹ  觵ͧҨҡ MTime2 öʡз Table Memployee  */
	public String getDailyTime0id(CscCalendar date){
		String time0id = "";
		try {
			String actime0 = getActualTime0(date) ;
	    	DbRecord timeRec = new InitialRecord(this.userPro).getDbRecord("MTIME0"); 
	    	timeRec.set("time0id",actime0);
	    	timeRec.set("companyid",this.getString("companyid"));
	    	timeRec.setColumn("*");
	    	if (timeRec.search() == 1){
	    		if(timeRec.getString("status").equals("1")){ /* 繵ҧ ͧҵ MTime2 ѹèʡ */
		        	DbRecord time2 = new InitialRecord(this.userPro).getDbRecord("MTIME2");
		        	time2.set("time0id", actime0);
		        	time2.set("monthid", date.getCurrentMonth());
		        	time2.set("yearid", date.getYear());
		        	time2.set("companyid", this.getString("companyid"));
		        	time2.setColumn("*");
		        	
		        	if(time2.search() == 1){
		        		/* ֧ʡ ѹͧ͹ 㹪ͧʡЪͧá (˹ѹ 3  軡Ԩͧá )*/
		        		DecimalFormat df = new DecimalFormat("00");
		        		time0id = time2.getString("time" + df.format(date.getDate()) + '1');
		        	} else {
		        		MyLog.error("!! Error : can't get time0id from MTIME2 !!");
		        	}
	    		} else { /* 繵ҧ÷ӧҹ ʹ*/
	    			time0id = timeRec.getString("time0id");
	    		}
	    	}
		}catch(Exception e){
			MyLog.error("!! Error : Can't get time0id from employeeid --> " + this.getString("employeeid"));
		}
		return time0id;
	}
	
	/* find time0 history */
	private String getActualTime0(CscCalendar date){
		String actime0 =  this.getString("time0") ;
		try {
			DbInquiry inq = new InitialInquiry(this.userPro).getDbInquiry("Mempl_time0trans");
			inq.setColumn("*");
			inq.setFilter("employeeid = '" + this.getString("employeeid") + "'");
			inq.refresh();
			
			while(inq.next()){
				CscCalendar st = new CscCalendar(inq.getString("start_date"));
				CscCalendar en = new CscCalendar(inq.getString("end_date"));
				if(date.afterEqualsDate(st) && date.beforeEqualsDate(en)){
					actime0 = inq.getString("time0id");
					break ;
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return actime0 ;
	}
	
	/* Ѻʡ ͧѡҹѹ  觵ͧҨҡ MTime2 öʡз Table Memployee  */
	public String getDailyTime0id(String time0, CscCalendar date){
		String time0id = "";
		try {
	    	DbRecord timeRec = new InitialRecord(this.userPro).getDbRecord("MTIME0"); 
	    	timeRec.set("time0id", time0);
	    	timeRec.set("companyid",this.getString("companyid"));
	    	timeRec.setColumn("*");
	    	if (timeRec.search() == 1){
	    		if(timeRec.getString("status").equals("1")){ /* 繵ҧ ͧҵ MTime2 ѹèʡ */
		        	DbRecord time2 = new InitialRecord(this.userPro).getDbRecord("MTIME2");
		        	time2.set("time0id", this.getString("time0"));
		        	time2.set("monthid", date.getCurrentMonth());
		        	time2.set("yearid", date.getYear());
		        	time2.set("companyid", this.getString("companyid"));
		        	time2.setColumn("*");
		        	
		        	if(time2.search() == 1){
		        		/* ֧ʡ ѹͧ͹ 㹪ͧʡЪͧá (˹ѹ 3  軡Ԩͧá )*/
		        		DecimalFormat df = new DecimalFormat("00");
		        		time0id = time2.getString("time" + df.format(date.getDate()) + '1');
		        	} else {
		        		MyLog.error("!! Error : can't get time0id from MTIME2 !!");
		        	}
	    		} else { /* 繵ҧ÷ӧҹ ʹ*/
	    			time0id = timeRec.getString("time0id");
	    		}
	    	}
		}catch(Exception e){
			MyLog.error("!! Error : Can't get time0id from employeeid --> " + this.getString("employeeid"));
		}
		return time0id;
	}
}
