package com.csc.library.databean;

import java.util.HashMap;
import java.util.Iterator;
import java.util.List;

import org.jdom.Attribute;
import org.jdom.Element;

import com.csc.library.database.DataSet;
import com.csc.library.database.MyHashMap;
import com.csc.library.databean.Memployee;
import com.csc.library.formula.FormulaString;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscTime;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.ReadXml;
import com.csc.library.utility.DiffTime;

/*
 * 㹡 ӹǳšҷӧҹШ͹ͧ KKB
 * ͹дǡ Ǵ㹡͡§ҹ
 * ·ӡûż͹ ͹͡§ҹǢ
 */
public class Memployee_working_summary extends Memployee {
	
	private MyHashMap hmLeave = null;
	private MyHashMap hmTime = null;
	private DbInquiry inqCurrent1 = null;
	private DbInquiry inqHistory1 = null;
	private DbInquiry inqTime = null;
	private CscCalendar cs = null;
	private DbRecord recSave = null; 
	
	/* Variable For Save*/
	private CscTime working_hour = new CscTime();
	private double working_day = 0;
	private CscTime late_hour = new CscTime();
	private int late_day = 0;
	private int notSwipe = 0;
	private CscTime leave1 = new CscTime();
	private CscTime leave2 = new CscTime();
	private CscTime leave3 = new CscTime();
	private CscTime leave4 = new CscTime();
	private CscTime leave5 = new CscTime();
	private CscTime leave_other = new CscTime();
	private double l1 = 0;  
	private double l2 = 0;
	private double l3 = 0;
	private double l4 = 0;
	private double l5 = 0;
	private double l_other = 0;
	private boolean isLoad = true;
	private FormulaString fs = new FormulaString();
	private double lateOver = 0; //ӹǹѹ Ҵҹ [Թ]
	private double absent = 0; //ӹǹѹ Ҵҹ [ŧ]
	
	/*public int assignField(DataSet rs) {
		int temp = super.assignField(rs);
		if (!this.getString("employeeid").equalsIgnoreCase("")) {
			this.cs = new CscCalendar("01-04-2007");
			if (this.isLoad) {
				this.initLeaveColumn();
			}
			this.setData();
			
			MyLog.debug("=============================");
			MyLog.debug("RESULT: "+this.getString("employeeid"));
			MyLog.debug("WORK HOUR : "+working_hour.getFloat());
			MyLog.debug("WORK DAY : "+working_day);
			MyLog.debug("LATE HOUR : "+late_hour.getFloat());
			MyLog.debug("LATE DAY : "+late_day);
			MyLog.debug("NOT SWIPE : "+notSwipe);
			MyLog.debug("LEAVE 1 : "+l1+" : "+leave1.getFloat());
			MyLog.debug("LEAVE 2 : "+l2+" : "+leave2.getFloat());
			MyLog.debug("LEAVE 3 : "+l3+" : "+leave3.getFloat());
			MyLog.debug("LEAVE 4 : "+l4+" : "+leave4.getFloat());
			MyLog.debug("LEAVE 5 : "+l5+" : "+leave5.getFloat());
			MyLog.debug("LEAVE OTHER : "+l_other+" : "+leave_other.getFloat());
			MyLog.debug("STICKTM : "+this.getSwipeType());
			MyLog.debug("AVG : "+working_hour.getFloat()/(working_day+notSwipe));
			MyLog.debug("=============================");
			
			this.saveData();
			this.isLoad = false;
		}
		return temp;
    }*/

	public void calculate() {
		if (!this.getString("employeeid").equalsIgnoreCase("")) {
			this.cs = new CscCalendar((String) this.param.get("processDate"));
			if (this.isLoad) {
				this.initLeaveColumn();
			}
			this.clearDataValue();
			this.setData();
			
			MyLog.debug("=============================");
			MyLog.debug("RESULT: "+this.getString("employeeid"));
			MyLog.debug("WORK HOUR : "+working_hour.getFloat());
			MyLog.debug("WORK DAY : "+(working_day+lateOver));
			MyLog.debug("LATE HOUR : "+late_hour.getFloat());
			MyLog.debug("LATE DAY : "+late_day);
			MyLog.debug("NOT SWIPE : "+notSwipe);
			MyLog.debug("LATE OVER : "+lateOver);
			MyLog.debug("ABSENT : "+absent);
			MyLog.debug("LEAVE 1 : "+l1+" : "+leave1.getFloat());
			MyLog.debug("LEAVE 2 : "+l2+" : "+leave2.getFloat());
			MyLog.debug("LEAVE 3 : "+l3+" : "+leave3.getFloat());
			MyLog.debug("LEAVE 4 : "+l4+" : "+leave4.getFloat());
			MyLog.debug("LEAVE 5 : "+l5+" : "+leave5.getFloat());
			MyLog.debug("LEAVE OTHER : "+l_other+" : "+leave_other.getFloat());
			MyLog.debug("STICKTM : "+this.getSwipeType());
			//MyLog.debug("AVG : "+working_hour.getFloat()/(working_day+notSwipe));
			MyLog.debug("=============================");
			
			this.saveData();
			this.isLoad = false;
		}
	}
	
	/*
	 * ӡҹʡҨҡ xml ˹  5 
	 */
	private void initLeaveColumn() {
		this.hmLeave = new MyHashMap();
		try {
			InitialEnvironment en = new InitialEnvironment("GLOBAL");
			String xmlPath = en.getValue("import-dir");
			String xmlName = "LEAVE_CODE.xml";
			
			ReadXml r = new ReadXml(xmlPath +"XML/"+ xmlName);
			Element root = r.getRootElement();
			List list = root.getChildren();
			Iterator it = list.iterator();			
			while (it.hasNext()) {
				Element obj = (Element) it.next();
				this.hmLeave.put(obj.getText(), obj.getAttributeValue("name"));
				//this.hmLeave.put("01", "L_COL01");
			}
			/*this.hmLeave.put("01", "L_COL01");
			this.hmLeave.put("02", "L_COL02");
			this.hmLeave.put("03", "L_COL03");
			this.hmLeave.put("04", "L_COL04");
			this.hmLeave.put("05", "L_COL05");*/
		} catch (Exception e) {
			MyLog.error(this, e);
			this.hmLeave.put("01", "");
			this.hmLeave.put("02", "");
			this.hmLeave.put("03", "");
			this.hmLeave.put("04", "");
			this.hmLeave.put("05", "");
		}
	}
	
	/* 
	 *ӡ clear ҵҧ
	 */
	private void clearDataValue() {
		this.working_hour.setHour(0);
		this.working_hour.setMinute(0);
		this.working_day = 0;
		this.late_hour = new CscTime();
		this.late_day = 0;
		this.notSwipe = 0;
		this.leave1.resetTime();;
		this.leave2.resetTime();
		this.leave3.resetTime();
		this.leave4.resetTime();
		this.leave5.resetTime();	
		this.leave_other.resetTime();
		this.l1 = 0;  
		this.l2 = 0;
		this.l3 = 0;
		this.l4 = 0;
		this.l5 = 0;
		this.l_other = 0;
		this.absent = 0;
		this.lateOver = 0;
	}
	
	private void setDataValue(DbRecord rec, String tmp_csc, int i) {
		try {
			//MyLog.debug(rec.getString("dateid") + ", EVENTGRP:"+rec.getString("eventgrp")+":"+rec.getString("m_lv")+
			//		" ,FORGET:"+rec.getString("forget_in")+":"+rec.getString("forget_out"));
			
			CscCalendar csc = new CscCalendar(rec.getString("dateid"));
			
			/*working_hour.add(rec.getFloat("hour_d"));
			working_hour.add(rec.getFloat("ac_ot"));*/
			CscCalendar break_in = new CscCalendar(rec.getString("dt_breakin"));
			break_in.setCSCTime(rec.getFloat("tm_breakin"));
			CscCalendar break_out = new CscCalendar(rec.getString("dt_breakout"));
			break_out.setCSCTime(rec.getFloat("tm_breakout"));
			
			CscCalendar time_in = new CscCalendar(rec.getString("m_dt_bg"));
			time_in.setCSCTime(rec.getFloat("m_tm_bg"));
			CscCalendar time_out = new CscCalendar(rec.getString("m_dt_en"));
			time_out.setCSCTime(rec.getFloat("m_tm_en"));	
			
			CscCalendar com_in = new CscCalendar(rec.getString("c_dt_bg"));
			com_in.setCSCTime(rec.getFloat("c_tm_bg"));
			CscCalendar com_out = new CscCalendar(rec.getString("c_dt_en"));
			com_out.setCSCTime(rec.getFloat("c_tm_en"));	
			
			DiffTime dt = new DiffTime();
			working_hour.add(dt.TimeOutDiffTimeIn(time_in, time_out, break_in, break_out)); 
						
			if (i==1) {
				tmp_csc = csc.getYYYYMMDD();
			}
			
			//System.out.println("==>"+rec.getString("dateid")+" ==>"+rec.getString("eventgrp")+" > "
			//		+rec.getString("hour_d")+" : "+(rec.getFloat("hour_s")/rec.getFloat("hour_d")));
			//if (rec.getString("eventgrp").equals("T") && (!tmp_csc.equals(csc.getYYYYMMDD()) || i==1)) {
			if (rec.getString("eventgrp").equals("T")) {
				if ((rec.getFloat("hour_d")/rec.getFloat("hour_s"))<=0.5) {
					working_day += 0.5;
				} else working_day += 1;
			}						
			
			if (rec.getFloat("lt")>0) {
				late_hour.add(rec.getFloat("lt"));
				late_day++;
			}
			
			if (rec.getString("forget_in").equals("1") || rec.getString("forget_out").equals("1")) {
				notSwipe++;
				if (rec.getFloat("m_lv")==rec.getFloat("hour_s")) {
					absent++;
				} else absent += 0.5;
			} else {
				if (rec.getString("eventgrp").equals("J")) {					
					/*if (rec.getFloat("m_lv")==rec.getFloat("hour_s")) {
						lateOver++;
					} else lateOver += 0.5;*/
					if (com_out.subForHour(com_in)>4) {
						lateOver++;
					} else lateOver += 0.5;
				}
			}
			
			if (rec.getFloat("m_lv")>0 && (!rec.getString("eventgrp").equals("J") && !rec.getString("eventgrp").equals("T"))) {
				if (this.hmLeave.containsKey(rec.getString("eventgrp"))) {
					String col = this.hmLeave.getString(rec.getString("eventgrp"));
					if (col.equals("L_COL01")) {
						leave1.add(rec.getFloat("m_lv"));
						if (rec.getFloat("m_lv")==rec.getFloat("hour_s")) {
							l1++;
						} else l1 += 0.5; 
					} else if (col.equals("L_COL02")) {
						leave2.add(rec.getFloat("m_lv"));
						if (rec.getFloat("m_lv")==rec.getFloat("hour_s")) {
							l2++;
						} else l2 += 0.5; 
					} else if (col.equals("L_COL03")) {
						leave3.add(rec.getFloat("m_lv"));
						if (rec.getFloat("m_lv")==rec.getFloat("hour_s")) {
							l3++;
						} else l3 += 0.5; 
					} else if (col.equals("L_COL04")) {
						leave4.add(rec.getFloat("m_lv"));
						if (rec.getFloat("m_lv")==rec.getFloat("hour_s")) {
							l4++;
						} else l4 += 0.5; 
					} else if (col.equals("L_COL05")) {
						leave5.add(rec.getFloat("m_lv"));
						if (rec.getFloat("m_lv")==rec.getFloat("hour_s")) {
							l5++;
						} else l5 += 0.5; 
					}		
				} else {
					leave_other.add(rec.getFloat("m_lv"));
					if (rec.getFloat("m_lv")>=rec.getFloat("hour_s")) {
						l_other++;
					} else l_other += 0.5; 
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);
		}	
	}
	
	private void setData() {
		try {
			//CscCalendar c1 = new CscCalendar(this.cs.getYYYYMMDD());
			CscCalendar c1 = new CscCalendar("01-"+this.cs.getMM()+"-"+this.cs.getYear());
			CscCalendar c2 = new CscCalendar(this.cs.getEndDateOfMonth()+"-"+this.cs.getMM()+"-"+this.cs.getYear());
								
			int i=1;
			String tmp_csc="";			
			if (this.inqCurrent1 == null) {
				this.inqCurrent1 = new InitialInquiry(this.getUProfile()).getDbInquiry();
				this.inqCurrent1.setSchemaName(this.getUProfile().getSchemaName());
				this.inqCurrent1.initMyTable("Ttime_current1","", "");
				this.inqCurrent1.setColumn("*");
			}
			this.inqCurrent1.setFilter("employeeid='"+this.getString("employeeid")+"' and " +
					"(dateid between '"+c1.getYYYYMMDD()+"' and '"+c2.getYYYYMMDD()+"')");
			this.inqCurrent1.refresh();
			while (this.inqCurrent1.next()) {
				DbRecord rec = this.inqCurrent1.getCurrentDbRecord();
				CscCalendar csc = new CscCalendar(rec.getString("dateid"));
				this.setDataValue(rec, tmp_csc, i);
				i++;
				tmp_csc = csc.getYYYYMMDD();
			}
			
			i=1;
			tmp_csc="";			
			if (this.inqHistory1 == null) {
				this.inqHistory1 = new InitialInquiry(this.getUProfile()).getDbInquiry();
				this.inqHistory1.setSchemaName(this.getUProfile().getSchemaName());
				this.inqHistory1.initMyTable("Ttime_history1","", "");
				this.inqHistory1.setColumn("*");
			}
			this.inqHistory1.setFilter("employeeid='"+this.getString("employeeid")+"' and " +
					"(dateid between '"+c1.getYYYYMMDD()+"' and '"+c2.getYYYYMMDD()+"')");
			this.inqHistory1.refresh();
			while (this.inqHistory1.next()) {
				DbRecord rec = this.inqHistory1.getCurrentDbRecord();
				CscCalendar csc = new CscCalendar(rec.getString("dateid"));
				this.setDataValue(rec, tmp_csc, i);
				i++;
				tmp_csc = csc.getYYYYMMDD();
			}					
		} catch (Exception e) {
			MyLog.error(this, e);
		}		
	}
	
	private void saveData() {
		try {
			if (this.recSave==null) {
				this.recSave = new InitialRecord(this.userPro).getDbRecord("TWORKING_SUMMARY");
				this.recSave.setColumn("*");
			}
			String swipeType = this.getSwipeType(); 
			this.recSave.clearField();
			this.recSave.set("EMPLOYEEID", this.getString("employeeid"));
			this.recSave.set("COMPANYID", (String) this.userPro.get("companyid"));
			this.recSave.set("MONTHID", Integer.parseInt(this.cs.getMM()));
			this.recSave.set("YEARID", this.cs.getYear());
			this.recSave.set("WORKING_DAY", (working_day+lateOver));
			this.recSave.set("WORKING_HOUR", working_hour.getFloat());
			this.recSave.set("NOTSWIPE", notSwipe);
			this.recSave.set("LATE_DAY", late_day);
			this.recSave.set("LATE_HOUR", late_hour.getFloat());
			if ((working_day+notSwipe)>0 && !swipeType.equals("N")) {
				//this.recSave.set("WORKING_AVG", working_hour.getFloat()/(working_day+notSwipe));
				String result = String.valueOf(working_hour.getFloat()/(working_day+absent+lateOver));
				if (result.indexOf(".")>-1) {
					String h = result.substring(0, result.indexOf("."));
					String m = result.substring(result.indexOf(".")+1, result.length());
					if (m.length()>2) m = m.substring(0,2); 
					if (Double.parseDouble(m)>0) {
						int mm = (int) (Double.parseDouble(m)*60)/100;
						if (mm<10) {
							this.recSave.set("WORKING_AVG", h+".0"+m);
						} else {
							this.recSave.set("WORKING_AVG", h+"."+mm);
						}
					} else this.recSave.set("WORKING_AVG", h+".0"+m);
				} else this.recSave.set("WORKING_AVG", result);
				
			} else {
				this.recSave.set("WORKING_AVG", 0.00);
				this.recSave.set("WORKING_DAY", 0);
				this.recSave.set("WORKING_HOUR", 0);
				this.recSave.set("NOTSWIPE", 0);
				this.recSave.set("LATE_DAY", 0);
				this.recSave.set("LATE_HOUR", 0);
			}
			this.recSave.set("LEAVE1", l1);
			this.recSave.set("LEAVE2", l2);
			this.recSave.set("LEAVE3", l3);
			this.recSave.set("LEAVE4", l4);
			this.recSave.set("LEAVE5", l5);
			this.recSave.set("LEAVE_OTHER", l_other);			
			this.recSave.set("SWIPETYPE", swipeType);
			this.recSave.set("TIME0", this.getString("time0"));
			this.recSave.set("BU1", this.getString("bu1"));
			this.recSave.set("BU2", this.getString("bu2"));
			this.recSave.set("BU3", this.getString("bu3"));
			this.recSave.set("BU4", this.getString("bu4"));
			this.recSave.set("BU5", this.getString("bu5"));
			this.recSave.set("BRANCH", this.getString("branch"));
			this.recSave.set("EMP_GROUP", this.getString("EMP_GROUP"));
			this.recSave.set("EMP_POSITION", this.getString("EMP_POSITION"));
			this.recSave.set("SALATYPE", this.getString("SALATYPE"));
			this.recSave.set("WORKAREA", this.getString("WORKAREA"));
			this.recSave.set("BOSSID", this.getString("BOSSID"));
			this.recSave.save();
		} catch (Exception e) {
			MyLog.error(this, e);
		}		
	}
	
	/*
	 * ֧ٴѵҨҡҧ÷ӧҹ
	 *   ͧӹǳ Фʹҡ÷ӧҹ
	 * ͧż ÷ӧҹ 
	 */
	private String getSwipeType() {
		String result = "";
		try {
			if (this.hmTime == null) {
				this.hmTime = new MyHashMap();
			}
			
			if (!this.hmTime.containsKey(this.getString("time0"))) {
				if (this.inqTime == null) {
					this.inqTime = new InitialInquiry(this.getUProfile()).getDbInquiry();
					this.inqTime.setSchemaName(this.getUProfile().getSchemaName());
					this.inqTime.initMyTable("Mtime0","", "");
					this.inqTime.setColumn("time0id, companyid, sticktm");
				}
				this.inqTime.setFilter("time0id='"+this.getString("time0")+"'");
				this.inqTime.refresh();
				if (this.inqTime.next()) {
					this.hmTime.put(this.inqTime.getString("time0id"), this.inqTime.getString("sticktm"));
					return this.inqTime.getString("sticktm");
				}
			} else return this.hmTime.getString(this.getString("time0"));
		} catch (Exception e) {
			MyLog.error(this, e);
		}
		return result;
	}
}
