package com.csc.library.databean;

import com.csc.library.utilities.MyLog;
import com.csc.library.database.ChildManager;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;

/*
 * ˹Ҩ͵ҧ÷ӧҹ
 * ͷӡҧҧ÷ӧҹ 7 ѹ  - 
 */
public class Simtime0 extends Mtime0 {

	public Simtime0() {
		super();
		this.setActualName("Simtime0");
	}

	public int putChild(ChildManager oChild) {
		int point = super.putChild(oChild);
		int lineno = 1;

		try {
			if ((oChild instanceof DbTable) && (oChild.getTableName().equalsIgnoreCase("MTIME1"))) {
				DbTable dbTable = (DbTable) oChild;
				for (int i = 0; i < 7; i++) {
					int j = i + 1;
					DbRecord rec = dbTable.getNewRecord();
					rec.set("TIME0ID", this.getString("TIME0ID"));
					rec.set("DAYWEEKID", j);
					rec.set("COMPANYID", this.getUProfile().get("companyid"));
					rec.set("STOPDAY", 0);
					rec.set("HOUR_D", "0.00");
					rec.set("TIMEIN1", "0.00");
					rec.set("TIMEIN2", "0.00");
					rec.set("TIMEOUT1", "0.00");
					rec.set("TIMEOUT2", "0.00");
					rec.set(dbTable.getMinorKey(), lineno++);
					dbTable.putNewRecord(rec);
				}
			}
		} catch (Exception ex) {
			MyLog.error(this, ex);			
		}
		return point;
	}
	
	/*protected void postInsertTrigger() throws Exception {
		super.postInsertTrigger();
		try {
			DbTable dbTable = (DbTable) this.getChild("mtime1");
			dbTable.first();
			do {
				DbRecord rec = dbTable.getCurrentRecordManager();
				rec.set("STOPDAY", 0);
				rec.set("HOUR_D", "0.00");
				rec.set("TIMEIN1", "0.00");
				rec.set("TIMEIN2", "0.00");
				rec.set("TIMEOUT1", "0.00");
				rec.set("TIMEOUT2", "0.00");
				dbTable.next();
			} while (!dbTable.eof());
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	protected void postUpdateTrigger() throws Exception {
		super.postUpdateTrigger();
		try {
			DbTable dbTable = (DbTable) this.getChild("mtime1");
			dbTable.first();
			do {
				DbRecord rec = dbTable.getCurrentRecordManager();
				rec.set("STOPDAY", 0);
				rec.set("HOUR_D", "0.00");
				rec.set("TIMEIN1", "0.00");
				rec.set("TIMEIN2", "0.00");
				rec.set("TIMEOUT1", "0.00");
				rec.set("TIMEOUT2", "0.00");
				dbTable.next();
			} while (!dbTable.eof());
		} catch (Exception e) {
			e.printStackTrace();
		}
	}*/

}