package com.csc.library.databean;

import com.csc.library.utilities.MyLog;
import java.util.HashMap;
import java.util.Iterator;

import com.csc.library.database.MyHashMap;
import com.csc.library.session.DbRecord;
import com.csc.library.session.DbTable;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.InitialTable;

public class Tot_m_date0_wf extends Tot_m_date0 {

    private MyHashMap hm=new MyHashMap();
    
    public Tot_m_date0_wf() {
        super();
    }
    
    public boolean set(String field, String data) {
        boolean chk=false;
        if(field.toUpperCase().indexOf("CHK")>-1 && data.equals("1")){
        	MyHashMap hmData = new MyHashMap();
        	hm.put(field.substring(3, field.length()), hmData);        
        } else if (field.toUpperCase().indexOf("START_DATE")>-1) {
        	String id = field.substring(10, field.length());
        	if (this.hm.containsKey(id)) {
        		MyHashMap hmData = (MyHashMap) hm.get(id);
        		hmData.put("START_DATE", data);
        		this.hm.put(id, hmData);
        	}
        } else if (field.toUpperCase().indexOf("START_TIME")>-1) {
        	String id = field.substring(10, field.length());
        	if (this.hm.containsKey(id)) {
        		MyHashMap hmData = (MyHashMap) hm.get(id);
        		hmData.put("START_TIME", data);
        		this.hm.put(id, hmData);
        	}
        } else if (field.toUpperCase().indexOf("END_DATE")>-1) {
        	String id = field.substring(8, field.length());
        	if (this.hm.containsKey(id)) {
        		MyHashMap hmData = (MyHashMap) hm.get(id);
        		hmData.put("END_DATE", data);
        		this.hm.put(id, hmData);
        	}
        } else if (field.toUpperCase().indexOf("END_TIME")>-1) {
        	String id = field.substring(8, field.length());
        	if (this.hm.containsKey(id)) {
        		MyHashMap hmData = (MyHashMap) hm.get(id);
        		hmData.put("END_TIME", data);
        		this.hm.put(id, hmData);
        	}
        } else if (field.toUpperCase().indexOf("OT_CAUSE")>-1) {
        	String id = field.substring(8, field.length());
        	if (this.hm.containsKey(id)) {
        		MyHashMap hmData = (MyHashMap) hm.get(id);
        		hmData.put("OT_CAUSE", data);
        		this.hm.put(id, hmData);
        	}
        } else if (field.toUpperCase().indexOf("OT_WORKAREA")>-1) {
        	String id = field.substring(11, field.length());
        	if (this.hm.containsKey(id)) {
        		MyHashMap hmData = (MyHashMap) hm.get(id);
        		hmData.put("OT_WORKAREA", data);
        		this.hm.put(id, hmData);
        	}
        } else if (field.toUpperCase().indexOf("OT_SALATYPE")>-1) {
        	String id = field.substring(11, field.length());
        	if (this.hm.containsKey(id)) {
        		MyHashMap hmData = (MyHashMap) hm.get(id);
        		hmData.put("OT_SALATYPE", data);
        		this.hm.put(id, hmData);
        	}
        } else if (field.toUpperCase().indexOf("OT_TYPE")>-1) {
        	String id = field.substring(7, field.length());
        	if (this.hm.containsKey(id)) {
        		MyHashMap hmData = (MyHashMap) hm.get(id);
        		hmData.put("OT_TYPE", data);
        		this.hm.put(id, hmData);
        	}
        } else chk=super.set(field, data);
        return chk;
    }
    
    private void setData() {
    	try {
    		int i=1;
    		DbTable db = new InitialTable(this.getUProfile()).getDbTable("Tot_m_date1");
    		 Iterator it = this.hm.keySet().iterator();
    		while (it.hasNext()) {
    			String key = (String) it.next();
    			MyHashMap hmData = (MyHashMap) hm.get(key);
    			
    			DbRecord recChild = db.getNewRecord();
    			recChild.set("OTID", "0");
    	    	recChild.set("COMPANYID", (String) this.userPro.get("companyid"));
    	    	recChild.set("LINE_NO", i);
    			Iterator itChild = hmData.keySet().iterator();
    			while (itChild.hasNext()) {
    				String keyChild = (String) itChild.next();
    				recChild.set(keyChild, hmData.getString(keyChild));
    			}
    			i++;
    			db.putNewRecord(recChild);
    		}
    		    		    		
	    	/*DbRecord rec=new InitialRecord(this.getUProfile()).getDbRecord("Tot_m_date0");
	    	rec.setColumn("*");
	    	rec.set("OTID", "0");
	    	rec.set("EMPLOYEEID", this.getString("employeeid"));
	    	rec.set("COMPANYID", (String) this.userPro.get("companyid"));
	    	rec.putChild(db);
	    	rec.setWFOff();
	    	rec.save();*/
    		
    		this.putChild(db);
    		this.setWFOff();
    	} catch (Exception e) {
		MyLog.error(this, e);

    		
    	}
    }
    	

    protected boolean preInsertTrigger() throws Exception {        
      this.setData();
      return super.preInsertTrigger();
    }

    protected boolean preUpdateTrigger() throws Exception {        
        this.setData();
        return super.preUpdateTrigger();
    }
}
