package com.csc.library.databean;

import com.csc.library.utilities.MyLog;
import java.rmi.RemoteException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.StringTokenizer;

import com.csc.library.database.FieldManager;
import com.csc.library.database.MyHashMap;
import com.csc.library.database.PropertyField;
import com.csc.library.formula.FormulaString;
import com.csc.library.process.CalOT;
import com.csc.library.process.RoundingTime;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.session.RecordCmp;
import com.csc.library.timeattendance.DayCalculation;
import com.csc.library.timeattendance.TimeZone;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscTime;
import com.csc.library.utilities.MyTreeMap;

public class Ttime_current1_decimal extends Ttime_current1 {	
	
	FieldManager fmTmp = null;
	FormulaString fs = new FormulaString();
	
	public Ttime_current1_decimal() {
		super();
	}
	
	/*
	 * Overide For getField LT, C_LV, M_LV, AC_OT, AP_OT, OT1, OT5, OT2, OT3, HOUR_D
	 * 繰ҹ 100 к繰ҹ 60
	 * ¨ Class FormulaString 㹡ŧ繰ҹ 100
	 */
	public FieldManager getField(String fieldName) {		
		FieldManager fm = super.getField(fieldName);		
		if (fieldName.equalsIgnoreCase("LT_DECIMAL")) {
			this.fmTmp = super.getField("LT");			
			fm = this.initField("Double", "LT_DECIMAL", 10, 2, "Late");
			fm.setWorking(true);
			fm.setUProfile(this.userPro);
			fm.setProperty(fmTmp.getProperty());
			fm.set(fs.Tm_To_Dec(fmTmp.getDouble()));
		} else if  (fieldName.equalsIgnoreCase("C_LV_DECIMAL")) {
			this.fmTmp = super.getField("C_LV");			
			fm = this.initField("Double", "C_LV_DECIMAL", 10, 2, "Company Leave");
			fm.setWorking(true);
			fm.setUProfile(this.userPro);
			fm.setProperty(fmTmp.getProperty());
			fm.set(fs.Tm_To_Dec(fmTmp.getDouble()));
		} else if  (fieldName.equalsIgnoreCase("M_LV_DECIMAL")) {
			this.fmTmp = super.getField("M_LV");			
			fm = this.initField("Double", "M_LV_DECIMAL", 10, 2, "Memployee Leave");
			fm.setWorking(true);
			fm.setUProfile(this.userPro);
			fm.setProperty(fmTmp.getProperty());
			fm.set(fs.Tm_To_Dec(fmTmp.getDouble()));
		} else if  (fieldName.equalsIgnoreCase("AC_OT_DECIMAL")) {
			this.fmTmp = super.getField("AC_OT");			
			fm = this.initField("Double", "AC_OT_DECIMAL", 10, 2, "OT Work");
			fm.setWorking(true);
			fm.setUProfile(this.userPro);
			fm.setProperty(fmTmp.getProperty());
			fm.set(fs.Tm_To_Dec(fmTmp.getDouble()));	
		} else if  (fieldName.equalsIgnoreCase("AP_OT_DECIMAL")) {
			this.fmTmp = super.getField("AP_OT");			
			fm = this.initField("Double", "AP_OT_DECIMAL", 10, 2, "OT Approve");
			fm.setWorking(true);
			fm.setUProfile(this.userPro);
			fm.setProperty(fmTmp.getProperty());
			fm.set(fs.Tm_To_Dec(fmTmp.getDouble()));	
		} else if  (fieldName.equalsIgnoreCase("OT1_DECIMAL")) {
			this.fmTmp = super.getField("OT1");			
			fm = this.initField("Double", "OT1_DECIMAL", 10, 2, "OT1");
			fm.setWorking(true);
			fm.setUProfile(this.userPro);
			fm.setProperty(fmTmp.getProperty());
			fm.set(fs.Tm_To_Dec(fmTmp.getDouble()));	
		} else if  (fieldName.equalsIgnoreCase("OT5_DECIMAL")) {
			this.fmTmp = super.getField("OT5");			
			fm = this.initField("Double", "OT5_DECIMAL", 10, 2, "OT5");
			fm.setWorking(true);
			fm.setUProfile(this.userPro);
			fm.setProperty(fmTmp.getProperty());
			fm.set(fs.Tm_To_Dec(fmTmp.getDouble()));	
		} else if  (fieldName.equalsIgnoreCase("OT2_DECIMAL")) {
			this.fmTmp = super.getField("OT2");			
			fm = this.initField("Double", "OT2_DECIMAL", 10, 2, "OT2");
			fm.setWorking(true);
			fm.setUProfile(this.userPro);
			fm.setProperty(fmTmp.getProperty());
			fm.set(fs.Tm_To_Dec(fmTmp.getDouble()));	
		} else if  (fieldName.equalsIgnoreCase("OT3_DECIMAL")) {
			this.fmTmp = super.getField("OT3");			
			fm = this.initField("Double", "OT3_DECIMAL", 10, 2, "OT3");
			fm.setWorking(true);
			fm.setUProfile(this.userPro);
			fm.setProperty(fmTmp.getProperty());
			fm.set(fs.Tm_To_Dec(fmTmp.getDouble()));	
		} else if  (fieldName.equalsIgnoreCase("HOUR_D_DECIMAL")) {
			this.fmTmp = super.getField("HOUR_D");			
			fm = this.initField("Double", "HOUR_D_DECIMAL", 10, 2, "Hour_D");
			fm.setWorking(true);
			fm.setUProfile(this.userPro);
			fm.setProperty(fmTmp.getProperty());
			fm.set(fs.Tm_To_Dec(fmTmp.getDouble()));	
		}
		return fm;
	}
	
}