package com.csc.library.process;

import com.csc.library.utilities.MyLog;

import java.text.DecimalFormat;
import java.util.HashMap;
import java.util.Iterator;
import java.util.StringTokenizer;
import java.util.Vector;

import com.csc.library.databean.Mtime0;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.timeattendance.DayShift;
import com.csc.library.timeattendance.Shift;
import com.csc.library.timeattendance.SwipeData;
import com.csc.library.timeattendance.WorkingShift;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.CscTime;
import com.csc.library.utilities.ReadFile;

/*
 * class 觵Ǩͺ÷ӧҹͧѡҹ
 *  ٴѵ ͡͹ 繵
 * ¨ save ŧ TTIMEERROR
 * NOT USED 2008/09/01 
 */
public class CheckTimeProcess extends ProcessTimeBase {
	
	private HashMap propTime;
	private HashMap errorTemp = new HashMap();
	private DbInquiry inqTime0 = null;
	private DbInquiry inqTimeError = null;
	private DbRecord empRec= null;
	private DbRecord recError = null;
	
	private CscCalendar cs1 = null;
	private CscCalendar cs2 = null;
	private DecimalFormat df = new DecimalFormat("0.00");
	private DecimalFormat df2 = new DecimalFormat("00.00");
	
	public Vector getProcessList() {
		Vector v = new Vector();
		try {
			this.setParamData();
			if (!this.getParamValue("filterProcess").equals("")) {
				DbInquiry inq = new InitialInquiry(this.upf).getDbInquiry();
				inq.setParam(this.data);
				inq.setSchemaName(this.upf.getSchemaName());
				inq.initMyTable("Memployee", this.getParamValue("filterProcess"), "employeeid");			
				inq.setColumn("employeeid, runno, emp_position, emp_group, branch, job, bossid, emp_level," +
					"bu1, bu2, bu3, bu4, bu5, costcenter, salatype, currency, salary, emp_every, time0, companyid," + 
					"status, startdate, resigndate, workarea");	
				inq.setFatchAll(true);
				inq.refresh();
				while (inq.next()) {
					v.addElement(inq.getCurrentDbRecord().getString("employeeid"));
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return v;
	}
	
	public Mtime0 getTimeRecord(String id) {
		Mtime0 rec = null;
		StringTokenizer str;
		try {
			if (this.inqTime0 == null) {
				this.inqTime0 = new InitialInquiry(this.upf).getDbInquiry();
				this.inqTime0.setParam(this.data);
				this.inqTime0.setSchemaName(this.upf.getSchemaName());
				this.inqTime0.initMyTable("Mtime0", "", "");
				this.inqTime0.setColumn("*");
			}
			this.inqTime0.setFilter("time0id='" + id + "'");
			this.inqTime0.setFatchAll(true);
			this.inqTime0.refresh();
			while (this.inqTime0.next()) {
				rec = (Mtime0) this.inqTime0.getCurrentDbRecord();
				this.propTime = new HashMap();
				str = new StringTokenizer(rec.getFieldList(), ",");
				while (str.hasMoreTokens()) {
					String field = str.nextToken().toUpperCase();
					this.propTime.put(field, rec.getString(field));
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return rec;
	}
		
	/*
	 * ӡźšüԴҴ źǧѹ˹ա process 
	 */
	private void deleteError(String empID) {
		CscCalendar cs1 = new CscCalendar(this.getParamValue("startDate"));
		CscCalendar cs2 = new CscCalendar(this.getParamValue("endDate"));
		String filter = "employeeid='"+empID+"' and (dateshift between '"+cs1.getYYYYMMDD()+"' and '"+cs2.getYYYYMMDD()+"')";
		try {
			if (this.inqTimeError == null) {
				this.inqTimeError = new InitialInquiry(this.upf).getDbInquiry();		
				this.inqTimeError.setSchemaName(this.upf.getSchemaName());						
				this.inqTimeError.initMyTable("Ttimeerror", "", "");
				this.inqTimeError.setColumn("*");
			}
			this.inqTimeError.setFilter(filter);
			this.inqTimeError.refresh();
			while (this.inqTimeError.next()) {
				DbRecord rec = this.inqTimeError.getCurrentDbRecord().cloneRecord(true);
				rec.delete();
			}
		} catch (Exception ex) {
			MyLog.error(this, ex);			
		}
	}
	
	public void process() throws Exception {
		long start=System.currentTimeMillis();		
		this.setParamData();
		//CscCalendar cs1 = new CscCalendar(this.getParamValue("startDate"));
		//cs1.decDate();
		//CscCalendar cs2 = new CscCalendar(this.getParamValue("endDate"));
		//cs2.incDate();
		
		if (this.getParamValue("startDate").equalsIgnoreCase("today") || this.getParamValue("endDate").equalsIgnoreCase("today")) {
			CscCalendar c1 = new CscCalendar();
			this.data.put("startDate", c1.getDDMMYYYY());
			this.data.put("endDate", c1.getDDMMYYYY());
		} else if (this.getParamValue("startDate").indexOf("last")>-1 || this.getParamValue("endDate").indexOf("last")>-1) {
			String s1 = this.getParamValue("startDate");
			String s2 = this.getParamValue("endDate");
			s1 = s1.substring(4, s1.length());
			s2 = s2.substring(4, s2.length());
			CscCalendar c1 = new CscCalendar();
			c1.decDate(Integer.parseInt(s1));
			CscCalendar c2 = new CscCalendar();
			c2.decDate(Integer.parseInt(s2));
			this.data.put("startDate", c1.getDDMMYYYY());
			this.data.put("endDate", c2.getDDMMYYYY());
		}
		
		this.cs1 = new CscCalendar(this.getParamValue("startDate"));        
        this.cs2 = new CscCalendar(this.getParamValue("endDate"));
        try {
        	this.cs1.setCSCTime(Float.parseFloat(this.getParamValue("startTime")));
        	this.cs2.setCSCTime(Float.parseFloat(this.getParamValue("endTime")));
        } catch (Exception e) {
        	this.cs1.setCSCTime(0.00f);
        	this.cs2.setCSCTime(0.00f);
        }
		
		Vector vt = this.processList;
					
		if (vt==null) {
			vt = new Vector();
			String condition = "";
			if (this.data.containsKey("conditionfile")) {
				InitialEnvironment en = new InitialEnvironment("GLOBAL");
				String xmlPath = en.getValue("import-dir");
				ReadFile rf = new ReadFile(xmlPath + "condition/" + (String) this.data.get("conditionfile"));
				condition = rf.readLine();
				rf.closeFile();
			} else {
				condition = (String)this.data.get("processlist");
			}
			
			StringTokenizer str = new StringTokenizer(condition, "#");
			while (str.hasMoreTokens()) {
				vt.add(str.nextToken());
			}			
			this.upf.set("companyid", (String) this.data.get("companyid"));
			this.upf.setSchemaName((String) this.data.get("schemaname"));
			this.upf.setDbName((String) this.data.get("dbname"));
			this.upf.set("appname", (String) this.data.get("appname"));
			this.upf.set("lang", (String) this.data.get("lang"));
		}
		
		int success = 0;
		int error = 0;
		String errorResult = "";
		String errorProcess = "";
		for (int i=0;i<vt.size() && !this.isCancle();i++) {
			String id = (String) vt.elementAt(i);
			try {
				if (this.empRec == null) {
					this.empRec = new InitialRecord(this.upf).getDbRecord("MEMPLOYEE");
				}
				this.empRec.clearField();
				this.empRec.set("employeeid", (String) vt.elementAt(i));
				this.empRec.set("companyid", (String) this.upf.get("companyid"));
	        	int flag = this.empRec.search();
				
	        	if (flag == 1) {
	        		this.deleteError(this.empRec.getString("employeeid"));
	        	}
	        	
				MyLog.debug(this, "-----------> employeeid=" + this.empRec.getString("employeeid") + " ---> time0=" + empRec.getString("time0"));
				Mtime0 timeRec = this.getTimeRecord(this.empRec.getString("time0"));			
				if (timeRec != null) {
					long startSave=System.currentTimeMillis();
					timeRec.setEmpRec(this.empRec);
					WorkingShift ws = timeRec.genWorkingShift(new CscCalendar(this.cs1	.getTimestamp()), new CscCalendar(this.cs2.getTimestamp()));
					
					this.upf.set("empRecord",this.empRec.getString("employeeid"));
					if ( this.getParamValue("cmdValue").equalsIgnoreCase("check")) {								
						this.checkTimeProcess(ws, this.empRec);							
					}
					long endSave=System.currentTimeMillis();			
					MyLog.debug(this, "Process Success >>> End Check Process "+empRec.getString("employeeid")+" :>>> time  : "+(endSave-startSave)/10000);
					success++;
				} else {
					MyLog.debug(this, "Process Error >>> End Check Process "+empRec.getString("employeeid"));
					error++;
					errorResult += id+",";
				}
			} catch (Exception e ) {
				errorProcess += id+",";
			}
			this.alive("Process EmployeeID : "+id+" ["+i+" of "+vt.size()+"]");
		}		
		long end=System.currentTimeMillis();
		MyLog.debug(this, "Process >>> End Process :>>> time  : "+(end-start)/10000 + "Total Process="+vt.size()+" >> Success="+success+" >> Error="+error);
		this.setMessage("Successful of CheckTimeProcess : "+vt.size());
		this.setFullMessage("Successful of CheckTimeProcess : "+vt.size()+"\n"+
				"Success : " +success+"\n"+
				"Error : "+error+"\n"+
				"Error Case : Not Find WorkingTime! Please Check time0, startdate, resigndate In MEMPLOYEE !!!"+ "\n" +
				"Result Error : "+errorResult+"\n"+
				"Error Process : "+errorProcess);
	}
	
	private void checkTimeProcess(WorkingShift ws, DbRecord empRec) {		
		try {
			if (!ws.isEmpty()) {				
				CscCalendar csStart = new CscCalendar(this.getParamValue("startDate"));
				csStart.decDate();
				CscCalendar csEnd = new CscCalendar(this.getParamValue("endDate"));
				csEnd.incDate();
				
				ws.setUProfile(this.upf);
				ws.setEmployeeid(empRec.getString("employeeid"));
				ws.adjust();
				ws.createLink();

				SwipeData SD = new SwipeData();				
				SD.setUProfile(this.upf);
				SD.loadData(empRec.getString("employeeid"), csStart, csEnd);
				ws.genTimeZone();
				ws.setSwipeTrans(SD);
				try {
					ws.findTime(new CscCalendar(this.getParamValue("startDate") + " 00:00:00.000000000"),
						new CscCalendar(this.getParamValue("endDate") + " 23:59:00.000000000"));
				} catch (Exception e) {
					MyLog.error(this, e);
					MyLog.debug(this, "+++ ERROR FINDTIME +++EMP="+empRec.getString("employeeid"));					
				}		
				this.saveCheckTimeError(ws, empRec);
			}
		} catch (Exception e) {
			MyLog.error(this, e);	
		}
	}
	
	private void saveCheckTimeError(WorkingShift ws, DbRecord empRec) {		
		if (this.recError == null) {
			this.recError = new InitialRecord(this.upf).getDbRecord("Ttimeerror");
		}
		//CscCalendar csStart = new CscCalendar(this.getParamValue("startDate"));		
		//CscCalendar csEnd = new CscCalendar(this.getParamValue("endDate"));		
		for (Iterator IT = ws.keySet().iterator(); IT.hasNext();) {			
			String key = (String) IT.next();
			DayShift dShift = (DayShift) ws.get(key);
			
			CscCalendar csDate = new CscCalendar(key);
			//Check save record  for in process date
			if (csDate.afterEquals(this.cs1) && csDate.beforeEquals(this.cs2)) {
				
				HashMap errorDayShiftResult = dShift.getErrorResult();
				//MyLog.debug(this, ">>>> ERROR DAYSHIFT "+key+" = "+errorDayShiftResult);
				if (!errorDayShiftResult.isEmpty()) {
					try {
						//DbRecord rec = new InitialRecord(this.upf).getDbRecord("TtimeError");
						this.recError.clearField();
						this.recError.set("companyid", this.upf.get("companyid"));
						this.recError.set("emp_process", this.getParamValue("employeeProcess"));
						//rec.set("line_no", this.getStringID(j, 9));
						CscCalendar cs = new CscCalendar();
						this.recError.set("line_no", this.processCode+"-"+System.currentTimeMillis());
						this.recError.set("employeeid", empRec.getString("employeeid"));
						this.recError.set("bossid", empRec.getString("bossid"));
						this.recError.set("time0id", empRec.getString("time0"));	
						
						this.recError.set("emp_position",empRec.getString("emp_position"));
						this.recError.set("emp_group",empRec.getString("emp_group"));				
						this.recError.set("branch",empRec.getString("branch"));
						this.recError.set("job",empRec.getString("job"));
						this.recError.set("bu1",empRec.getString("bu1"));
						this.recError.set("bu2",empRec.getString("bu2"));
						this.recError.set("bu3",empRec.getString("bu3"));
						this.recError.set("bu4",empRec.getString("bu4"));
						this.recError.set("bu5",empRec.getString("bu5"));
						this.recError.set("bossid",empRec.getString("bossid"));
						this.recError.set("emp_level",empRec.getString("emp_level"));
						this.recError.set("costcenter",empRec.getString("costcenter"));
						this.recError.set("salatype",empRec.getString("salatype"));
						this.recError.set("currency",empRec.getString("costcenter"));
						this.recError.set("salary",empRec.getString("salary"));
						this.recError.set("every",empRec.getString("emp_every"));
						this.recError.set("workarea",empRec.getString("workarea"));	
						
						try {
							this.recError.set("dateshift", dShift.getShiftDate().getDDMMYYYY());
							this.recError.set("timeshift", dShift.getShiftDate().getCSCTime());
						} catch (Exception e) {
							MyLog.error(this, e);
						}
						try {
							this.recError.set("dt_c_in", dShift.getShiftDate().getDDMMYYYY());
							this.recError.set("tm_c_in", dShift.getShiftDate().getCSCTime());
						} catch (Exception e) {
							MyLog.error(this, e);
						}
						try {
							this.recError.set("dt_c_out", dShift.getShiftDate().getDDMMYYYY());
							this.recError.set("tm_c_out", dShift.getShiftDate().getCSCTime());
						} catch (Exception e) {
							MyLog.error(this, e);
						}
						this.recError.set("error_type", "11");
						this.recError.save();
					} catch (Exception e) {
						MyLog.error(this, e);						
					}
				}
								
				for (Iterator IT1 = dShift.keySet().iterator(); IT1.hasNext();) {
					String key1 = (String) IT1.next();
					Shift sh = (Shift) dShift.get(key1);					
					/*MyLog.debug(this, "+++ Date=" + key + " : Time=" + key1
							+ " : Shift " + " > Begin="
							+ sh.get_c_dt_in().getCSCTime() + " > End="
							+ sh.get_c_dt_out().getCSCTime() + " > Time Code="
							+ sh.getTimeCode() + " > Type="
							+ sh.getTR_Type().substring(0, 1) + " > Leave="
							+ sh.getLv() + " > Leave Type=" + sh.getLV_Type()
							+ " > Error Type=" + sh.getErrorResult());*/
					
					try {
						this.errorTemp.put(empRec.getString("employeeid"), sh.getErrorResult());
					} catch (Exception e1) {
						MyLog.error(this, e1);						
					}
	
					HashMap errorResult = sh.getErrorResult();					
					boolean isSaveRec;		
					for (Iterator itError = errorResult.keySet().iterator(); itError.hasNext();) {
						String errorType = (String) itError.next();
						Object obj = errorResult.get(errorType);
						isSaveRec = true;
						if (this.propTime.get("STICKTM").equals("N")) {
							if(!sh.getTR_Type().substring(0,1).equals("A")){
								isSaveRec = false;
							} else {
								if (errorResult.containsKey("0")||errorResult.containsKey("1")) {
									isSaveRec = false;
								} 
							}
						} 
						
						if ((errorResult.containsKey("0")||errorResult.containsKey("1")) && (sh.getEventGroup().equals("H")||sh.getEventGroup().equals("I"))) {							
							isSaveRec = false;
						}
						
						if (isSaveRec && !sh.getTR_Type().equalsIgnoreCase("M")) { //sh.getTR_Type()=M ͡зԴ  ͷշԴѺзӧҹ Шй仵͡Ѻҷӧҹ
							try {
								MyLog.debug(this, ":::::::::::::::::::: SAVE BY  :::::::::::::::::> " + this.getParamValue("employeeProcess")
												+ " ::::::::: SAVE EMP :::> " + empRec.getString("employeeid")
												+ " ::::::::: ERROR ::::> " + errorType + " > DATA => " + obj);
								//DbRecord rec = new InitialRecord(this.upf).getDbRecord("TtimeError");
								this.recError.clearField();
								this.recError.set("companyid", this.upf.get("companyid"));
								this.recError.set("emp_process", this.getParamValue("employeeProcess"));
								this.recError.set("line_no",  this.processCode+"-"+System.currentTimeMillis());
								this.recError.set("employeeid", empRec.getString("employeeid"));								
								this.recError.set("bossid", empRec.getString("bossid"));
								this.recError.set("time0id", empRec.getString("time0"));	
								
								this.recError.set("emp_position",empRec.getString("emp_position"));
								this.recError.set("emp_group",empRec.getString("emp_group"));				
								this.recError.set("branch",empRec.getString("branch"));
								this.recError.set("job",empRec.getString("job"));
								this.recError.set("bu1",empRec.getString("bu1"));
								this.recError.set("bu2",empRec.getString("bu2"));
								this.recError.set("bu3",empRec.getString("bu3"));
								this.recError.set("bu4",empRec.getString("bu4"));
								this.recError.set("bu5",empRec.getString("bu5"));
								this.recError.set("bossid",empRec.getString("bossid"));
								this.recError.set("emp_level",empRec.getString("emp_level"));
								this.recError.set("costcenter",empRec.getString("costcenter"));
								this.recError.set("salatype",empRec.getString("salatype"));
								this.recError.set("currency",empRec.getString("costcenter"));
								this.recError.set("salary",empRec.getString("salary"));
								this.recError.set("every",empRec.getString("emp_every"));	
								this.recError.set("workarea",empRec.getString("workarea"));	
								try {
									this.recError.set("dateshift", sh.getShiftDate().getDDMMYYYY());
									this.recError.set("timeshift", sh.getShiftDate().getCSCTime());
								} catch (Exception e) {
									MyLog.error(this, e);
								}
								try {
									this.recError.set("dt_c_in", sh.get_c_dt_in().getDDMMYYYY());
									this.recError.set("tm_c_in", sh.get_c_dt_in().getCSCTime());
								} catch (Exception e) {
									MyLog.error(this, e);
								}
								try {
									this.recError.set("dt_c_out", sh.get_c_dt_out().getDDMMYYYY());
									this.recError.set("tm_c_out", sh.get_c_dt_out().getCSCTime());
								} catch (Exception e) {
									MyLog.error(this, e);
								}
								
								if (!errorResult.containsKey("0")) {
									try {
										if (sh.get_m_dt_in()!=null) {
											this.recError.set("dt_m_in", sh.get_m_dt_in().getDDMMYYYY());
											this.recError.set("tm_m_in", sh.get_m_dt_in().getCSCTime());				
										}
									} catch (Exception e) {
										MyLog.error(this, e);
									}
								} else {
									this.recError.set("dt_m_in", "01-01-1900");
								}
								
								if (!errorResult.containsKey("1")) {
									try {
										if (sh.get_m_dt_out()!=null) {
											this.recError.set("dt_m_out", sh.get_m_dt_out().getDDMMYYYY());
											this.recError.set("tm_m_out", sh.get_m_dt_out().getCSCTime());
										}
									} catch (Exception e) {
										MyLog.error(this, e);
									}
								} else {														
									this.recError.set("dt_m_out", "01-01-2900");
								}								
								
								try {
									if (sh.getMidDayStop()!=null){
										try {
											if (sh.getMidDayStop().getBeginZone()!=null) {
												this.recError.set("dt_breakin", sh.getMidDayStop().getBeginZone().getDDMMYYYY());
												this.recError.set("tm_breakin", sh.getMidDayStop().getBeginZone().getCSCTime());
											}		
										} catch (Exception e) {
											MyLog.error(this, e);
										}
										try { 										
											if (sh.getMidDayStop().getEndZone()!=null) {
												this.recError.set("dt_breakout", sh.getMidDayStop().getEndZone().getDDMMYYYY());							
												this.recError.set("tm_breakout", sh.getMidDayStop().getEndZone().getCSCTime());
											}
										} catch (Exception e) {
											MyLog.error(this, e);
										}
									} 
								} catch (Exception e) {
									MyLog.error(this, e);
								}
																
								this.recError.set("eventgroup", sh.getEventGroup());
								this.recError.set("tr_type", sh.getTR_Type());
								this.recError.set("error_type", errorType);								
								this.recError.set("error_value", this.getErrorValue(obj));
								
								try {
									if (sh.getInZone()!=null) {
										try {
											if (sh.getInZone().getBeginZone()!=null) {
												this.recError.set("dt_inzone_begin", sh.getInZone().getBeginZone().getDDMMYYYY());
												this.recError.set("tm_inzone_begin", sh.getInZone().getBeginZone().getCSCTime());
											}
										} catch (Exception e) {
											MyLog.error(this, e);
										}
										try {
											if (sh.getInZone().getEndZone()!=null) {
												this.recError.set("dt_inzone_end", sh.getInZone().getEndZone().getDDMMYYYY());
												this.recError.set("tm_inzone_end", sh.getInZone().getEndZone().getCSCTime());
											}
										} catch (Exception e) {
											MyLog.error(this, e);
										}
									}
								} catch (Exception e) {
									MyLog.error(this, e);
								}
								
								try {
									if (sh.getOutZone()!=null) {
										try {
											if (sh.getOutZone().getBeginZone()!=null) {
												this.recError.set("dt_outzone_begin", sh.getOutZone()	.getBeginZone().getDDMMYYYY());
												this.recError.set("tm_outzone_begin", sh.getOutZone().getBeginZone().getCSCTime());
											}
										} catch (Exception e) {
											MyLog.error(this, e);
										}
										try {
											if (sh.getOutZone().getEndZone()!=null) {
												this.recError.set("dt_outzone_end", sh.getOutZone().getEndZone().getDDMMYYYY());
												this.recError.set("tm_outzone_end", sh.getOutZone().getEndZone().getCSCTime());
											}
										} catch (Exception e) {
											MyLog.error(this, e);
										}
									}
								} catch (Exception e) {
									MyLog.error(this, e);
								}
								
								try {
									if (sh.getInTimeNear()!=null) {
										try {
											if (sh.getInTimeNear().getBeginZone()!=null) {
												this.recError.set("dt_inzone_timenear_begin", sh.getInTimeNear().getBeginZone().getDDMMYYYY());
												this.recError.set("tm_inzone_timenear_begin", sh.getInTimeNear().getBeginZone().getCSCTime());
											} 
										} catch (Exception e) {
											MyLog.error(this, e);
										}
										try {
											if (sh.getInTimeNear().getEndZone()!=null) {
												this.recError.set("dt_inzone_timenear_end", sh.getInTimeNear()	.getEndZone().getDDMMYYYY());
												this.recError.set("tm_inzone_timenear_end", sh.getInTimeNear().getEndZone().getCSCTime());
											}
										} catch (Exception e) {
											MyLog.error(this, e);
										}
									}
								} catch (Exception e) {
									MyLog.error(this, e);
								}
								
								try {
									if (sh.getOutTimeNear()!=null) {
										try {
											if (sh.getOutTimeNear().getBeginZone()!=null) {
												this.recError.set("dt_outzone_timenear_begin", sh.getOutTimeNear().getBeginZone().getDDMMYYYY());
												this.recError.set("tm_outzone_timenear_begin", sh.getOutTimeNear().getBeginZone().getCSCTime());
											} 
										} catch (Exception e) {
											MyLog.error(this, e);
										}
										try {
											if (sh.getOutTimeNear().getEndZone()!=null) {
												this.recError.set("dt_outzone_timenear_end", sh.getOutTimeNear().getEndZone().getDDMMYYYY());
												this.recError.set("tm_outzone_timenear_end", sh.getOutTimeNear().getEndZone().getCSCTime());
											} 
										} catch (Exception e) {
											MyLog.error(this, e);
										}
									}
								} catch (Exception e) {
									MyLog.error(this, e);
								}
								
								this.recError.set("doctype", sh.getDocType());															
								this.recError.set("docno", sh.getDocNo());
								this.recError.save();
							} catch (Exception e) {
								MyLog.error(this, e);								
							}
						} //End isSaveRec
					}
				}
			}
		}		
	}
	
	/*
	 * ֧ҷ error ͡ ͹ save 
	 */
	private String getErrorValue(Object obj) {
		String value = "";
		if (obj instanceof CscTime) { //
			CscTime csc = (CscTime) obj;
			value = df.format(csc.getFloat());
		} else if (obj instanceof CscCalendar) { // Calendar
			CscCalendar csc = (CscCalendar) obj;
			value = csc.getDDMMYYYY()+":"+df2.format(csc.getCSCTime());
		}
		return value;
	}
}
