package com.csc.library.process;

import java.text.DecimalFormat;
import java.util.StringTokenizer;
import java.util.Vector;

import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;

/*
 * class 㹡 copy Шҡ ҧ˹ѧաҧ˹
 * ǧѹͧ÷ӡ copy 
 * ʵҧзͧ 
 */
public class CopyShiftPattern extends MyProcess {
	
	public Vector getProcessList() {
		Vector v = new Vector();
		v.addElement("All");
		return v;
	}
	
	public void process() throws Exception {
		Vector vt = this.processList;
		DecimalFormat df = new DecimalFormat("00");
		for (int i=0;i<vt.size() && !this.isCancle();i++) {
			String id = (String) vt.elementAt(i);
			MyLog.debug(this, "***** START COPY SHIFT PROCESS *****");
			MyLog.debug(this, ">>data="+this.data);
			
			String timeCode = (String) this.data.get("time0id"); //ʵҧõẺ
			
			//Ҫǧҷͧ÷ӡ copy ѺҨҡ param
			CscCalendar cc1 = null;
			CscCalendar cc2 = null;
			if (this.data.containsKey("start_date") && this.data.containsKey("end_date")) {
				cc1 = new CscCalendar((String) this.data.get("start_date"));
				cc2 = new CscCalendar((String) this.data.get("end_date"));
			} else {			
				String year1 = (String) this.data.get("year1");
				String month1 = (String) this.data.get("month1");
				String date1 = (String) this.data.get("date1");
				String year2 = (String) this.data.get("year2");
				String month2 = (String) this.data.get("month2");
				String date2 = (String) this.data.get("date2");
				
				cc1 = new CscCalendar(year1+"-"+month1+"-"+date1); 
				cc1.decMonth();
				cc2 = new CscCalendar(year2+"-"+month2+"-"+date2);
				cc2.decMonth();
			}
			
			CscCalendar cStart = new CscCalendar(cc1.getYYYYMMDD()); 
			CscCalendar cEnd = new CscCalendar(cc2.getYYYYMMDD());
			
			CscCalendar c1 = new CscCalendar(cc1.getYYYYMMDD());
			CscCalendar c2 = new CscCalendar(cc2.getYYYYMMDD());	
			
			//Copy time0		
			DbInquiry time0 = new InitialInquiry(this.upf).getDbInquiry();
			time0.initMyTable("Mtime0", "", "");
			time0.setColumn("*");
			
			DbInquiry inq = new InitialInquiry(this.upf).getDbInquiry();
			inq.initMyTable("Mtime0", "time0id='"+timeCode+"'", "");
			inq.setColumn("*");
			inq.refresh();
			if (inq.next()) {
				DbRecord rec = inq.getCurrentDbRecord().cloneRecord(true);
				//ʵҧ ͧ copy
				StringTokenizer timeList = new StringTokenizer((String) this.data.get("timelist"), ","); //ӡҹʵҧͧúѹ֡  list
				while (timeList.hasMoreTokens()) {
					String code = timeList.nextToken(); //ʵҧ  copy
					
					time0.setFilter("time0id='"+code+"'");
					time0.refresh();
					if (time0.next()) {
						//ͧ ͧ
					} else {
						rec.set("time0id", code.trim());
						rec.save();
					}
				}
			}
			
			DbRecord rec = new InitialRecord(this.upf).getDbRecord("Mtime2");
			rec.setColumn("*");
			
			DbInquiry time2 = new InitialInquiry(this.upf).getDbInquiry();
			time2.initMyTable("Mtime2", "", "");
			time2.setColumn("*");
			
			DbInquiry inq2 = new InitialInquiry(this.upf).getDbInquiry();
			inq2.initMyTable("Mtime2", "", "");
			inq2.setColumn("*");
			while (cStart.before(cEnd)) {
				//Copy time2
				inq2.setFilter("time0id='"+timeCode+"' and monthid="+(cStart.getMonth()+1)+" and yearid="+cStart.getYear());
				inq2.refresh();
				while (inq2.next()) {
					DbRecord recTime = inq2.getCurrentDbRecord().cloneRecord(true);
					StringTokenizer timeList = new StringTokenizer((String) this.data.get("timelist"), ",");
					while (timeList.hasMoreTokens()) {
						String code = timeList.nextToken();						
						boolean flag = false; //ҵҧ copy բ
						time2.setFilter("time0id='"+code+"' and monthid="+(cStart.getMonth()+1)+" and yearid="+cStart.getYear());
						time2.refresh();
						if (time2.next()) {
							flag = true;
							rec = time2.getCurrentDbRecord().cloneRecord(true);
						} else rec.clearField(); 
								 
						//DbRecord rec = recTime.cloneRecord(true); //ŨҡҧẺ						
						rec.set("time0id", code.trim());
						rec.set("monthid", (cStart.getMonth()+1));
						rec.set("yearid", cStart.getYear());
						int m = cStart.getMonth()+1; //͹ѧ process
						int mStart = c1.getMonth()+1; //͹á process
						int mEnd = c2.getMonth()+1; //͹ش· process
						
						if (m==mStart && m!=mEnd) { //m = ͹á ͹ش
							int endDate = c1.getEndDateOfMonth();
							for (int k=c1.getDate();k<=endDate;k++) {
								for (int j=1;j<=3;j++) {
									rec.set("time"+df.format(k)+j, recTime.getString("time"+df.format(k)+j)); //ҤҵҧẺ									
								}
							}							
						} else if (m==mEnd && m!=mStart) { //m = ͹ش ͹á
							int endDate = c2.getDate();
							for (int k=1;k<=endDate;k++) {
								for (int j=1;j<=3;j++) {
									rec.set("time"+df.format(k)+j, recTime.getString("time"+df.format(k)+j));
								}
							}							
						} else if (m==mStart && m==mEnd) { //͹á ͹ش͹ǡѹ
							int startDate = c1.getDate();
							int endDate = c2.getDate();
							for (int k=startDate;k<=endDate;k++) {
								for (int j=1;j<=3;j++) {
									rec.set("time"+df.format(k)+j, recTime.getString("time"+df.format(k)+j));
								}
							}							
						} else { //͹ͧ copy 
							int endDate = cStart.getEndDateOfMonth();
							for (int k=1;k<=endDate;k++) {
								for (int j=1;j<=3;j++) {
									rec.set("time"+df.format(k)+j, recTime.getString("time"+df.format(k)+j));
								}
							}						
						}
						/*if (m==mStart) {
							for (int k=1;k<c1.getDate();k++) {
								for (int j=1;j<=3;j++) {
									if (flag) {
										rec.set("time"+df.format(k)+j, time2.getString("time"+df.format(k)+j));
									} else rec.set("time"+df.format(k)+j, "");
								}
							}							
						}
						if (m==mEnd) {
							int endDate = c2.getEndDateOfMonth();
							for (int k=cEnd.getDate()+1;k<=endDate;k++) {
								for (int j=1;j<=3;j++) {
									if (flag) {
										rec.set("time"+df.format(k)+j, time2.getString("time"+df.format(k)+j));
									} else rec.set("time"+df.format(k)+j, "");
								}
							}							
						}*/

						rec.save();
					}
				}
				cStart.setDate(1);
				cStart.incMonth(1);
			}
			this.alive("Process Record : "+id+" ["+i+" of "+vt.size()+"]");
		}
		this.setMessage("Successful of CopyShiftPattern....");
		this.setFullMessage("Successful of CopyShiftPattern.... "+"\n");  	
		MyLog.debug(this, "***** END COPY SHIFT PROCESS *****");
	}
}
