package com.csc.library.process;

import java.util.Vector;

import com.csc.library.cscimport.MyImport;
import com.csc.library.database.StaticProperties;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.MyLog;

public class ImportAbsent extends MyProcess  {
	public Vector getProcessList() {
		Vector v = new Vector();
		v.addElement("All");
		return v;
	}
	
	public void process() throws Exception {
		Vector vt = this.processList;
		for (int i=0;i<vt.size() && !this.isCancle();i++) {
			String id = (String) vt.elementAt(i);
			MyLog.debug(this, "***** IMPORT Absent PROCESS *****");
			MyLog.debug(this, ">>data="+this.data);
			
			try {
				InitialEnvironment en = new InitialEnvironment("GLOBAL");
				String xmlPath = en.getValue("import-dir"); //path  xml ˹ format 㹡 import
				String importPath = en.getValue("dirimport-dir"); //path  import 
				String errorPath = en.getValue("dirimport_error-dir");
				DbRecord rec = null;
				if (this.data.get("tableImport")!=null) {
					rec = new InitialRecord(this.upf).getDbRecord((String) this.data.get("tableImport")); //ӡ new table ͧ save ŧ ҹ table ҡ param
				} else rec = new InitialRecord(this.upf).getDbRecord("tabsent_nstda");
				rec.setParam(this.data);
				rec.setColumn("*");
				
				MyImport_Absent myImp = new MyImport_Absent(rec, importPath + (String) this.data.get("fileName"), xmlPath +"XML/"+ (String) this.data.get("xmlName"),this.data);
				myImp.process(); //ӡ import
				this.setMessage(myImp.getMsg_error().toString());
				StaticProperties.serverManager.writeFileResultProcess(this.processId, myImp.getSummaryResult());
				MyLog.debug(this, ">>>>>>>>>>>>>>> Import Absent Result : Successful");
			} catch (Exception e) {
				MyLog.error(this, e);				
				MyLog.debug(this, ">>>>>>>>>>>>>>> Import Absent Result : ERROR Not Successful !!!!");
			}			
			this.alive("Process Data: "+id+" ["+i+" of "+vt.size()+"]");
		}
		//this.setMessage("Successful of Absent : "+vt.size());
		//this.setFullMessage("Successful of ImportSwipeCard : "+vt.size()+"\n");		
	}
}
