package com.csc.library.process;

import com.csc.library.utilities.MyLog;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Vector;

import std.library.DataTable;

import com.csc.library.database.CscConnection;
import com.csc.library.database.StaticProperties;
import com.csc.library.databean.Ttime_current;
import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialEnvironment;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CscCalendar;

/*
 * class 㹡 copy š÷ӧҹҡ Time Attendance --> Payroll
 * TTIME_CURRENT --> TPTIME_CURRENT
 * TPTIME_CURRENT1 --> TPTIME_CURRENT1
 * · structure ͧ module ͹ѹ
 * ¨зӡ copy ʹ relation  copy ŵç ͨӡ copy Ǣ
 */
public class MoveToPayroll extends ProcessTimeBase {
	
	/* СȪ͵ҧ͹任ѵ */
	private String _TIMECURRENT  = "TTIME_CURRENT";
	private String _TIMECURRENT1 = "TTIME_CURRENT1";
	private String _TPTIMECURRENT  = "TPTIME_CURRENT";
	private String _TPTIMECURRENT1 = "TPTIME_CURRENT1";
	
	public Vector getProcessList() {
		Vector v = new Vector();
		try {
			this.setParamData();
			if (!this.getParamValue("filterProcess").equals("")) {
				DbInquiry inq = new InitialInquiry(this.upf).getDbInquiry();
				inq.setParam(this.data);
				inq.setSchemaName(this.upf.getSchemaName());
				inq.initMyTable("Memployee", this.getParamValue("filterProcess"), "employeeid");
				inq.setColumn("employeeid, time0, runno, bossid, bu1, bu2, bu3, bu4, bu5, " +
						"salatype,workarea,emp_level, " +
						"companyid, startdate, resigndate, status, vacation0, vacation1");
				inq.setFatchAll(true);
				inq.refresh();
				while (inq.next()) {
					v.addElement(inq.getCurrentDbRecord().getString("employeeid"));
				}
			}
		} catch (Exception e) {
			MyLog.error(this, e);			
		}
		return v;
	}
	
	public void process() throws Exception {		
		boolean isCmpTcur = false;
		boolean isCmpTcur1 = false;
		
		/* 纤ʶԵԡ͹ */
		Vector vFail = new Vector();
		Vector vSuccess = new Vector();
		
		/* 駤ѹ ش͹  */
		CscCalendar cs1 = new CscCalendar(this.getParamData("startDate"));
		CscCalendar cs2 = new CscCalendar(this.getParamData("endDate"));
		CscCalendar csEndWorkDate = new CscCalendar(this.getParamData("endDate"));

		/* 駤 */
		setParamData();

		/* ֧ª;ѡҹͧ͹任ѵ */
		Vector vt = this.processList;
		
		/* ֧ªͤͧҧ͹任ѵ */
		String TMCurrentCols = getTableColumns(_TIMECURRENT);
		String TMCurrent1Cols = getTableColumns(_TIMECURRENT1);
		
		/* ͹ŵʾѡҹ ProcessList */
		for (int i=0;i<vt.size() && !this.isCancle();i++) {
			StringBuffer filter = new StringBuffer();
			StringBuffer filterWithEndWorkDate = new StringBuffer();
			String id = (String) vt.elementAt(i);
			
			/* ѹӧҹѹش ͹鹧Ǵ ǧѹ͹ж١Ѻ仴 */
			csEndWorkDate = chkLastWorkingDay(id,cs2);

			/* ҧ͹¡÷͹任ѵ ʾѡҹ Ъǧ */
			filter.append("employeeid='").append(id).append("' and (dateid between '").append(cs1.getYYYYMMDD());
			filter.append("' and '").append(cs2.getYYYYMMDD()).append("') ");
			
			/* ҧ͹¡÷͹任ѵ ʾѡҹ Ъǧ */
			filterWithEndWorkDate.append("employeeid='").append(id).append("' and (dateid between '").append(cs1.getYYYYMMDD());
			filterWithEndWorkDate.append("' and '").append(csEndWorkDate.getYYYYMMDD()).append("') ");
			
			
			/* ź Ttime_history ͹йӢŧ */
			removeTPTimecurrent(filter.toString()); 
			
			/* ͹Ũҡ Ttime_current --> Tptime_current ͹觤ҡѺ True ,(source, target, columns, filter)*/
			isCmpTcur = moveToTimePayroll(_TIMECURRENT, _TPTIMECURRENT, TMCurrentCols, filterWithEndWorkDate.toString()); 
			
			/* if isCmp is true ʴ͹ Ttime_current --> Ttime_history ֧͹ Ttime_current1 */
			if(isCmpTcur){
				/* ź Tptime_current ͹йӢŧ */
				removeTPTimecurrent1(filter.toString());
				
				/* ͹Ũҡ Ttime_current1 --> Ttime_history1 (source, target, columns, filter)*/
				isCmpTcur1 = moveToTimePayroll(_TIMECURRENT1, _TPTIMECURRENT1, TMCurrent1Cols, filterWithEndWorkDate.toString());
				
				/* ʾѡҹö͹ */
				if(isCmpTcur1){
					vSuccess.add(id);
				}else{
					vFail.add(id); /* ʾѡҹö͹ */
				}
			} else { /* ö͹ 价ӡ͹ѡҹѴ */
				MyLog.debug("!! Error : can't tranfter this rec [" + id + "]");
				vFail.add(id); /* ʾѡҹö͹ */
				continue;
			}
			
			this.alive("Process EmployeeID : "+id+" ["+i+" of "+vt.size()+"]");
		}
		/* 纤ʶҹС͹ */
		this.setMessage("MoveToPayroll completed : "+ vSuccess.size());
		this.setFullMessage("MoveToPayroll failed : "+ vFail.size()+"\n");	
	}
	
	/* ͹Ũҡҧ Transaction 任ѵ */
	private boolean moveToTimePayroll(String source, String target,String cols, String filter) {
		StringBuffer sql = new StringBuffer();
		boolean isCmp = false;
		
		try {
			/* ҧ Query ҡ */
			sql.append("insert into ").append(target).append("(").append(cols.toString()).append(")");
			sql.append(" select ").append(cols.toString()).append(" from ").append(source).append(" where ").append(filter);
			
			execSQL(sql.toString());

			isCmp = true;
		} catch (Exception e) {
			MyLog.error(this,e);
		} 
		return isCmp;
	}		
	
	/* ź Ttime_history ͹йӢŧ */
	private void removeTPTimecurrent(String filter){
		StringBuffer sql = new StringBuffer();
		try {
			sql.append("delete from tptime_current where ").append(filter);
			
			execSQL(sql.toString());	
		} catch(Exception e){
			MyLog.error("!! Error : can't remove tptime_current !!",e);
		} 
	}
	
	/* ź Ttime_history1 ͹йӢŧ */
	private void removeTPTimecurrent1(String filter){
		StringBuffer sql = new StringBuffer();
		try {
			sql.append("delete from tptime_current1 where ").append(filter);
			
			execSQL(sql.toString());
		} catch(Exception e){
			MyLog.error("!! Error : can't remove tptime_current !!",e);
		} 
	}	
	
	/* ֧ªͤ㹵ҧ */
	private String getTableColumns(String tablename){
		CscConnection conn = null;
		Statement stmt = null;
		ResultSet rs = null;
		StringBuffer columns = new StringBuffer();
		String sql = "";
		try {
			/* ҧ sql çѺͧ DB (Oracl,MSSQL)*/
			InitialEnvironment inv = new InitialEnvironment(this.upf.get("dbname"));	
			String schema = this.upf.getSchemaName(); /* ҧԧѺ Owner ͧҧ */
			
			if(inv.getValue("datasource-dbtype").equalsIgnoreCase("MSSQL")){
				/* DB  MSSQL */
				sql = "SELECT column_name FROM INFORMATION_SCHEMA.Columns where TABLE_NAME = '"+ tablename +"'"; 
			}else{
				/* DB  ORACLE */
				sql = "SELECT column_name FROM all_tab_cols where table_name = '"+ tablename +"' and owner = upper('" + schema + "') and data_type != 'RAW'";
			}
			
			conn = this.getCscConn();
			stmt = conn.createStatement();
			rs = stmt.executeQuery(sql);
			int count = 0;
			while(rs.next()){
				if(count > 0) columns.append(","); /* ҡ 1 ͧ蹴 ','  */
				columns.append(rs.getString("column_name"));
				count++;
			}

		}catch(Exception e){
			MyLog.error(this,e);
		}finally{
			try{
				if(rs != null) rs.close();
				if(stmt != null) stmt.close();
				if(conn != null) conn.close();
			}catch(Exception e){
				MyLog.error(this,e);
			}
		}
		
		return columns.toString();
	}

	/* ҧ CscConnection .. ˵ؼŷԴ conn ͧͧҡͧ繡÷ӧҹͧ process ͧäǴǨ֧ͧ价ӧҹҹ MyInquiry  MyDB */
	private CscConnection getCscConn(){
		CscConnection conn = null;
		try {
			conn = (CscConnection) StaticProperties.myConnection.getConnection(this.upf.get("dbname"));
		} catch(Exception e) {
			MyLog.error("!! Error :  can't get connection in MoveToHistory.getCscConn !!",e);
		}
		return conn;
	}
	
    /**  EXECUTE SQL  */
    public void execSQL(String _SQL) {
		CscConnection conn = null;
		Statement stmt = null;
		try {
			if(_SQL != null && !_SQL.equals("")){
				conn = (CscConnection) StaticProperties.myConnection.getConnection(this.upf.get("dbname"));
				stmt = conn.createStatement();
				stmt.executeUpdate(_SQL);
			}else{
				MyLog.debug("!! SQL is null or empty !!");
			}
        } catch (Exception e) {
            MyLog.error("!! Error : can't exec this SQL [" + _SQL + "] !!" ,e);           
        } finally {
        	try {
	        	if(stmt != null) stmt.close();
	        	if(conn != null) conn.close();
        	} catch(Exception e){
        		MyLog.error("!! Error : Can't close statement or connection !!",e);
        	}
        }
    }

    /* ѹӧҹѹش ͹ѹ鹧Ǵ Ѻǧ͹֧ѹӧҹѹش᷹ */
    private CscCalendar chkLastWorkingDay(String EMP, CscCalendar endDATE){
    	CscCalendar ENDDATE = new CscCalendar();
    	try {
    		DbRecord empRec = new InitialRecord(this.upf).getDbRecord("Memployee");
    		empRec.setColumn("employeeid,endworkdate");
    		empRec.set("employeeid", EMP);
    		if(empRec.search() == 1){ 
    			CscCalendar lastDate = empRec.getCscCalendar("ENDWORKDATE");
    			if(lastDate.beforeDate(endDATE)){
    				ENDDATE.setCscCalendar(lastDate.getYYYYMMDD());
    			}else{
    				ENDDATE.setCscCalendar(endDATE.getYYYYMMDD());
    			}
    		}
    	}catch(Exception e){
    		MyLog.error(this,e);
    	}finally{
    		return ENDDATE;
    	}
    }
    
}
