package com.csc.library.process;

import java.util.HashMap;
import java.util.Vector;

import com.csc.library.database.DataSet;
import com.csc.library.mail.SendMail;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;

public class SendMailForApprove extends ProcessTimeBase{
	@Override
	public Vector getProcessList() {
		Vector v = new Vector();
		HashMap hData;
		CscCalendar csc= new CscCalendar();
		csc.decDate(2);
		if(csc.getDayOfWeek()==1){
			csc.decDate();
		}
		try{
			System.out.println("### SendMailForApprove ###");
			String sql = "select wd.doc_no as doc_no,mp.tdesc as prefix,me.fname as fname,me.lname as lname,wi.subject as subject"
					+ " from workflow_data wd left join memployee me on wd.initiator=me.employeeid"
					+ " left join mprefix mp on me.emp_prefix = mp.prefixid"
					+ " left join workflow_incident wi on wd.runno=wi.wf_seq_no"
					+ " where wd.runno in (select wf_seq_no from actor_incident where status='1' and create_date <= '"+csc.getYYYYMMDD()+"')" 
					+ " and wd.wf_id='8001' and wd.wf_status='1'";
			DataSet ds = new DataSet(sql,this.getUProfile().get("dbname"),"MEMPLOYEE");
			ds.initConnection(this.getUProfile());	
			while(ds.next()){
				hData= new HashMap();
				hData.put("doc_no", ds.getString("doc_no"));
				hData.put("prefix", ds.getString("prefix"));
				hData.put("fname", ds.getString("fname"));
				hData.put("lname", ds.getString("lname"));
				hData.put("subject", ds.getString("subject"));
				v.add(hData);
				hData=null;
			}
			ds.closeConnection(); 
		}catch(Exception e){
			e.printStackTrace();
		}
		return v;
	}
	
	@Override
	public void process() throws Exception {
		HashMap hmData = new HashMap();
		try {
			Vector email = new Vector();
			StringBuilder content= new StringBuilder();
			content.append("¹ HR<br>");
			content.append("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;ҡõǨͺšشҹͧѡҹ к MyHR ͡÷ѧѺ͹ѵѹ˹ ѧ<br><br>");
			Vector data = this.getProcessList();
			if(data.size() > 0) {
				for(int i=0; i < data.size(); i++){	/* ǹٻ֧ҷӧҹ */
					hmData=(HashMap) data.get(i);
					content.append(i+1).append(".").append(" Ţ͡ ").append(hmData.get("doc_no")).append("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
					content.append(hmData.get("prefix")+" ").append(hmData.get("fname")+" ").append(hmData.get("lname"));
					content.append("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;").append(hmData.get("subject")).append("<br>");
				}
			}
			content.append("<br>").append("к myHR");
			String from = "MyHR";
			String subject="͹šشҹͧѡҹ";
			
			email=this.getEmailSender();
			
			System.out.println("### SendMailForApprove Send : "+email.size()+"email ###");
			if(email.size()>0){
				for(int i=0; i < data.size(); i++){
					SendMail sm = new SendMail("", from,email.get(i).toString(), "", subject, content.toString());
					sm.send();
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	private Vector getEmailSender(){
		Vector mail = new Vector();
		try {
			String sql = "select EMP_POSITION,* from MEMPLOYEE where" 
						+ " bu1='ADM' and bu2='APS' and bu3='PS' and (EMP_POSITION like '%O%'"
						+ " or EMP_POSITION like '%M%')";
			DataSet ds = new DataSet(sql,this.getUProfile().get("dbname"),"MEMPLOYEE");
			ds.initConnection(this.getUProfile());	
			while(ds.next()){
				mail.add(ds.getString("email"));
			}
			ds.closeConnection(); 
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return mail;
	}
}
