package com.csc.library.timeattendance;

import java.util.Iterator;
import java.util.List;
import java.util.Vector;

import com.csc.library.database.StaticConfig;
import com.csc.library.databean.Mtime0;
import com.csc.library.service.TA_Service;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;

public class ChangeShiftSwapHoliday extends TA_Service{
	private DbRecord recTime0exists = null;
	
	public ChangeShiftSwapHoliday(UProfile up) {
		this.setUProfile(up);
	}
	
	/*
	 * ó¹ѹ 㹪ǧҹ ѹش
	 * ͧ ¹  H 㹡óշ ѹش
	 * By Tong_Zuu
	 * */
	public WorkingShift genWorkingShiftAddSwapHoliday(String newShift , DbRecord dbEMP ,String stDate ,String enDate ,WorkingShift ws ,WorkingShift wsAdd){
		WorkingShift wsAddNew = wsAdd;
		try{
			if( StaticConfig.getConfigCompany(this.getUProfile(), "SWAP_SH").equals("Y") && newShift.indexOf("H") == -1){
				List<String> listHoliday = new Vector<String>();
				Iterator it = ws.keySet().iterator();
				while(it.hasNext()){
					String dsKey = it.next().toString();
					DayShift ds = (DayShift)ws.get(dsKey);
					Iterator it2 = ds.keySet().iterator();
					if( it2.hasNext() ){
						Shift sh = (Shift)ds.get(it2.next().toString());
						if( sh.getEventGroup().indexOf("H") >= 0){
							listHoliday.add(dsKey);
						}
					}
				}
				String newShiftHoliday = newShift+"H";
				if(listHoliday.size() > 0 && this.isExistsTime0(newShiftHoliday)){
					Mtime0 recAdd = (Mtime0) new InitialRecord(this.getUProfile()).getDbRecord("Mtime0");		
					recAdd.set("companyid", this.getUProfile().get("companyid"));
					recAdd.setEmpRec(dbEMP);
					CscCalendar cst = new CscCalendar() , cen = new CscCalendar();
					for(String strDate : listHoliday){
						recAdd.set("time0id", newShiftHoliday);
						if(recAdd.search() == 1){
							cst.setCscCalendar(strDate);
							cen.setCscCalendar(strDate);
							WorkingShift wsHol = recAdd.genWorkingShift(cst, cen, "true");
							if( wsHol.containsKey(strDate) && wsAddNew.containsKey(strDate)){
								DayShift dsNew = (DayShift)wsHol.get(strDate);
								DayShift dsAdd = (DayShift)wsAddNew.get(strDate);
								Iterator itNew = dsNew.keySet().iterator() , itAdd = dsAdd.keySet().iterator();
								if( itNew.hasNext() && itAdd.hasNext()){
									Shift shNew = (Shift)dsNew.get(itNew.next().toString());
									String keyShAdd = itAdd.next().toString();
									dsAdd.remove(keyShAdd);
									dsAdd.put(shNew);
								}
							}
						}
					}
				}
			}
		}catch(Exception e){
			MyLog.error(this ,this.getUProfile() , e);
		}
		return wsAddNew;
	}
	
	private boolean isExistsTime0(String time0id){
		boolean result = false;
		try{
			if( this.recTime0exists == null ){
				this.recTime0exists = new InitialRecord(this.getUProfile()).getDbRecord("mtime0");
				this.recTime0exists.setColumn("*");
			}
			this.recTime0exists.set("companyid", this.getUProfile().get("companyid"));
			this.recTime0exists.set("time0id", time0id);
			result = this.recTime0exists.search() == 1;
		}catch(Exception e){
			MyLog.error(this ,this.getUProfile() , e);
		}
		return result;
	}
}
