package com.csc.library.timeattendance;

import com.csc.library.database.MyHashMap;
import com.csc.library.session.DbRecord;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.CscTime;
import com.csc.library.utilities.CscCalendar;

import java.rmi.RemoteException;
import java.util.HashMap;

/*
 * äӹǳҷӧҹ
 * ѹ лѹ
 */
public class DayCalculation {
	
	private float OT_Before; //ͷա͹ҧҹ
	private float OT_After; //ͷѧҧҹ
	private float late; //
	private float actual_late = 0 ; // Թ͹ (͹Ѵ 0)	
	private float absentIn; //Ҵҹǧҧҹ͹
	private float absentOut; //Ҵҹǧҧҹ͹
	private int subOTFlag = 0;

	
	private HashMap shiftPro; 	// ´ͧ
	private TimeZone breakTime; // ǧѡ
	private float workHour; 	// . ӧҹѹ Ἱ÷ӧҹ
	private float actualWorkHour; // .ӧҹԧ Դҡ ٴ ͡ѡźѹ
	private CscCalendar cTimeIn = new CscCalendar(); // Ἱ
	private CscCalendar cTimeOut = new CscCalendar(); // شἹ
	private CscCalendar mTimeIn = new CscCalendar(); // ٴ
	private CscCalendar mTimeOut = new CscCalendar(); // ٴ͡
	
	private float hour_d = 0;	//. ӧҹѹ (Դҡٴѵ)
	private float hour_s = 0;	//. ӧҹѹ (ҡἹѧѺ)
	
	private String shiftType = ""; //èѺҢͧ
	
	private DbRecord time1 = null; 

	/* shiftProperty ´ҧ 㹵ҧ÷ӧҹ
	 * cDateIn ѹҷͧҧҹ
	 * cDateOut ѹҷԡҹ
	 * mDateIn ѹҷ边ѡҹŧҧҹ
	 * mDateOut ѹҷ边ѡҹŧ͡ҡҹ
	 * midDayStop ǧҷѡ
	 * previousShiftType ٻẺͧС͹˹
	 * nextShiftType ٻẺͧжѴ
	 * oDateIn ѹҷͧҧҹ
	 * oDateOut ѹҷԡҹ
	 * shDateIn ѹҷͧҧҹҧ÷ӧҹ
	 * shDateOut ѹҷͧԡҹҧ÷ӧҹ
	 * type ٻẺͧ
	 * docType ͡
	 */
	public DayCalculation(HashMap shiftProperty, CscCalendar cDateIn, 
			CscCalendar cDateOut, CscCalendar mDateIn, CscCalendar mDateOut, 
            TimeZone midDayStop, String previousShiftType, String nextShiftType, 
            CscCalendar oDateOut, CscCalendar oDateIn, CscCalendar shDateIn, CscCalendar shDateOut, String type
            ,String docType ) {
		
		this.calculate(shiftProperty, cDateIn, cDateOut, mDateIn, mDateOut, midDayStop, 
				previousShiftType, nextShiftType, oDateIn, oDateOut, shDateIn, shDateOut, type
				,docType);	
	}

	public DayCalculation() {
		super();
	}
	
	public void setTime1(DbRecord time1){
		this.time1 = time1 ;
	}

	public void calculate(HashMap shiftProperty, CscCalendar cDateIn,
			CscCalendar cDateOut, CscCalendar mDateIn, CscCalendar mDateOut, 
            TimeZone midDayStop, String previousShiftType, String nextShiftType,
            CscCalendar oDateIn, CscCalendar oDateOut, CscCalendar shDateIn, CscCalendar shDateOut, String type
            ,String docType) {

		/******* Ѻӹǳ ú  .  **********/
		/* ˹ شἹ÷ӧҹ */
		this.cTimeIn = cDateIn;
		this.cTimeOut = cDateOut;
		
		/* ˹ǧҾѡ */
		this.breakTime = midDayStop;
		
		/* . ӧҹѹ */
		this.workHour = Float.parseFloat((String)shiftProperty.get("HOUR_D"));
		
		/* èѺҢͧ  */
		this.shiftType = (String)shiftProperty.get("STICKTM");
		
		/* ˹ ٴ-͡*/
		this.mTimeIn = mDateIn;
		this.mTimeOut = mDateOut;
		/******* ش Ѻӹǳ ú  .  **********/
		         
	    //shiftProperty is properties from MTIME0
		if (midDayStop!=null) {
			if (mDateIn!=null && type.indexOf("A")==-1 && type.indexOf("O")==-1) {		
				if (midDayStop.inZone(mDateIn)) {
					mDateIn = midDayStop.getBeginZone();
				}
			}
			if (mDateOut!=null && type.indexOf("A")==-1 && type.indexOf("O")==-1) {
				if (midDayStop.inZone(mDateOut)) {
					mDateOut = midDayStop.getEndZone();
				}
			}
		}              
		
		/*
		 * OT_COUNT ùѺҷͷ
		 * 0 = ͹ѵ
		 * 1 = ÷Өԧ
		 * 2 = кѺ
		 * 3 = ÷Өԧ - ͷա͹
		 * 4 = ÷Өԧ - ͷѧ
		 * 5 = ͹ѵ + ͷա͹
		 * 6 = ͹ѵ + ͷѧ
		 */
		int OT_COUNT = 0;
		this.OT_Before = 0;
		this.OT_After = 0;
		this.late = 0;
		this.absentIn = 0;
		this.absentOut = 0;
		this.shiftPro = shiftProperty;	/*Ѻӹǳ ӧҹú .  */
				
		/* ˹ʶҹСùѺͷ*/
		try {
			String strOTCount = (String) shiftProperty.get("OT_COUNT");
			OT_COUNT = Integer.parseInt(strOTCount);
		}catch(Exception e){
			/* Ҥ ˹ кѺͷ*/
			OT_COUNT = 2;
		}
		
		if (mDateIn!=null) { 
			/* ӹǳͷ before */
			//if (oDateIn.after(mDateIn)) { /* ͧ */
			/* modified 24-07-2014 Ѻ͹䢤ӹǳͷա͹ */
			if(shDateIn.after(cDateIn)){
				/* óͷա͹ ͷշ͡л ͧѹǡѺл */
				try {
					if(time1 != null && time1.getString("eventgrp").equals("O") && time1.getCscCalendar("sh_dt_bg").equalsDate(cDateIn)){
						CscCalendar ost = (cDateIn.afterEqualsDateTime(mDateIn))?cDateIn:mDateIn;
						CscCalendar oen = (cDateOut.beforeEqualsDateTime(mDateOut))?cDateOut:mDateOut;
						
						if(OT_COUNT == 0){ /* ͹ѵ */
							this.OT_Before = cDateOut.subForHour(cDateIn);
						}else if(OT_COUNT == 1){ /* Өԧ  */
							this.OT_Before = mDateOut.subForHour(mDateIn);
						}else if(OT_COUNT == 2){	/* кѺ */
							this.OT_Before = oen.subForHour(ost);
						}
					}else{ /* л ʹ¡ͷ */
						if(OT_COUNT == 0){ /* ͹ѵ */
							this.OT_Before = shDateIn.subForHour(cDateIn);
						}else if(OT_COUNT == 1){ /* Өԧ  */
							if(mDateOut.afterEqualsDateTime(shDateIn)){
								this.OT_Before = shDateIn.subForHour(mDateIn);
							}else{ /* ٴ͡͹Ἱӧҹ */
								this.OT_Before = mDateOut.subForHour(mDateIn);
							}
						}else if(OT_COUNT == 2){	/* кѺ */
							if(mDateIn.beforeEqualsDateTime(cDateIn)){	/* ҡ͹Ἱ */
								CscCalendar otst = new CscCalendar((mDateIn.beforeDateTime(cDateIn))
										?cDateIn.getTime():mDateIn.getTime());
								CscCalendar oten = new CscCalendar((mDateOut.afterDateTime(cDateOut))
										?cDateOut.getTime():mDateOut.getTime());
			
								if(time1 != null && (time1.getString("eventgrp").equals("H") || time1.getString("eventgrp").equals("I"))){
									if(oten.beforeEqualsDateTime(shDateIn)){
										this.OT_Before = oten.subForHour(otst);
									}else{
										this.OT_Before = shDateIn.subForHour(otst);
									}
								}else{
									if(mDateOut.afterEqualsDateTime(shDateIn)){
										this.OT_Before = shDateIn.subForHour(otst);
									}else{ /* ٴ͡͹Ἱҷӧҹ */
										this.OT_Before = mDateOut.subForHour(otst);
									}
								}
							}else{	/* ѧἹ */
								if(time1 != null && (time1.getString("eventgrp").equals("H") || time1.getString("eventgrp").equals("I"))){
									CscCalendar otst = new CscCalendar((mDateIn.beforeDateTime(cDateIn))
																?cDateIn.getTime():mDateIn.getTime());
									CscCalendar oten = new CscCalendar((mDateOut.afterDateTime(cDateOut))
											?cDateOut.getTime():mDateOut.getTime());
									
									if(oten.beforeEqualsDateTime(shDateIn)){ /* ͡੾㹪ǧͷա͹ */
										this.OT_Before = oten.subForHour(otst);
									}else if(oten.afterEqualsDateTime(shDateOut)){ /* ٴҪǧͷա͹ ͡ѧӧҹ */
										this.OT_Before = shDateIn.subForHour(otst);
									}else{ /* ѧἹ͹Ἱ - ٴ͡㹪ǧҷӧҹ */
										this.OT_Before = shDateIn.subForHour(otst);
									}
								}else{ /*ͷյʹ¡лѹӧҹ */
									if(mDateOut.afterEqualsDateTime(shDateIn)){ /* ٴ͡ѧԡҹ */
										this.OT_Before = shDateIn.subForHour(mDateIn);
									}else{ /* ٴ͡͹Ἱӧҹ */
										this.OT_Before = mDateOut.subForHour(mDateIn);
									}
								}
							}
						}
					}
				} catch (RemoteException e) {
					e.printStackTrace();
				}
			} else {                
				if (cDateIn.before(mDateIn) && !mDateIn.equalsDateTime(mDateOut)) {
					if (midDayStop.inZone(cDateIn)) {
						this.late = mDateIn.subForHour(midDayStop.getEndZone());
					} else {
						// 㹪ǧѡѧѡ (Ҵҹǧ) ͧҾѡѡ͡ С¨Ѻѡ§
						float _lt_nd_time = 0.0f;
						if(mDateIn.afterEquals(midDayStop.en)){ // ҧҹѧشѡ§ ͧѡ͡ӹǹ . ѡ§
							this.late = midDayStop.bg.subForHour(cDateIn); // ӹǹ . ӧҹǧá
							_lt_nd_time = mDateIn.subForHour(midDayStop.en); // ӹǹ . Ҵҹ Ѻ鹷ҧҹǧѧ
							
							CscTime _tmp = new CscTime(this.late);
							_tmp.add(_lt_nd_time); // ٴѧҧҹǧ ͧǡ´
							this.late = _tmp.getFloat();
						} else if(mDateIn.after(midDayStop.bg) && mDateIn.before(midDayStop.en)) { // 㹪ǧѡ§, . ¡ҡѺ ӹǹ . ӧҹá
							this.late = mDateIn.subForHour(midDayStop.bg); // ӹǹ . ӧҹǧá
						} else { // ҧҹѧһ ͹ѡ§
							this.late = mDateIn.subForHour(cDateIn);
						}
					}		
					//ա OT ͧ͹   ҹ  ԧ
				    // ҷ OT ҷӧҹ  set  = 0
					//ͧ ҷ OT 
					if((docType.equalsIgnoreCase("O") || 
							docType.equalsIgnoreCase("B") || 
							docType.equalsIgnoreCase("OM")) && 
							shDateIn.after(cDateIn)){
						
						if(mDateIn.before(shDateIn)|| mDateIn.equals(shDateIn)){
							this.late = 0;	
						}else{
							this.late = mDateIn.subForHour(shDateIn);
						}
					}//end if 
					
				}		
			}
			
			if(OT_COUNT == 0){
				if(docType.equals("O") || docType.equals("OM") || docType.equals("B")){
					try {
						if(type.startsWith("O") && time1 != null && time1.getCscCalendar("sh_dt_bg").equalsDate(cDateIn)){	/* 繡ͧѺл ͹л ѹǡѹ */
							if(cDateOut.beforeDateTime(shDateIn)){
								this.OT_Before = cDateOut.subForHour(cDateIn);
							}
						}else{	/* ѹǡѺ date_actual ͷա͹ */
							this.OT_Before = 0;
							//this.OT_Before = shDateIn.subForHour(cDateIn);
						}
					} catch (RemoteException e) {
						e.printStackTrace();
					}
				}
			}
		}
		
		if (mDateOut!=null) {			
			//if (oDateOut.after(mDateOut)) {
			/* modified 24-07-2014 Ѻ͹䢤ӹǳͷѧ */
			try{
				CscCalendar zst = null , zen = null;
				if(cDateOut.afterDateTime(shDateOut)){
					//this.absentOut = oDateOut.subForHour(mDateOut);
					//if (mDateOut.before(cDateOut)) {
					/* ӹǹ͡͹ ੾ٴѵ͡͹÷ӧҹҹ ͷѧ */
					if (mDateOut.before(shDateOut)) {
						this.absentOut = getActualWorkHour(this, mDateOut, shDateOut, shDateOut.subForHour(mDateOut));
					}
					zen = shDateOut;
				}else{
					if (mDateOut.before(cDateOut)) {
						this.absentOut = getActualWorkHour(this, mDateOut, cDateOut, cDateOut.subForHour(mDateOut));
					}
					zen = cDateOut;
				}
				//if(this.time1 != null && (this.time1.getString("forget_in").equals("1") || this.time1.getString("forget_out").equals("1") || mDateIn.equalsDateTime(mDateOut)) ){
				if(this.time1 != null && mDateIn != null && mDateOut != null 
						&& (this.time1.getString("forget_in").equals("1") || this.time1.getString("forget_out").equals("1") || mDateIn.equalsDateTime(mDateOut)) ){
					if( cDateIn.beforeDateTime(shDateIn)){
						zst = shDateIn;
					}else{
						zst = cDateIn;
					}
					this.absentOut = getActualWorkHour(this, zst, zen, zen.subForHour(zst));
				}
			}catch(Exception e){
				MyLog.error(this ,e);
			}

			CscCalendar ost = (cDateIn.afterEqualsDateTime(mDateIn))?cDateIn:mDateIn;
			CscCalendar oen = (cDateOut.beforeEqualsDateTime(mDateOut))?cDateOut:mDateOut;
			
			/* ӹǳͷ after */
			if(OT_COUNT == 0){	/* ͹ѵ */
				if(docType.equals("O") || docType.equals("OM") || docType.equals("B")){
					if(type.startsWith("O")){	/* 繡ͧѺл */
						try {
							/* ͷѧ ͧѧл ѹǡѺл  */
							if(time1 != null && cDateOut.afterDateTime(shDateOut) && time1.getCscCalendar("sh_dt_bg").equalsDate(cDateIn)){
								this.OT_After = deductBreak(cDateOut.subForHour(cDateIn), shiftProperty, cDateIn, cDateOut, shDateIn, shDateOut);
							}else if(time1 != null && cDateIn.afterEqualsDateTime(shDateIn) && cDateOut.afterDateTime(shDateOut)){
								CscCalendar otst = new CscCalendar(cDateIn.getTime());
								CscCalendar oten = new CscCalendar(cDateOut.getTime());
								
								this.OT_After = oten.subForHour(otst);
								
								this.OT_After = deductBreak(this.OT_After, shiftProperty, cDateIn, cDateOut, shDateIn, shDateOut);
							}else{
								this.OT_After = 0;
							}
						} catch (RemoteException e) {
							e.printStackTrace();
						}
					}else{
						this.OT_After = deductBreak(cDateOut.subForHour(shDateOut), shiftProperty, cDateIn, cDateOut, shDateIn, shDateOut);
					}
				}
			}else if(OT_COUNT == 1){	/* ٴѵ */
				if(docType.equals("O") || docType.equals("OM") || docType.equals("B")){
					if(type.startsWith("O")){	/* 繡ͧѺл */
						try {
							/* ͷѧ ͧѧл ѹǡѺл  */
							if(time1 != null && cDateOut.afterDateTime(shDateOut) && time1.getCscCalendar("sh_dt_bg").equalsDate(cDateIn)){
								//this.OT_After = deductBreak(mDateOut.subForHour(mDateIn), shiftProperty, cDateIn, cDateOut, shDateIn, shDateOut);
								this.OT_After = deductBreak(oen.subForHour(ost), shiftProperty, cDateIn, cDateOut, shDateIn, shDateOut);
							}else if(time1 != null && cDateIn.afterEqualsDateTime(shDateIn) && cDateOut.afterDateTime(shDateOut)){
								CscCalendar otst = new CscCalendar(mDateIn.getTime());
								CscCalendar oten = new CscCalendar(mDateOut.getTime());
								
								this.OT_After = oten.subForHour(otst);
								
								this.OT_After = deductBreak(this.OT_After, shiftProperty, cDateIn, cDateOut, shDateIn, shDateOut);
							}else{
								this.OT_After = 0;
							}
						} catch (RemoteException e) {
							e.printStackTrace();
						}
					}else{
						this.OT_After = deductBreak(mDateOut.subForHour(shDateOut), shiftProperty, cDateIn, cDateOut, shDateIn, shDateOut);
					}
				}
			}else{	/* кѺ */
				if(docType.equals("O") || docType.equals("OM") || docType.equals("B")){
					if(type.startsWith("O")){	/* 繡ͧѺл */
						try {
							CscCalendar otst = new CscCalendar((mDateIn.beforeDateTime(cDateIn))
									?cDateIn.getTime():mDateIn.getTime());
							CscCalendar oten = new CscCalendar((mDateOut.afterDateTime(cDateOut))
									?cDateOut.getTime():mDateOut.getTime());
							
							/* ͷѧ ͧѧл ѹǡѺл  */
							if(time1 != null && cDateOut.afterEqualsDateTime(shDateOut) && time1.getCscCalendar("sh_dt_bg").equalsDate(cDateIn)){
								if( time1.getString("eventgrp").equals("O") ){
									if(otst.afterEqualsDateTime(shDateOut)){
										this.OT_After = oten.subForHour(otst);
									}else if(otst.beforeDateTime(shDateOut)){
										this.OT_After = oten.subForHour(shDateOut);
									}
									
									this.OT_After = deductBreak(this.OT_After, shiftProperty, cDateIn, cDateOut, shDateIn, shDateOut);
								} else if(time1 != null && (time1.getString("eventgrp").equals("H") || time1.getString("eventgrp").equals("I"))
										&& hasOTRequest(time1)){
									
									if(otst.afterEqualsDateTime(shDateOut)){
										this.OT_After = oten.subForHour(otst);
									}else if(otst.beforeDateTime(shDateOut)){
										this.OT_After = oten.subForHour(shDateOut);
									}
								}else{
									if(mDateOut.after(cDateOut)){ /* ٴ͡ѧἹͷ */
										this.OT_After = deductBreak(cDateOut.subForHour(shDateOut), shiftProperty, cDateIn, cDateOut, shDateIn, shDateOut);
									}else{	/* ͡͹شἹͷ */
										this.OT_After = deductBreak(mDateOut.subForHour(shDateOut), shiftProperty, cDateIn, cDateOut, shDateIn, shDateOut);
									}
								}
							}else if(time1 != null && cDateIn.afterEqualsDateTime(shDateIn) && cDateOut.afterDateTime(shDateOut)){
								if(otst.afterEqualsDateTime(shDateOut)){
									this.OT_After = oten.subForHour(otst);
								}else if(otst.beforeDateTime(shDateOut)){
									this.OT_After = oten.subForHour(shDateOut);
								}
								
								this.OT_After = deductBreak(this.OT_After, shiftProperty, cDateIn, cDateOut, shDateIn, shDateOut);
							}else{
								this.OT_After = 0;
							}
						} catch (RemoteException e) {
							e.printStackTrace();
						}
					}else{
						if(mDateOut.after(cDateOut)){ /* ٴ͡ѧἹͷ */
							this.OT_After = deductBreak(cDateOut.subForHour(shDateOut), shiftProperty, cDateIn, cDateOut, shDateIn, shDateOut);
						}else{	/* ͡͹شἹͷ */
							this.OT_After = deductBreak(mDateOut.subForHour(shDateOut), shiftProperty, cDateIn, cDateOut, shDateIn, shDateOut);
						}
					}
				}
			}
		}
		
		//繡  OT = 0
		/**
		 * Author : Nuiss
		 * Date : 23/06/2552
		 * Logic : ͧત  ѹ С͹˹ҹѹ  褹ѹ
		 * ʴѹǢͧ ѹ ͧԴ OT 
		 */
		if(mDateIn!=null && shDateIn!=null){
			if (previousShiftType.equalsIgnoreCase("A") &&
				(mDateIn.after(shDateIn)||mDateIn.equals(shDateIn))) {
				this.OT_Before = 0;
			}//end if 
		}//end if 
      
        //硡 Թǧ͹
		if (shiftProperty.get("MAXLATE") != null) {
			float maxlate = Float.valueOf((String) shiftProperty.get("MAXLATE")).floatValue();
			if (maxlate < this.late) {
				//͹
				this.absentIn = this.late;
				this.late = 0;
			}else{
				//ѧ͹
				float maxtmlate = Float.valueOf((String) shiftProperty.get("LATESTICK")).floatValue();
				if (maxtmlate >= this.late) {
					this.actual_late = this.late ; /* 纤 ͹ºѺ͹ */
					this.late = 0;
				} else {
					/* Pae Edit 2005-08-19  ----> 
					 *  շ¹ ͹ǨѺ ҹѺͨҡ͹
					 * 硨ҡ LATE_COUNT  MTIME0
					 * 0 = Not sum from late,Ѻ
					 * 1 = Sum from late,Ѻͨҡ
					 */
					if (shiftProperty.get("LATE_COUNT") != null) {
						String late_count = shiftProperty.get("LATE_COUNT").toString();
						if (late_count.equals("0")) {
							//źҡ Class CscTime ٻͧҹ 60
							float late_tmp = this.late;
							CscTime c = new CscTime(late_tmp);
							c.sub(maxtmlate);
							this.late = c.getFloat();
							if (this.late<0) {
								CscTime c1 = new CscTime(late_tmp);
								c1.sub(maxtmlate);
								this.late = c1.getFloat();
							}
						}
					}
				}
			}
		}
		
		/*
		 * ͷѧҧҹ Թҷ˹㹵ҧ÷ӧҹ
		 */
		if (this.OT_After > 0) {
			if (shiftProperty.containsKey("MIN_OT")) {
				float min_ot = Float.valueOf((String) shiftProperty.get("MIN_OT")).floatValue();
				if (min_ot > this.OT_After) {
					this.OT_After = 0;
				}
			}
			if (shiftProperty.containsKey("MAX_OT")) {
				float max_ot = Float.valueOf((String) shiftProperty.get("MAX_OT")).floatValue();
				if (max_ot < this.OT_After) {
					this.OT_After = max_ot;
				}
			}
		}
		
		/*
		 * ͷա͹ҧҹ Թҷ˹㹵ҧ÷ӧҹ
		 */
		if (this.OT_Before > 0) {
			if (shiftProperty.containsKey("MINOT_B") ) {
				float min_ot = Float.valueOf((String) shiftProperty.get("MINOT_B")).floatValue();
				if (min_ot > this.OT_Before) {
					this.OT_Before = 0;
				}
			}
			if (shiftProperty.containsKey("MAXOT_B")) {
				float max_ot = Float.valueOf((String) shiftProperty.get("MAXOT_B")).floatValue();
				if (max_ot < this.OT_Before) {
					this.OT_Before = max_ot;
				}
			}
		}
						
		/*
		 * Check  FIX_TIME Ẻ˹ 硨ҡ field STICKTM  MTIME0
		 * N - Not interested in both In and Out
		 * I - Interested in entering draw only
		 * O - Interested in leaving draw only
		 * T - Complete the number of hours day
		 * Y - Both in and out time
		 */
		if (shiftProperty.containsKey("STICKTM")) {
			String fix_time = (String) shiftProperty.get("STICKTM");
			if (fix_time.equalsIgnoreCase("N")) {
				this.absentIn = 0;
				this.absentOut = 0;
				this.late = 0;
			} else if (fix_time.equalsIgnoreCase("I")) {
				this.OT_After = 0;
			} else if (fix_time.equalsIgnoreCase("O")) {
				this.late = 0;
				this.OT_Before = 0;
			} else if (fix_time.equalsIgnoreCase("T")) {
				float m_work = 0.0f;
				this.absentOut = 0;	/*  Flex  absentOut */				
				if(mDateOut!=null && mDateIn != null){
					m_work = mDateOut.subForHour(mDateIn);
				}//end if 
				
				float hour_d = Float.parseFloat((String) shiftProperty.get("HOUR_D"));
				if (m_work>=hour_d) {
					this.absentIn = 0;
					this.absentOut = 0;
				}
				
				if(type.indexOf("A") == -1){	/* 繵ͧ ӹǹ . ӧҹ  Ẻӧҹú  19-12-2012 */
					calWorkByFixHour(this);
				}
			}
		}		
		
		//Ҷ mDateOut = mDateIn  OT դ 0
		if (mDateIn!=null && mDateOut!=null && mDateIn.equals(mDateOut)) {
			String fix_time = (String) shiftProperty.get("STICKTM");
			if(!fix_time.equals("N")){	/*  "ʹ㨷͡"  ٴѵ ʴҢҴҹ ٴ  ot */
				this.OT_Before = 0;
				this.OT_After = 0;
			}
		}
		
		//繡 OT Ҵҹդ = 0
		if (type.indexOf("O")>-1 || type.indexOf("H")>-1 || type.indexOf("I")>-1) {
			this.absentIn = 0;
			this.absentOut = 0;
			this.late = 0;
		}
	}	

	/* ӹǳҨӹǹ . ӧҹҡٴѵ ѡ . ѡ͡ */
	private float getActualWorkHour(DayCalculation day, CscCalendar st, CscCalendar en, float hourd){
		CscTime ct = new CscTime();

		try {
			/* ӹǳ . ӧҹ ִҡٴ͡ѡ (èѺٴѵẺ ӧҹú .  )*/
			ct.add(hourd);
			
			/* ѡѡ§ */
			if(st.beforeEqualsDateTime(day.breakTime.getBeginZone()) && en.afterEqualsDateTime(day.breakTime.getEndZone())){
				ct.sub(day.breakTime.getEndZone().subForHour(day.breakTime.getBeginZone()));
			}else if(st.beforeDateTime(day.breakTime.getBeginZone()) && (en.afterDateTime(day.breakTime.getBeginZone()) && en.beforeEqualsDateTime(day.breakTime.getEndZone()))){
				ct.sub(en.subForHour(day.breakTime.getBeginZone()));
			}else if((st.afterEqualsDateTime(day.breakTime.getBeginZone()) && st.beforeDateTime(day.breakTime.getEndZone()))&& en.afterEqualsDate(day.breakTime.getEndZone())){
				ct.sub(day.breakTime.getEndZone().subForHour(st));
			}else if((st.afterEqualsDateTime(day.breakTime.getBeginZone())&&st.beforeDateTime(day.breakTime.getEndZone()))
					&&(en.afterDateTime(day.breakTime.getBeginZone())&&en.beforeEqualsDateTime(day.breakTime.getEndZone()))){
				ct.sub(en.subForHour(st));
			}
			
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return ct.getFloat();
	}
	
	/* ûżẺӧҹú . ˹ */
	private void calWorkByFixHour(DayCalculation day){
		try {
			day.calLateByFixHour(day);
			day.calOTBeforeByFixHour(day);
			day.calOTAfterByFixHour(day);
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	/* ӹǳ ͧûżẺ ӧҹú . ˹ */
	private void calLateByFixHour(DayCalculation day){
		try {
			/* ˹٧ش ¤Դҡ Ἱ ǡ . ͹ */
			CscCalendar maxLateTime = new CscCalendar(day.cTimeIn.getYYYYMMDD());
			maxLateTime.setCSCTime(day.cTimeIn.getCSCTime());
			maxLateTime.incTime(Float.parseFloat((String)day.shiftPro.get("LATESTICK")));
			
			/* ˹ҢҴҹ óն͹ */
			CscCalendar absentTime = new CscCalendar(day.cTimeIn.getYYYYMMDD());
			absentTime.setCSCTime(day.cTimeIn.getCSCTime());
			absentTime.incTime(Float.parseFloat((String)day.shiftPro.get("MAXLATE")));
			absentTime.incTime(0.01f);	/* ѺҴҹ ҡ٧ش   ٧ٴ 2.00 ҧҹ 7.00 ʴҨйѺҴҹ  9.01 繵 */
			
			/* ٴҡ ٧ش ͹˹ҢҴҹ ٴҵ źҷ˹٧ش */
			if(day.mTimeIn.after(maxLateTime) && day.mTimeIn.beforeDateTime(absentTime)){
				day.late = mTimeIn.subForHour(day.cTimeIn);
			}else if(day.mTimeIn.afterEqualsDateTime(absentTime) ){ /* óٴԹ˹ҢҴҹ ¨դ ʶҹШ繢Ҵҹ᷹ */
				day.late = 0; /* ˹ 0 */
				if(day.mTimeIn.afterEqualsDateTime(day.breakTime.getBeginZone()) && day.mTimeIn.beforeEqualsDateTime(day.breakTime.getEndZone())){ /* ٴ㹪ǧѡ§ Դ . Ҵҹ੾Ъǧ */
					day.absentIn = day.breakTime.getBeginZone().subForHour(day.cTimeIn); /* ˹ . Ҵҹ */
				}else{
					day.absentIn = day.mTimeIn.subForHour(day.cTimeIn); /* ˹ . Ҵҹ */
				}
			}else{
				day.late = 0; //㹡óٴһ   
			}
			
			// . ӧҹӹǳҡٴѵ ֧ӹǹ . ӧҹѹ Ѻ繢Ҵҹ  礨ҡ  - ͡ ͧἹѺ 
			//  Ἱ 8.30 - 18.00  1 .  
			// Ἱ¹ 8.30 - 17.00 ӧҹ  17.00 - 18.00  
			// ѧ . ӧҹͧй  17.00 - 8.30 = 7.30 .  8.30
			/* hour_d */
			float hourd = 0;
			if(day.mTimeIn != null && day.mTimeOut != null){
				hourd = day.mTimeOut.subForHour(day.mTimeIn);
			}
			
			float hours = 0;
			if(day.shiftPro != null && day.shiftPro.containsKey("HOUR_D")){
				hours = Float.parseFloat(day.shiftPro.get("HOUR_D").toString());
			}else{
				if(this.time1 != null){
					CscCalendar sh_bg = new CscCalendar(this.time1.getString("sh_dt_bg"));
					sh_bg.setCSCTime(this.time1.getDouble("sh_tm_bg"));
					CscCalendar sh_en = new CscCalendar(this.time1.getString("sh_dt_en"));
					sh_en.setCSCTime(this.time1.getDouble("sh_tm_en"));
					hours = sh_en.subForHour(sh_bg);
				}else{
					hours = day.cTimeOut.subForHour(day.cTimeIn);
				}
				
			}
			
			CscTime actual_hourd = new CscTime(hourd);
			if( day.breakTime != null ){
				MyTimeZone tzC = new MyTimeZone(day.cTimeIn,day.cTimeOut);
				actual_hourd.sub(tzC.getDiffIntersectZone(new MyTimeZone( day.breakTime.getBeginZone() , day.breakTime.getEndZone() )));
			}
			
			//actual_hourd.sub(day.breakTime.getEndZone().subForHour(day.breakTime.getBeginZone()));	// ѧͧѡѡ ѡ ͹ѹ
			//actual_hourd.add(day.late);	/* . ӧҹ ͧ . 仴 */
			
			CscTime actual_hours = new CscTime(hours);
			//actual_hours.sub(day.breakTime.getEndZone().subForHour(day.breakTime.getBeginZone()));
			
			hour_s = actual_hours.getFloat();
			hour_d = actual_hourd.getFloat();
			
			/* óա˹ӹǳ. ӧҹ "ҧ÷ӧҹ"  hour_d Թ hour_s */
			if(day.shiftPro != null && day.shiftPro.containsKey("HOUR_COUNT")){
				String hrc = (String) day.shiftPro.get("HOUR_COUNT");
				if(hrc.equals("0") && hour_d > hour_s){
					hour_d = hour_s ;
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	/* ӹǳͷա͹ */
	private void calOTBeforeByFixHour(DayCalculation day){
		/* ˹ͷա͹ 0 СûżẺӧҹú . Դͷա͹ */
		try {
			if(day.time1 != null){
				if(day.time1.getString("eventgrp").equals("O") 
						|| day.time1.getString("eventgrp").equals("H")
						|| day.time1.getString("eventgrp").equals("I")) {
					if(day.OT_Before > 0){
						if(day.OT_Before > day.time1.getFloat("ap_ot")){
							day.OT_Before = day.time1.getFloat("ap_ot");
						}
					}
				}else if(day.time1.getString("eventgrp").equals("T")) {
					day.OT_Before = 0;
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	/* ӹǳҨӹǹ . ӧҹҡٴѵ ѡ . ѡ͡ */
	private void setActualWorkHour(DayCalculation day){
		CscTime ct = new CscTime();
		CscCalendar st ;
		CscCalendar en ;

		try {
			/* ӹǳ . ӧҹ ִҡٴ͡ѡ (èѺٴѵẺ ӧҹú .  )*/
			if(this.mTimeOut != null){
				ct.add(this.mTimeOut.subForHour(this.mTimeIn));
				
				/* ѡѡ§ */
				if(this.mTimeIn.beforeEqualsDateTime(day.breakTime.getBeginZone()) && this.mTimeOut.afterEqualsDateTime(day.breakTime.getEndZone())){
					ct.sub(day.breakTime.getEndZone().subForHour(day.breakTime.getBeginZone()));
				}else if(this.mTimeIn.beforeDateTime(day.breakTime.getBeginZone()) && (this.mTimeOut.afterDateTime(day.breakTime.getBeginZone()) && this.mTimeOut.beforeEqualsDateTime(day.breakTime.getEndZone()))){
					ct.sub(this.mTimeOut.subForHour(day.breakTime.getBeginZone()));
				}else if((this.mTimeIn.afterEqualsDateTime(day.breakTime.getBeginZone()) && this.mTimeIn.beforeDateTime(day.breakTime.getEndZone()))&& this.mTimeOut.afterEqualsDate(day.breakTime.getEndZone())){
					ct.sub(day.breakTime.getEndZone().subForHour(this.mTimeIn));
				}else if((this.mTimeIn.afterEqualsDateTime(day.breakTime.getBeginZone())&&this.mTimeIn.beforeDateTime(day.breakTime.getEndZone()))
						&&(this.mTimeOut.afterDateTime(day.breakTime.getBeginZone())&&this.mTimeOut.beforeEqualsDateTime(day.breakTime.getEndZone()))){
					ct.sub(this.mTimeOut.subForHour(this.mTimeIn));
				}
			}
			
			this.actualWorkHour = ct.getFloat();
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	/* ӹǳͷѧ */
	private void calOTAfterByFixHour(DayCalculation day){
		try {
			setActualWorkHour(day); /*  . ӧҹҡٴѵ */

			if(this.time1 != null && ("'OM','O','B'".indexOf("'"+this.time1.getString("DOCTYPE")+"'") > -1)){	/* ੾ͷҹ鹨֧Фӹǳ  */
				if(this.time1 != null && (this.time1.getString("EVENTGRP").equals("O")
						||this.time1.getString("EVENTGRP").equals("H")
						||this.time1.getString("EVENTGRP").equals("I"))) { /*ѹش . ͷѧҡѺӹǹ . ӧҹѹ ź 8 . */
					
					CscTime ct = new CscTime();
					CscCalendar st = (day.cTimeIn.afterDateTime(day.mTimeIn))?day.cTimeIn:day.mTimeIn;
					CscCalendar en = (day.cTimeOut.beforeDateTime(day.mTimeOut))?day.cTimeOut:day.mTimeOut;
					
					ct.add(en.subForHour(st));
					
					float hourd = Float.valueOf((String) this.shiftPro.get("HOUR_D")).floatValue();
					CscCalendar bkin = this.time1.getCscCalendar("dt_breakin");
					bkin.setCSCTime(this.time1.getFloat("tm_breakin"));
					
					CscCalendar bkout = this.time1.getCscCalendar("dt_breakout");
					bkout.setCSCTime(this.time1.getFloat("tm_breakout"));
					
					if(day.time1.getString("eventgrp").equals("O")){
						if(day.OT_After > 0){
							if(day.OT_After > day.time1.getFloat("ap_ot")){
								day.OT_After = day.time1.getFloat("ap_ot");
							}else{
								day.OT_After = ct.getFloat();
							}
						}
					}else{
						if(day.OT_After > 0 && (time1.getString("eventgrp").equals("H") || time1.getString("eventgrp").equals("I"))){
							if(ct.getFloat() > hourd){
								ct.sub(hourd);	/* ѡ . ӧҹѹ (ѡ) */
								ct.sub(bkout.subForHour(bkin));	/* ǡѡ§ */
								
								/* deduct break before ot */
								float stp_ot = Float.valueOf((String) this.shiftPro.get("STP_OT")).floatValue();
								if(ct.getFloat() > stp_ot){
									ct.sub(stp_ot);
								}
								
								day.OT_After = ct.getFloat();
								if(day.OT_After < 0){
									day.OT_After = 0 ;
								}else if(day.OT_After > day.time1.getFloat("ap_ot")){
									day.OT_After = day.time1.getFloat("ap_ot");
								}
							}
						}
					}
				}else{	/* ѹ ӹǹ . ͷѧ еͧ . Թ . ӧҹѹ */
					if(this.actualWorkHour > this.workHour){
						float stp_ot = Float.valueOf((String) this.shiftPro.get("STP_OT")).floatValue();
						
						CscTime ct = new CscTime();
						ct.add(this.actualWorkHour);
						ct.sub(this.workHour);
						
						if (ct.getFloat() >= stp_ot) {
							ct.sub(stp_ot);
							day.OT_After = ct.getFloat();
						} else {
							day.OT_After = 0;
						}
					}else{
						day.OT_After = 0;
					}
				}
			}else{
				day.OT_After = 0;
			}
			
			if(day.OT_After > 0 && day.OT_After > day.time1.getFloat("ap_ot")){
				day.OT_After = day.time1.getFloat("ap_ot");
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	public float getOT_Before() {
		if (this.OT_Before<0) 
			return 0;
		else return this.OT_Before;
	}

	public float getOT_After() {
		if (this.OT_After<0) 
			return 0;
		else return this.OT_After;
	}

	public float getOT_All() {
		CscTime t = new CscTime(0);
		if (this.OT_After>0) {
			t.add(this.getOT_After());
		}
		if (this.getOT_Before()>0) {
			t.add(this.getOT_Before());
		}
		return t.getFloat();
	}

	public float getLate() {
		return this.late;
	}

	public float getAbsentIn() {
		return this.absentIn;
	}

	public float getAbsentOut() {
		return this.absentOut;
	}

	public float getAbsentAll() {
		CscTime t = new CscTime(this.absentIn);
		t.add(this.absentOut);
		return t.getFloat();
	}

	public CscTime getCscTimeOT_Before() {
		if (this.OT_Before<0) 
			return new CscTime(0);
		else return new CscTime(this.OT_Before);
	}

	public CscTime getCscTimeOT_After() {
		if (this.OT_After<0) 
			return new CscTime(0);
		else return new CscTime(this.OT_After);
	}

	public CscTime getCscTimeOT_All() {
		CscTime t = new CscTime(0);
		if (this.OT_After>0) {
			t.add(this.getOT_After());
		}
		if (this.getOT_Before()>0) {
			t.add(this.getOT_Before());
		}
		return t;
	}

	public CscTime getCscTimeLate() {
		return new CscTime(this.late);
	}

	public CscTime getCscTimeAbsentIn() {
		return new CscTime(this.absentIn);
	}

	public CscTime getCscTimeAbsentOut() {
		return new CscTime(this.absentOut);
	}

	public CscTime getCscTimeAbsentAll() {
		CscTime t = new CscTime(this.absentIn);
		t.add(this.absentOut);
		return t;
	}

	public float getHourD(){
		return hour_d;
	}
	
	public float getHourS(){
		return hour_s;
	}
	
	public float getWorkingHour(){
		return this.workHour;
	}
	
	
	private float deductBreak(float ot_after, HashMap shiftProperty, CscCalendar cscstart, CscCalendar cscend, CscCalendar csshstart, CscCalendar  csshend){
		try {
			float stp_ot = Float.valueOf((String) shiftProperty.get("STP_OT")).floatValue();
			
			if (cscstart.beforeEqualsDateTime(csshend) && cscend.afterDateTime(csshend)) {
				if (ot_after >= stp_ot) {
					CscTime c2 = new CscTime(ot_after);
					c2.sub(stp_ot);
					ot_after = c2.getFloat();
				} else {
					ot_after = 0;
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return ot_after ;
	}
	
	public float getActualLate(){
		return this.actual_late ;
	}
	
	private boolean hasOTRequest(DbRecord tcur1){
		try{
			return (tcur1.getString("doctype").equals("O") || tcur1.getString("doctype").equals("OM") || tcur1.getString("doctype").equals("B"));
		}catch(Exception e){
			MyLog.error(this,e);
		}
		return false ;
	}
}