package com.csc.library.timeattendance;

import java.text.DecimalFormat;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;

import com.csc.library.utilities.CscTime;
import com.csc.library.utilities.MyLog;
import com.csc.library.utility.DHMConvert;

public class LeaveStatManager {
	private Vector allLeave = new Vector(); 	/* ʹҷ Ϳਡ LeaveItems */
	private HashMap hm = new HashMap(); /* ʹ繪.  . ӧҹѹ*/
	private float curHour_d = 0f; 		/* . ӧҹѹͧлѨغѹ */
	private String leaveStat = "00:00:00"; /* ʹ */
	
	public LeaveStatManager(){
		
	}

	private void setLeaveStatValue(String stat){
		this.leaveStat = stat;
	}
	
	public String getLeaveStat(){
		return this.leaveStat;
	}
	
	public int getRecCount(){
		return this.allLeave.size();
	}
	
	/* ֧ . ӧҹѹ ͧѹӧҹ ش */
	private float getCurHourDay(){
		if(this.allLeave != null && this.allLeave.size() > 0){
			LeaveItems lt ;
			lt = (LeaveItems)this.allLeave.get(0);
			return lt.getDayHour();
		}else{
			return 0;
		}
	}
	
	/*  .   . ӧҹѹ  Vector ͹Ҥӹǳʹ . ѧ */
	public void addItem(float hour,float dayhour){
		allLeave.add(new LeaveItems(hour,dayhour));
	}
	 
	/* ¡ .   . ӧҹѹ . ¡ҷ . зӧҹѹ 8 .  8.40 . ͡ҡѹ 繵 */
	public void allocateLeaveHour(){
		LeaveItems lt = null;
		
		try {
			/* ֧š͡¡纵 . ӧҹѹ */
			for(int i=0; i < allLeave.size(); i++){
				lt = (LeaveItems)allLeave.get(i);
				
				/*  ֧͡ӹǹ .  ա */
				if(hm.containsKey(lt.getDayHour())){
					float leave = (Float) hm.get(lt.getDayHour());
					CscTime ct = new CscTime();
					ct.add(leave);
					ct.add(lt.getHour());
					hm.put(lt.getDayHour(), ct.getFloat());
				}else{
					hm.put(lt.getDayHour(), lt.getHour());
				}
			}
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	/* ʹ ¨ʹͧ . ӧҹѹ ǹ  ͹ ѹ  . ӧҹͧлѨغѹ ӹǳ ѹ . ҷ */
	public void sumLeaveHour(){
		int day = 0;
		int hour = 0;
		int min = 0;
		float keyHour = 0;
		
		String dhmValue = "00:00:00";
		String dhmItems[] ;
		DecimalFormat df = new DecimalFormat("00");
		try {
			Iterator iterator = hm.keySet().iterator();
			/* ʹ ͧ˹ (ѹ . ҷ) */
			while(iterator.hasNext()){        
	        	keyHour = (Float)iterator.next();	/*  . ӧҹѹ */
	        	
	        	/*  .  Ҥӹǳ ѹ . ҷ*/
	        	DHMConvert dhm = new DHMConvert((Float)hm.get(keyHour),keyHour);
	        	dhmValue = dhm.parseDHM();
	        	dhmItems = dhmValue.split(":");
	        	
	        	/* ӹǹѹöҨ . ӧҹѹ (8,8.4,... 9 . 繵) */
	        	day += Integer.parseInt(dhmItems[0]);
	        	
	        	/* ӹǹ . ͹   . ӧҹѹͧлѨغѹ繵Ǥӹǳ ѹ . ҷ */
	        	hour += Integer.parseInt(dhmItems[1]);
	        	
	        	/* ӹǹ ҷ */
	        	min += Integer.parseInt(dhmItems[2]);
	        }
			
			/* ʹ . ҷ Թ . ӧҹѹ ¡ʹѺ ʹѹ */
			float curHour_d = this.getCurHourDay();
			CscTime ct = new CscTime();
			ct.setHour(hour);
			ct.setMinute(min);
			
			if(ct.getFloat() >= curHour_d){
				day++; /* ӹǹѹ  . ҷ Թ . ӧҹѹ */
				ct.sub(curHour_d);
				hour = ct.getHour();
				min = ct.getMinute();
			}
			
			setLeaveStatValue(df.format(day) + ":" +df.format(hour) + ":" + df.format(min));
		}catch(Exception e){
			MyLog.error(this,e);
		}
	}
	
	 

}
