package com.csc.library.timeinterface;

import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.CscCalendar;
import java.util.Vector;

public interface SwipeRecord {	
	public CscCalendar getDate();
	public float getTime();
	public String getSource(); // T-TimeRecorder, A-Auto, M-Manual, S-SignOn, O-SignOff
	public String getMachineName();
	public String getJobCode();
	public String getTimeCode(); 
	public Vector getReserveCode();
	public long getRecordNo();
	public String getStringRecordNo();
	public String getSwipeType();
	public boolean isReserved();
	public String toString();
}