package com.csc.library.utility;

import std.library.DataTable;

import com.csc.library.session.DbInquiry;
import com.csc.library.session.DbRecord;
import com.csc.library.session.InitialInquiry;
import com.csc.library.session.InitialRecord;
import com.csc.library.utilities.CscCalendar;
import com.csc.library.utilities.MyLog;
import com.csc.library.utilities.UProfile;

public class NAdjustTime {
	public void adjustTadjTime0(UProfile userPro, String argDateid,
												String argEmployeeid, String argCompanyid) {
		/**
		 * Author : Nuiss 
		 * Date : 09/01/2009 
		 * Logic : աҡ 1  ѹǡѹ
		 */
		// ===================== Step1 ====================
		/**
		 * ¡  ,ӧҹ ͡ҡѹ  ǧҷͧҷӧҹԧ
		 */
		String columnName[] = { "employeeid", "companyid", "docid", "docdate",
				"dt_bg", "tm_bg", "updtype", "dt_en", "tm_en" };
		String columnType[] = { "varchar", "varchar", "varchar", "varchar",
				"varchar", "varchar", "varchar", "varchar", "varchar" };
		DataTable T_Type = new DataTable(columnName, columnType);
		DataTable A_Type = new DataTable(columnName, columnType);

		String whereClauseTleave = "doctype ='A' and employeeid= '"
				+ argEmployeeid + "' and dateid = '" + argDateid + "'";
	 	String docIdList = "";
		String time0id = "";
	
		try {
			DbInquiry inqTleave = new InitialInquiry(userPro).getDbInquiry();
			inqTleave.initMyTable("Tleave_summary", whereClauseTleave,"docid ASC");
			inqTleave.setColumn("docid");
			inqTleave.refresh();
	 
			if (inqTleave.recCount() <= 1) {
				// ͧ
				return;
			} else {
				while (inqTleave.next()) {
					if (docIdList.equals("")) {
						docIdList = "'" + inqTleave.getString("docid") + "'";
					} else {
						docIdList += "," + "'" + inqTleave.getString("docid")+ "'";
					}// end if
				}// end while

				String whereClauseTadjtime0 = " employeeid = '" + argEmployeeid
						+ "'" + " and updtype <> 'D' " + " and docid in ("
						+ docIdList + ")";

				DbInquiry inqTadjtime0 = new InitialInquiry(userPro).getDbInquiry();
				inqTadjtime0.initMyTable("Tadjtime0", whereClauseTadjtime0,"updtype ASC");
				inqTadjtime0.setColumn("employeeid,companyid,docid,docdate,dt_bg,tm_bg,updtype,dt_en,tm_en,time0id");
				inqTadjtime0.refresh();

				String updType = "";

				while (inqTadjtime0.next()) {

					updType = inqTadjtime0.getString(columnName[6]);
					time0id = inqTadjtime0.getString("time0id");

					if (updType.trim().equals("T")) {
						// ӧҹ
						if (T_Type.rowCount() == 0) {
							T_Type.insertRow(1);
							for (int colIndex = 0; colIndex < columnName.length; colIndex++) {
								T_Type.setItem(1,columnName[colIndex],inqTadjtime0.getString(columnName[colIndex]));
							}// end for
						} else {
							CscCalendar inqStDateTime = new CscCalendar(inqTadjtime0.getString(columnName[4]));
							inqStDateTime.setCSCTime(Float.valueOf(inqTadjtime0.getString(columnName[5])));

							CscCalendar inqEndDateTime = new CscCalendar(inqTadjtime0.getString(columnName[7]));
							inqEndDateTime.setCSCTime(Float.valueOf(inqTadjtime0.getString(columnName[8])));

							CscCalendar dtbStDateTime = new CscCalendar(T_Type.getItemString(1, columnName[4]));
							dtbStDateTime.setCSCTime(Float.valueOf(T_Type.getItemString(1, columnName[5])));

							CscCalendar dtbEndDateTime = new CscCalendar(T_Type.getItemString(1, columnName[7]));
							dtbEndDateTime.setCSCTime(Float.valueOf(T_Type.getItemString(1, columnName[8])));

							if (dtbStDateTime.afterDateTime(inqStDateTime)) {
								// ѹ-   ¡ ͧ
								T_Type.setItem(1, columnName[4], inqTadjtime0.getString(columnName[4]));
								T_Type.setItem(1, columnName[5], inqTadjtime0.getString(columnName[5]));
							}// end if

							if (inqEndDateTime.afterDateTime(dtbEndDateTime)) {
								// ѹ- ش  ҡ ͧ
								T_Type.setItem(1, columnName[7], inqTadjtime0.getString(columnName[7]));
								T_Type.setItem(1, columnName[8], inqTadjtime0.getString(columnName[8]));
							}// end if

						}// end if
					} else if (updType.trim().equals("A")) {
						// 
						A_Type.insertRow(1);
						for (int colIndex = 0; colIndex < columnName.length; colIndex++) {
							A_Type.setItem(A_Type.rowCount(),columnName[colIndex], inqTadjtime0.getString(columnName[colIndex]));
						}// end for
					}// end if
				}// end while

				// =====================Step 1.5 ========================
				/**
				 * ͧҾѡ§ A_Type
				 * ѹҨѹ ͧҷӧҹ ?
				 */
				CscCalendar leaveDate = new CscCalendar(argDateid);
				CscCalendar leaveStDate = new CscCalendar(argDateid);
				CscCalendar leaveEndDate = new CscCalendar(argDateid);
				int dayOfWeek = leaveDate.getCSCDOW();

				String whereClauseMtime1 = "time0id = '" + time0id + "'"
						+ " and companyid = '" + argCompanyid + "'"
						+ " and dayweekid = '" + dayOfWeek + "'";

				DbInquiry inqMtime1 = new InitialInquiry(userPro).getDbInquiry();
				inqMtime1.initMyTable("Mtime1", whereClauseMtime1, "");
				inqMtime1.setColumn("timein1,timeout1,timein2");
				inqMtime1.refresh();
				if (inqMtime1.next()) {
					// ================== get
					if (Float.parseFloat(inqMtime1.getString("timeout1")) < Float.parseFloat(inqMtime1.getString("timein1"))) {
						leaveStDate.incDate(1);
					}// end if
					if (Float.parseFloat(inqMtime1.getString("timein2")) < Float.parseFloat(inqMtime1.getString("timein1"))) {
						leaveEndDate.incDate(1);
					}// end if
					// ================== set
					A_Type.insertRow(1);
					A_Type.setItem(A_Type.rowCount(), columnName[0],argEmployeeid);
					A_Type.setItem(A_Type.rowCount(), columnName[1],argCompanyid);
					A_Type.setItem(A_Type.rowCount(), columnName[2],"LogicLeave");
					A_Type.setItem(A_Type.rowCount(), columnName[3], leaveDate.getYYYYMMDD());
					A_Type.setItem(A_Type.rowCount(), columnName[4],leaveStDate.getYYYYMMDD());
					A_Type.setItem(A_Type.rowCount(), columnName[5], inqMtime1.getString("timeout1"));
					A_Type.setItem(A_Type.rowCount(), columnName[6], "A");
					A_Type.setItem(A_Type.rowCount(), columnName[7],leaveEndDate.getYYYYMMDD());
					A_Type.setItem(A_Type.rowCount(), columnName[8], inqMtime1.getString("timein2"));
				}// end if
				// ===================================================

			}// end if
		} catch (Exception ex) {
			MyLog.error("error in Step 1 Tadjtime0.adjustTadjTime0() By Nuiss Code..."
							+ "\n" + ex.getStackTrace().toString());
		}// end try

		// ===================== Step2 ====================
		/**
		 * Ҫǧ ź ͡ҡ ǧҷͧӧҹԧ 
		 *  ҧ ǧ 
		 */
		try {
			CscCalendar AStDateTime;
			CscCalendar AEndDateTime;
			CscCalendar TStDateTime;
			CscCalendar TEndDateTime;

			for (int rowA = 1; rowA <= A_Type.rowCount(); rowA++) {
				AStDateTime = new CscCalendar(A_Type.getItemString(rowA,columnName[4]));
				AStDateTime.setCSCTime(Float.valueOf(A_Type.getItemString(rowA,columnName[5])));
				AEndDateTime = new CscCalendar(A_Type.getItemString(rowA,columnName[7]));
				AEndDateTime.setCSCTime(Float.valueOf(A_Type.getItemString(rowA, columnName[8])));

				for (int rowT = 1; rowT <= T_Type.rowCount(); rowT++) {
					TStDateTime = new CscCalendar(T_Type.getItemString(rowT,columnName[4]));
					TStDateTime.setCSCTime(Float.valueOf(T_Type.getItemString(rowT, columnName[5])));
					TEndDateTime = new CscCalendar(T_Type.getItemString(rowT,columnName[7]));
					TEndDateTime.setCSCTime(Float.valueOf(T_Type.getItemString(rowT, columnName[8])));
					/**
					 * equalsDateTime sign is : == beforeDateTime sign is : <
					 * afterDateTime sign is : >
					 */
					if (AStDateTime.equalsDateTime(TStDateTime)&& AEndDateTime.equalsDateTime(TEndDateTime)) {
						// AStDateTime == TStDateTime && AStDateTime == TEndDateTime
						// ҡѹ駪ǧ delete row ͡ҡ DataTable 
						T_Type.deleteRow(rowT);
					} else if (AStDateTime.equalsDateTime(TStDateTime)&& AEndDateTime.beforeDateTime(TEndDateTime)) {
						// AStDateTime == TStDateTime && AEndDateTime < TEndDateTime
						// ҡѹǧ ¡Ҫǧش
						T_Type.setItem(rowT, columnName[4], A_Type.getItemString(rowA, columnName[7]));
						T_Type.setItem(rowT, columnName[5], A_Type.getItemString(rowA, columnName[8]));

						T_Type.setItem(rowT, columnName[7], T_Type.getItemString(rowT, columnName[7]));
						T_Type.setItem(rowT, columnName[8], T_Type.getItemString(rowT, columnName[8]));
					} else if (AStDateTime.afterDateTime(TStDateTime)&& AEndDateTime.beforeDateTime(TEndDateTime)) {
						// AStDateTime > TStDateTime && AEndDateTime < TEndDateTime
						// ==========================================================
						// ҡ  ǧҾѡ (LogicLeave) ҧͧ
						//  case  ͧ 蹪ǧ ѡ
						if (A_Type.getItemString(rowA, columnName[2]).equals("LogicLeave")) {
							break;
						}// end if
						// ==========================================================
						// ҧǧ ͧ ¡ǧ͡
						T_Type.insertRow(1);

						// ǧá row 
						// set ѹ- 鹢ͧ T_Type row  
						// ѹ- 鹢ͧ T_Type row 
						T_Type.setItem(rowT, columnName[4], T_Type.getItemString(rowT, columnName[4]));
						T_Type.setItem(rowT, columnName[5], T_Type.getItemString(rowT, columnName[5]));

						// ǧѴ价١¡͡ row 
						// set ѹ- شͧ T_Type row   ѹ-
						// شͧ T_Type row 
						//  set ͹ Ǥѹж١¹ 
						// code 2 ÷Ѵҹҧ
						T_Type.setItem(T_Type.rowCount(), columnName[7], T_Type.getItemString(rowT, columnName[7]));
						T_Type.setItem(T_Type.rowCount(), columnName[8], T_Type.getItemString(rowT, columnName[8]));

						// ǧá row 
						// set ѹ- شͧ T_Type row   ѹ-
						// 鹢ͧ A_Type
						T_Type.setItem(rowT, columnName[7], A_Type.getItemString(rowA, columnName[4]));
						T_Type.setItem(rowT, columnName[8], A_Type.getItemString(rowA, columnName[5]));

						// ǧѴ价١¡͡ row 
						// set ѹ- 鹢ͧ T_Type row  
						// ѹ- شͧ A_Type
						T_Type.setItem(T_Type.rowCount(), columnName[4], A_Type.getItemString(rowA, columnName[7]));
						T_Type.setItem(T_Type.rowCount(), columnName[5], A_Type.getItemString(rowA, columnName[8]));

						//  ͧ T_Type row    T_Type
						// row 
						T_Type.setItem(T_Type.rowCount(), columnName[0], T_Type.getItemString(rowT, columnName[0]));
						T_Type.setItem(T_Type.rowCount(), columnName[1], T_Type.getItemString(rowT, columnName[1]));
						T_Type.setItem(T_Type.rowCount(), columnName[2], T_Type.getItemString(rowT, columnName[2]));
						T_Type.setItem(T_Type.rowCount(), columnName[3], T_Type.getItemString(rowT, columnName[3]));
						T_Type.setItem(T_Type.rowCount(), columnName[6], T_Type.getItemString(rowT, columnName[6]));

						break;
					} else if (AStDateTime.afterDateTime(TStDateTime)&& AEndDateTime.equalsDateTime(TEndDateTime)) {
						// AStDateTime > TStDateTime && AEndDateTime == TEndDateTime
						// ҡҪǧ ҡѹǧش
						T_Type.setItem(rowT, columnName[4], T_Type.getItemString(rowT, columnName[4]));
						T_Type.setItem(rowT, columnName[5], T_Type.getItemString(rowT, columnName[5]));

						T_Type.setItem(rowT, columnName[7], A_Type.getItemString(rowA, columnName[4]));
						T_Type.setItem(rowT, columnName[8], A_Type.getItemString(rowA, columnName[5]));

					}// end if
				}// end for rowT

			}// end for rowA
		} catch (Exception ex) {
			MyLog.error("error in Step 2 Tadjtime0.adjustTadjTime0() By Nuiss Code..."
							+ "\n" + ex.getStackTrace().toString());
		}// end try

		// ===================== Step3 ====================
		/**
		 * update data to tadjtime0  data  T_Type PK_Tadjtime0 :
		 * EMPLOYEEID, COMPANYID, DOCID, DOCTYPE, DT_BG, TM_BG, UPDTYPE
		 */
		try {
			String whereClauseTadjtime0 = " employeeid = '" + argEmployeeid
					+ "'" + " and updtype = 'T' " + " and docid in ("+ docIdList + ")";

			DbInquiry inqTadjtime0 = new InitialInquiry(userPro).getDbInquiry();
			inqTadjtime0.initMyTable("Tadjtime0", whereClauseTadjtime0,"docdate ASC,docid ASC,updtype ASC");
			inqTadjtime0.setColumn("*");
			inqTadjtime0.refresh();

			String fields[] = { "EMPLOYEEID", "COMPANYID", "DOCID", "DOCDATE",
					"DOCTYPE", "TIME0ID", "EVENTGRP", "OLDTIME0ID",
					"OLDEVENTGRP", "LV_TY", "LV", "TR_TYPE", "DT_BG", "DT_EN",
					"TM_BG", "TM_EN", "UPDTYPE", "BU1", "BU2", "BU3", "BU4",
					"BU5", "BRANCH", "EMP_GROUP", "EMP_POSITION", "SALATYPE",
					"WORKAREA", "BOSSID", "STATUS", "ADJUSTTEMP", "PRIORITY",
					"MARK", "HOUR_S", "OT_CAUSE", "OT_WORKAREA", "OT_SALATYPE",
					"OT_TYPE", "OT_TIME0","WF_STATUS" };
			String fieldsType[] = { "varchar", "varchar", "varchar", "varchar",
					"varchar", "varchar", "varchar", "varchar", "varchar",
					"varchar", "varchar", "varchar", "varchar", "varchar",
					"varchar", "varchar", "varchar", "varchar", "varchar",
					"varchar", "varchar", "varchar", "varchar", "varchar",
					"varchar", "varchar", "varchar", "varchar", "varchar",
					"varchar", "varchar", "varchar", "varchar", "varchar",
					"varchar", "varchar", "varchar", "varchar" , "varchar"};

			DataTable T_TypeTemp = new DataTable(fields, fieldsType);

			// ================ ź row  updtype = 'T'  ============
			while (inqTadjtime0.next()) {
				DbRecord dbRecord = inqTadjtime0.getCurrentDbRecord().cloneRecord(true);
				if (T_TypeTemp.rowCount() == T_Type.rowCount()) {

				} else {
					T_TypeTemp.insertRow(1);
					for (int colIndex = 0; colIndex < fields.length; colIndex++) {
						T_TypeTemp.setItem(T_TypeTemp.rowCount(),fields[colIndex], inqTadjtime0.getString(fields[colIndex]));
					}// end for
				}// end if
				dbRecord.delete();
			}// end while

			//=============== Step 3.1 ===============================
			//ҧ ѹ generate row data  tadjtime0  updtype ='T' < updtype ='A' 
			//ҧ row  ѹ   ѹ-ҷӧҹ ҧ T_Type  ú
			//Ե row  T_TypeTemp == T_Type  
			if(T_Type.rowCount()>T_TypeTemp.rowCount()){
				int rowInsert =T_Type.rowCount()-T_TypeTemp.rowCount(); 
				T_TypeTemp.insertRow(rowInsert);
				for (int row=T_TypeTemp.rowCount();row<=T_Type.rowCount();row++){
					for (int colIndex = 0; colIndex < fields.length; colIndex++) {
						//ѹ͹ѹء row   data Ҩҡѹͧ
						T_TypeTemp.setItem(T_TypeTemp.rowCount(),fields[colIndex],T_TypeTemp.getItemString(1,fields[colIndex]));
					}// end for
				}//end for 
			}//end if 
			
			// ================ insert row ǧ᷹ ============
			for (int rowS = 1; rowS <= T_TypeTemp.rowCount(); rowS++) {
				if (T_Type.getItemString(rowS, columnName[0]) == null) {
					// ʴ row  ١ź
				} else {
					DbRecord recTadj = new InitialRecord(userPro).getDbRecord("TADJTIME0");

					for (int colIndex = 0; colIndex < fields.length; colIndex++) {
						if (fields[colIndex].equalsIgnoreCase("DT_BG")) {
							recTadj.set(fields[colIndex], T_Type.getItemString(rowS, "dt_bg"));
						} else if (fields[colIndex].equalsIgnoreCase("TM_BG")) {
							recTadj.set(fields[colIndex], T_Type.getItemString(rowS, "tm_bg"));
						} else if (fields[colIndex].equalsIgnoreCase("DT_EN")) {
							recTadj.set(fields[colIndex], T_Type.getItemString(rowS, "dt_en"));
						} else if (fields[colIndex].equalsIgnoreCase("TM_EN")) {
							recTadj.set(fields[colIndex], T_Type.getItemString(rowS, "tm_en"));
						} else if (fields[colIndex].equalsIgnoreCase("LV")) {
							// get
							String inDate = T_Type.getItemString(rowS, "dt_bg");
							float inTime = Float.parseFloat(T_Type.getItemString(rowS, "tm_bg"));
							String outDate = T_Type.getItemString(rowS, "dt_en");
							float outTime = Float.parseFloat(T_Type.getItemString(rowS, "tm_en"));
							// set
							CscCalendar inDateTime = new CscCalendar(inDate);
							inDateTime.setCSCTime(inTime);
							CscCalendar outDateTime = new CscCalendar(outDate);
							outDateTime.setCSCTime(outTime);
							// calculate
							float workHour = outDateTime.subForHour(inDateTime);
							// set
							recTadj.set(fields[colIndex], workHour);
						} else if (fields[colIndex].equalsIgnoreCase("WF_STATUS")) {
							recTadj.set(fields[colIndex], "");
						} else {
							recTadj.set(fields[colIndex], T_TypeTemp.getItemString(rowS, fields[colIndex]));
						}// end if
					}// end for
					recTadj.save();
				}// end if
			}// end rowS

		} catch (Exception ex) {
			MyLog.error("error in Step 3 Tadjtime0.adjustTadjTime0() By Nuiss Code..."
							+ "\n" + ex.getStackTrace().toString());
		}// end try
		// ==============================================		
	}// end method

}//end class NAdjustTime
